{"version":"NotebookV1","origId":3118105296409311,"name":"BatchBuildDimension","language":"python","commands":[{"version":"CommandV1","origId":3118105296409312,"guid":"608e303a-e2da-456b-9229-405d03315a07","subtype":"command","commandType":"auto","position":1.0,"command":"from datetime import timedelta, datetime\nfrom delta.tables import *\nfrom pyspark.sql.functions import *\nfrom pyspark.sql.types import StringType\n\nimport pytz\nimport os #for adding filename to dataframe\nimport re #regular expressions\n\n#Set variables\ndelta_location = \"DELTA\"\noutput_message = ''\ntable_exists = False\ninputValidation = False\nsuccess = False \n\n# Get current EST time with offset to be used for inserted and updated dates\nbatchTime = datetime.now(pytz.timezone('EST'))","commandVersion":321,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353064824,"submitTime":1626353063079,"finishTime":1626353064846,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"3507","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"Imports","showCommandTitle":true,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"cd29183c-edaf-4706-8bc4-fa25cf2f09db"},{"version":"CommandV1","origId":3118105296409313,"guid":"cf294192-5a4b-409f-a6df-b4ddb8d08d53","subtype":"command","commandType":"auto","position":1.125,"command":"%run /DataEngineering/SharedUtils","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353063131,"submitTime":1626353063131,"finishTime":1626353064814,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"Load shared functions module","showCommandTitle":true,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"3b725ad6-2212-4eb1-bb5d-97da0981108d"},{"version":"CommandV1","origId":3118105296409314,"guid":"9cc707c7-4436-4468-a54a-0e877964be2f","subtype":"command","commandType":"auto","position":1.25,"command":"#dbutils.widgets.removeAll()\n\ndbutils.widgets.text(\"mappingTable\",\"\")\ndbutils.widgets.text(\"StagingSchema\",\"\")","commandVersion":73,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{"StagingSchema":{"widgetType":"text","name":"StagingSchema","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"mappingTable":{"widgetType":"text","name":"mappingTable","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065493,"submitTime":1626353063240,"finishTime":1626353065509,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"Create widgets","showCommandTitle":true,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"f587939d-4fc3-467e-90a2-d5a511f145f3"},{"version":"CommandV1","origId":3118105296409315,"guid":"61039305-fb2d-41d1-a3d2-e934bf434de1","subtype":"command","commandType":"auto","position":1.3125,"command":"pMappingTable = dbutils.widgets.get(\"mappingTable\").strip()\npstagingSchema = dbutils.widgets.get(\"StagingSchema\").strip()\n\n\nmapping_table = pMappingTable\n\nif not pstagingSchema:\n  raise ValueError(\"Staging Schema is not provided!\") \n    \nprint(f\"Mapping table location: {mapping_table}\")","commandVersion":184,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">Mapping table location: /RAW/DataModelConfig_EmpowerSupplyChain.csv\n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{"StagingSchema":"empower_stage","mappingTable":"/RAW/DataModelConfig_EmpowerSupplyChain.csv"},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065513,"submitTime":1626353063290,"finishTime":1626353065532,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"Get Parameters","showCommandTitle":true,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"786d60c8-9271-41a2-8dd2-3214348226bf"},{"version":"CommandV1","origId":3118105296409316,"guid":"32fed272-82a1-4942-9456-f15dcdd44a2a","subtype":"command","commandType":"auto","position":1.34375,"command":"mdf = None\n\n# Check to see if anything was passed into the mapping_table param\nif mapping_table:\n\n    #Add Databricks/dbfs root mount point to file name\n    args = [\"mnt\", mapping_table]\n    theFile = slash_join(args, True)  # handles existing leading slash (or not)\n    mappingtbl_file = theFile\n\n    if not file_exists(mappingtbl_file):\n      raise ValueError(\"The Mapping file provided does not exist!\") \n      dbutils.notebook.exit(-1)        \n\n    print(f\"Loading file from {mappingtbl_file}\")\n\n    # Read the file\n    if mappingtbl_file.endswith(\".csv\"):\n      mdf = (spark \n             .read \n             .format('csv') \n             .option(\"header\", \"true\") \n             .option(\"inferSchema\", \"true\") \n             .load(mappingtbl_file)\n             )\n\n\n    elif mappingtbl_file.endswith(\".orc\"):\n      mdf = (spark.read\n             .format('orc')\n             .load(mappingtbl_file)\n             )\n    if mdf.count() == 0:\n      raise ValueError(\"The Mapping file provided contains no records!\") \n      dbutils.notebook.exit(-1)  \nelse:\n  raise ValueError(\"No Mapping file provided\")\n  \n#Select Active Records only from control table\nmdf = mdf.select(\"*\").filter(col(\"Active\") == 1)","commandVersion":127,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">Loading file from /mnt/RAW/DataModelConfig_EmpowerSupplyChain.csv\n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[{"name":"mdf","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"ModelName","nullable":true,"type":"string"},{"metadata":{},"name":"SourceType","nullable":true,"type":"string"},{"metadata":{},"name":"Source","nullable":true,"type":"string"},{"metadata":{},"name":"TargetSchemaName","nullable":true,"type":"string"},{"metadata":{},"name":"TargetTableName","nullable":true,"type":"string"},{"metadata":{},"name":"TargetColumnName","nullable":true,"type":"string"},{"metadata":{},"name":"TargetColumnType","nullable":true,"type":"string"},{"metadata":{},"name":"ColumnOrdinal","nullable":true,"type":"integer"},{"metadata":{},"name":"Active","nullable":true,"type":"integer"},{"metadata":{},"name":"ValidFromUtc","nullable":true,"type":"string"},{"metadata":{},"name":"ValidToUtc","nullable":true,"type":"string"}],"type":"struct"},"tableIdentifier":null}],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065534,"submitTime":1626353063353,"finishTime":1626353066756,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"Check and read Mapping Document if exists","showCommandTitle":true,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"86443e7e-6117-45b7-b832-9cefff7f5aa0"},{"version":"CommandV1","origId":3118105296409317,"guid":"b7f65aea-85fb-4c0e-82db-d41fd52498cd","subtype":"command","commandType":"auto","position":1.3671875,"command":"Dimensions = mdf.select(\"TargetSchemaName\",\"TargetTableName\").filter(col(\"Active\") == 1).distinct()\n\n#Create an empty DataFrame to be used for processing\nprocessing_table = [('None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        'None',\\\n        False)]\ntable_schema = ['DimensionSchema',\\\n                'StagingSchema',\\\n                'DimensionTable',\\\n                'StagingTable',\\\n                'StagingTempView',\\\n                'src_insert_col_list',\\\n                'insert_column_list',\\\n                'key_col_list',\\\n                'src_key_col_list',\\\n                'dim_key_col_list',\\\n                'business_key_col_list',\\\n                'join_key_col_list',\\\n                'src_business_key_col_list',\\\n                'dim_business_key_col_list',\\\n                'type1_col_list',\\\n                'src_type1_col_list',\\\n                'dim_type1_col_list',\\\n                'type2_col_list',\\\n                'src_type2_col_list',\\\n                'dim_type2_col_list',\\\n                'type12_col_list',\\\n                'table_exists'\n                 ]\n  \nprocessing_table = spark.createDataFrame(data = processing_table, schema = table_schema)\n\n\n\n#Loop through schema\\db\nfor dim in Dimensions.rdd.collect():    \n  #Get Schema and Table name to be loaded\n  DimensionSchema = dim.TargetSchemaName\n  DimensionTable  = dim.TargetTableName\n  stagingTable    = 'tmp_dim_' + DimensionTable\n  stagingTempView  = 'tmpvw_dim_' + DimensionTable\n  \n  #Check if schema\\db doesn't exist then create it\n  create_db = True\n  check_if_db_exists(DimensionSchema, create_db, delta_location)\n\n  #Check if dimension table exists\n  table_exists = check_if_table_exists(DimensionTable, DimensionSchema) \n    \n  print(f\"Processing SchemaName: {DimensionSchema}, DimensionName: {DimensionTable} and DimensionExists = {table_exists} \")\n  \n  #Select dimension table metadata (Keys,BusinessKey, Type1\\2 columns) from mapping document\n  AllFields = mdf.select(\"TargetColumnName\",\"TargetColumnType\")\\\n                 .filter(col(\"TargetSchemaName\") == f\"{DimensionSchema}\")\\\n                 .filter(col(\"TargetTableName\") == f\"{DimensionTable}\")\\\n                 .distinct()\n\n  #Define empty lists for the string manipulation\n  src_insert_col_list = []\n  insert_col_list = []\n  \n  key_col_list = []\n  src_key_col_list = []\n  dim_key_col_list = []\n  \n  business_key_col_list = []\n  join_key_col_list = []\n  src_business_key_col_list = []\n  dim_business_key_col_list = []\n  \n  type1_col_list = []\n  type1_col_list2 = []\n  src_type1_col_list = []\n  dim_type1_col_list = []\n  \n  type2_col_list = []\n  type2_col_list2 = []\n  src_type2_col_list = []\n  dim_type2_col_list = []\n  \n  type12_col_list = []\n  \n  #Loop through attributes for the dimension being loaded\n  for fn in AllFields.rdd.collect():\n    target_column_type = fn[\"TargetColumnType\"]\n    target_column_name = fn[\"TargetColumnName\"]\n    \n    #To be used for all fields string\n    src_insert_col_list.append(f\"src.{target_column_name}\")  \n    insert_col_list.append(target_column_name)                    \n    \n    #To be used for computing the key column(s) string\n    if target_column_type == 'key':                               \n      key_col_list.append(target_column_name)                     \n      src_key_col_list.append(f\"src.{target_column_name}\")\n      dim_key_col_list.append(f\"dim.{target_column_name}\")\n      \n    #To be used for computing the business key column(s) string\n    if target_column_type == 'business_key':                      \n      business_key_col_list.append(f\"{target_column_name}\")\n      join_key_col_list.append(f\"src.{target_column_name} = dim.{target_column_name}\")\n      src_business_key_col_list.append(f\"src.{target_column_name}\")\n      dim_business_key_col_list.append(f\"dim.{target_column_name}\")\n      \n    #To be used for computing the type 1 column(s) string\n    if target_column_type == 'type1':                             \n      type1_col_list.append(f\"dim.{target_column_name} = src.{target_column_name}\")\n      type1_col_list2.append(f\"{target_column_name}\")\n      src_type1_col_list.append(f\"src.{target_column_name}\")\n      dim_type1_col_list.append(f\"dim.{target_column_name}\")\n    \n    #To be used for computing the type 2 column(s) string\n    if target_column_type == 'type2':                             \n      type2_col_list.append(f\"dim.{target_column_name} = src.{target_column_name}\")\n      type2_col_list2.append(f\"{target_column_name}\")\n      src_type2_col_list.append(f\"src.{target_column_name}\")\n      dim_type2_col_list.append(f\"dim.{target_column_name}\")\n    \n \n  type12_col_list = type1_col_list + type2_col_list\n    \n  #Create a string to be used in merge for: select field list  \n  src_insert_col_list = \",\".join(src_insert_col_list)             \n  #Create a string to be used in merge for: Insert New\\Type2 field list    \n  insert_col_list = \",\".join(insert_col_list)                     \n  \n  #Create a string to be used in merge for: table keys \n  key_col_list = \",\".join(key_col_list)\n  src_key_col_list = \",\".join(src_key_col_list)\n  dim_key_col_list = \",\".join(dim_key_col_list)\n  \n  #Create a string to be used in merge for: Join Keys based on Business Key of the dimension\n  business_key_col_list = \",\".join(business_key_col_list)\n  join_key_col_list = \" and \".join(join_key_col_list)\n  src_business_key_col_list = \",\".join(src_business_key_col_list)\n  dim_business_key_col_list = \",\".join(dim_business_key_col_list)\n  \n  #Check if there are no Type1 fields then add a dummy column    \n  if len(type1_col_list) == 0:\n    src_type1_col_list.append(\"'X' AS empty_string\")\n    dim_type1_col_list.append(\"'X' AS empty_string\")\n  \n\n  #Create a string to be used in merge for: list of type 1 columns    \n  type1_col_list = \" , \".join(type1_col_list2)  \n  src_type1_col_list = \",\".join(src_type1_col_list)\n  dim_type1_col_list = \",\".join(dim_type1_col_list)  \n  \n\n  #Check if there are no Type2 fields then add a dummy column    \n  if len(type2_col_list) == 0:\n    src_type2_col_list.append(\"'X' AS empty_string_t2\")\n    dim_type2_col_list.append(\"'X' AS empty_string_t2\")\n    \n  #Create a string to be used in merge for: list of type 2 columns    \n  type2_col_list = \" , \".join(type2_col_list2)\n  src_type2_col_list = \",\".join(src_type2_col_list)\n  dim_type2_col_list = \",\".join(dim_type2_col_list)  \n\n  #Create a string to be used in merge for: list of merge fields\n  type12_col_list = \" , \".join(type12_col_list)\n  \n\n  \n  processing_table_t = [(DimensionSchema,\\\n                         pstagingSchema,\\\n                         DimensionTable,\\\n                         stagingTable,\\\n                         stagingTempView,\\\n                         src_insert_col_list,\\\n                         insert_col_list,\\\n                         key_col_list,\\\n                         src_key_col_list,\\\n                         dim_key_col_list,\\\n                         business_key_col_list,\\\n                         join_key_col_list,\\\n                         src_business_key_col_list,\\\n                         dim_business_key_col_list,\\\n                         type1_col_list,\\\n                         src_type1_col_list,\\\n                         dim_type1_col_list,\\\n                         type2_col_list,\\\n                         src_type2_col_list,\\\n                         dim_type2_col_list,\\\n                         type12_col_list,\\\n                         table_exists)]\n  table_schema = ['DimensionSchema',\\\n                  'StagingSchema',\\\n                  'DimensionTable',\\\n                  'StagingTable',\\\n                  'StagingTempView',\\\n                  'src_insert_col_list',\\\n                  'insert_column_list',\\\n                  'key_col_list',\\\n                  'src_key_col_list',\\\n                  'dim_key_col_list',\\\n                  'business_key_col_list',\\\n                  'join_key_col_list',\\\n                  'src_business_key_col_list',\\\n                  'dim_business_key_col_list',\\\n                  'type1_col_list',\\\n                  'src_type1_col_list',\\\n                  'dim_type1_col_list',\\\n                  'type2_col_list',\\\n                  'src_type2_col_list',\\\n                  'dim_type2_col_list',\\\n                  'type12_col_list',\\\n                  'table_exists'\n                 ]\n  \n  #Add result to processing dataframe\n  if processing_table.count != 0:\n    processing_table = spark.createDataFrame(data = processing_table_t, schema = table_schema).union(processing_table) \n  else:\n    processing_table = spark.createDataFrame(data = processing_table_t, schema = table_schema)\n    \n  \nprocessing_table = processing_table.filter(col(\"DimensionSchema\") != 'None')\ndisplay(processing_table)","commandVersion":1798,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">Processing SchemaName: empower, DimensionName: dim_legal_entity and DimensionExists = True \nProcessing SchemaName: empower, DimensionName: dim_product and DimensionExists = True \n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},{"type":"table","data":[["empower","empower_stage","dim_product","tmp_dim_dim_product","tmpvw_dim_dim_product","src.unit_cost_quantity,src.product_sub_type_description,src.product_key,src.product_description,src.unit_cost,src.product_id,src.product_weight,src.product_sub_type,src.product_state,src.product_volume,src.sales_unit_id,src.parent_sku,src.product_type_description,src.product_type,src.item_id,src.product_depth,src.legal_entity_id,src.inventory_unit_id,src.product_name,src.purchase_unit_id,src.product_width,src.unit_cost_date,src.product_height","unit_cost_quantity,product_sub_type_description,product_key,product_description,unit_cost,product_id,product_weight,product_sub_type,product_state,product_volume,sales_unit_id,parent_sku,product_type_description,product_type,item_id,product_depth,legal_entity_id,inventory_unit_id,product_name,purchase_unit_id,product_width,unit_cost_date,product_height","product_key","src.product_key","dim.product_key","item_id,legal_entity_id","src.item_id = dim.item_id and src.legal_entity_id = dim.legal_entity_id","src.item_id,src.legal_entity_id","dim.item_id,dim.legal_entity_id","unit_cost_quantity , product_sub_type_description , product_description , unit_cost , product_id , product_weight , product_sub_type , product_state , product_volume , sales_unit_id , parent_sku , product_type_description , product_type , product_depth , inventory_unit_id , product_name , purchase_unit_id , product_width , unit_cost_date , product_height","src.unit_cost_quantity,src.product_sub_type_description,src.product_description,src.unit_cost,src.product_id,src.product_weight,src.product_sub_type,src.product_state,src.product_volume,src.sales_unit_id,src.parent_sku,src.product_type_description,src.product_type,src.product_depth,src.inventory_unit_id,src.product_name,src.purchase_unit_id,src.product_width,src.unit_cost_date,src.product_height","dim.unit_cost_quantity,dim.product_sub_type_description,dim.product_description,dim.unit_cost,dim.product_id,dim.product_weight,dim.product_sub_type,dim.product_state,dim.product_volume,dim.sales_unit_id,dim.parent_sku,dim.product_type_description,dim.product_type,dim.product_depth,dim.inventory_unit_id,dim.product_name,dim.purchase_unit_id,dim.product_width,dim.unit_cost_date,dim.product_height","","'X' AS empty_string_t2","'X' AS empty_string_t2","dim.unit_cost_quantity = src.unit_cost_quantity , dim.product_sub_type_description = src.product_sub_type_description , dim.product_description = src.product_description , dim.unit_cost = src.unit_cost , dim.product_id = src.product_id , dim.product_weight = src.product_weight , dim.product_sub_type = src.product_sub_type , dim.product_state = src.product_state , dim.product_volume = src.product_volume , dim.sales_unit_id = src.sales_unit_id , dim.parent_sku = src.parent_sku , dim.product_type_description = src.product_type_description , dim.product_type = src.product_type , dim.product_depth = src.product_depth , dim.inventory_unit_id = src.inventory_unit_id , dim.product_name = src.product_name , dim.purchase_unit_id = src.purchase_unit_id , dim.product_width = src.product_width , dim.unit_cost_date = src.unit_cost_date , dim.product_height = src.product_height",true],["empower","empower_stage","dim_legal_entity","tmp_dim_dim_legal_entity","tmpvw_dim_dim_legal_entity","src.legal_entity_name,src.legal_entity_id ,src.legal_entity_key","legal_entity_name,legal_entity_id ,legal_entity_key","legal_entity_key","src.legal_entity_key","dim.legal_entity_key","legal_entity_id ","src.legal_entity_id  = dim.legal_entity_id ","src.legal_entity_id ","dim.legal_entity_id ","legal_entity_name","src.legal_entity_name","dim.legal_entity_name","","'X' AS empty_string_t2","'X' AS empty_string_t2","dim.legal_entity_name = src.legal_entity_name",true]],"arguments":{},"addedWidgets":{},"removedWidgets":[],"schema":[{"name":"DimensionSchema","type":"\"string\"","metadata":"{}"},{"name":"StagingSchema","type":"\"string\"","metadata":"{}"},{"name":"DimensionTable","type":"\"string\"","metadata":"{}"},{"name":"StagingTable","type":"\"string\"","metadata":"{}"},{"name":"StagingTempView","type":"\"string\"","metadata":"{}"},{"name":"src_insert_col_list","type":"\"string\"","metadata":"{}"},{"name":"insert_column_list","type":"\"string\"","metadata":"{}"},{"name":"key_col_list","type":"\"string\"","metadata":"{}"},{"name":"src_key_col_list","type":"\"string\"","metadata":"{}"},{"name":"dim_key_col_list","type":"\"string\"","metadata":"{}"},{"name":"business_key_col_list","type":"\"string\"","metadata":"{}"},{"name":"join_key_col_list","type":"\"string\"","metadata":"{}"},{"name":"src_business_key_col_list","type":"\"string\"","metadata":"{}"},{"name":"dim_business_key_col_list","type":"\"string\"","metadata":"{}"},{"name":"type1_col_list","type":"\"string\"","metadata":"{}"},{"name":"src_type1_col_list","type":"\"string\"","metadata":"{}"},{"name":"dim_type1_col_list","type":"\"string\"","metadata":"{}"},{"name":"type2_col_list","type":"\"string\"","metadata":"{}"},{"name":"src_type2_col_list","type":"\"string\"","metadata":"{}"},{"name":"dim_type2_col_list","type":"\"string\"","metadata":"{}"},{"name":"type12_col_list","type":"\"string\"","metadata":"{}"},{"name":"table_exists","type":"\"boolean\"","metadata":"{}"}],"overflow":false,"aggData":[],"aggSchema":[],"aggOverflow":false,"aggSeriesLimitReached":false,"aggError":"","aggType":"","plotOptions":null,"isJsonSchema":true,"dbfsResultPath":null,"datasetInfos":[],"columnCustomDisplayInfos":{},"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[{"name":"Dimensions","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"TargetSchemaName","nullable":true,"type":"string"},{"metadata":{},"name":"TargetTableName","nullable":true,"type":"string"}],"type":"struct"},"tableIdentifier":null},{"name":"AllFields","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"TargetColumnName","nullable":true,"type":"string"},{"metadata":{},"name":"TargetColumnType","nullable":true,"type":"string"}],"type":"struct"},"tableIdentifier":null},{"name":"processing_table","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"DimensionSchema","nullable":true,"type":"string"},{"metadata":{},"name":"StagingSchema","nullable":true,"type":"string"},{"metadata":{},"name":"DimensionTable","nullable":true,"type":"string"},{"metadata":{},"name":"StagingTable","nullable":true,"type":"string"},{"metadata":{},"name":"StagingTempView","nullable":true,"type":"string"},{"metadata":{},"name":"src_insert_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"insert_column_list","nullable":true,"type":"string"},{"metadata":{},"name":"key_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"src_key_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"dim_key_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"business_key_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"join_key_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"src_business_key_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"dim_business_key_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"type1_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"src_type1_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"dim_type1_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"type2_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"src_type2_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"dim_type2_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"type12_col_list","nullable":true,"type":"string"},{"metadata":{},"name":"table_exists","nullable":true,"type":"boolean"}],"type":"struct"},"tableIdentifier":null}],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353066759,"submitTime":1626353063400,"finishTime":1626353068383,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"7417","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"Create a table with Active dimensions and columns to be processed in the load","showCommandTitle":true,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"bc77da2f-fce6-412e-8501-4b7cb3fdeeaf"},{"version":"CommandV1","origId":3118105296409318,"guid":"b976f838-e84a-42b8-852c-87c75bc71eb4","subtype":"command","commandType":"auto","position":1.43359375,"command":"#If dimension table doesn't exist, then it's the first run. \n#Write staging query as a delta table (dimension)\n#new_dimension = processing_table.filter(col(\"table_exists\") == False)\n\nfor dim in processing_table.rdd.collect():\n  staging_table = dim[\"StagingTable\"]\n  staging_schema =  dim[\"StagingSchema\"]  \n  staging_schema_table = dim[\"StagingSchema\"] + '.' + dim[\"StagingTable\"]\n  dimension_schema_table = dim[\"DimensionSchema\"] + '.' + dim[\"DimensionTable\"]\n  staging_temp_view = dim[\"StagingTempView\"]\n  table_exists = dim[\"table_exists\"]\n  type1_cols_str = dim[\"type1_col_list\"]\n  type2_cols_str = dim[\"type2_col_list\"]\n  delta_control_col_list = ['dl_iscurrent','dl_rowhash','dl_recordstartdateutc','dl_recordenddateutc','dl_sourcefilename']\n  \n  stage_table_exists = check_if_table_exists(staging_table,staging_schema)  \n  \n  #For Debugging\n  print(f\"reading from table : {staging_schema_table} and loading dimension : {dimension_schema_table} and dimension table exists is :{table_exists}\")\n  \n  #Check if staging table exists\n  if not stage_table_exists:\n    raise ValueError(\"Staging Table doesn't exist!\") \n  else:\n    \n    #Select from Source table\n    staging_query_str = f\"SELECT * FROM {staging_schema_table}\"   \n  \n    #Create a dataframe from source dataset\n    staging_query_df = spark.sql(staging_query_str) \n    \n    #Check if no Type1 columns defined then used business keys for the hash\n    if type1_cols_str == '':\n      type1_cols_str = dim[\"business_key_col_list\"]\n\n    #Check if no Type2 columns defined then used business keys for the hash\n    if type2_cols_str == '':\n      type2_cols_str = dim[\"business_key_col_list\"]\n\n    # Convert the string to a list\n    type1_cols = type1_cols_str.split(\",\")\n    #Remove any spaces\n    type1_cols = [c.strip() for c in type1_cols]\n\n\n    # Convert the string to a list\n    type2_cols = type2_cols_str.split(\",\")\n    #Remove any spaces\n    type2_cols = [c.strip() for c in type2_cols]\n\n\n    #print('Type1 columns:\\t', type1_cols)\n    #print('Type2 columns:\\t', type2_cols)\n    \n    staging_query_df = staging_query_df.drop(*delta_control_col_list)\n    \n    #Add hashtotal for type 1 columns\n    staging_query_df = staging_query_df.withColumn(\"h_total_type_1\", sha2(concat_ws(\"||\", *type1_cols), 256))\n\n    #Add hashtotal for type 2 columns    \n    staging_query_df = staging_query_df.withColumn(\"h_total_type_2\", sha2(concat_ws(\"||\", *type2_cols), 256))\n    \n    #display(staging_query_df)\n    \n    if not table_exists:\n      #New Load and dimension table doesn't exist\n      #Write the data frame to a delta dimension table\n      staging_query_df.write.format(\"delta\").saveAsTable(f\"{dimension_schema_table}\")\n    else:\n      #Table Exists then apply merge statement\n      #Write Staging Query to a temp view\n      staging_query_df.createOrReplaceTempView(f\"{staging_temp_view}\")\n      \n      \n      table_key = dim[\"key_col_list\"]\n      src_table_key = dim[\"src_key_col_list\"]\n      dim_table_key = dim[\"dim_key_col_list\"]\n      join_key  = dim[\"join_key_col_list\"]\n      dim_business_key_columns  = dim[\"dim_business_key_col_list\"]\n      update_columns = dim[\"type12_col_list\"]\n      insert_columns = dim[\"insert_column_list\"]\n      src_insert_columns = dim[\"src_insert_col_list\"]\n      src_key_columns = dim[\"src_key_col_list\"]\n      src_business_key_columns = dim[\"src_business_key_col_list\"]   ##Typo with columns \n      src_type1_columns = dim[\"src_type1_col_list\"]\n      dim_type1_columns = dim[\"dim_type1_col_list\"]\n      src_type2_columns = dim[\"src_type2_col_list\"]\n      dim_type2_columns = dim[\"dim_type2_col_list\"]\n      \n      row_count_max_dim_key   = spark.sql(f\"\"\"SELECT MAX(dim.{table_key}) as {table_key} \n                                              FROM {dimension_schema_table} dim\"\"\")\\\n                                     .distinct()\\\n                                     .rdd.map(lambda r:r[0])\\\n                                     .collect()[0]\n      row_count_new_insert    = spark.sql(f\"\"\"SELECT COUNT(src.{table_key}) as {table_key} \n                                              FROM {staging_temp_view} src \n                                              LEFT JOIN {dimension_schema_table} dim \n                                              ON {join_key} \n                                              WHERE {dim_table_key} IS NULL \"\"\")\\\n                                     .distinct()\\\n                                     .rdd.map(lambda r:r[0])\\\n                                     .collect()[0]\n      row_count_type2_insert  = spark.sql(f\"\"\"SELECT COUNT(dim.{table_key}) as {table_key} \n                                              FROM {staging_temp_view} src \n                                              INNER JOIN {dimension_schema_table} dim \n                                              ON {join_key} \n                                              WHERE (src.h_total_type_2 <> dim.h_total_type_2)  \n                                              AND dim.current_flag = 1 \n                                              AND dim.deleted_flag = 0\"\"\")\\\n                                     .distinct()\\\n                                     .rdd.map(lambda r:r[0])\\\n                                     .collect()[0]\n      row_count_delete_insert = spark.sql(f\"\"\"SELECT COUNT(dim.{table_key}) as {table_key} \n                                               FROM {staging_temp_view} src \n                                               RIGHT JOIN {dimension_schema_table} dim \n                                               ON {join_key} \n                                               WHERE src.h_total_type_2 IS NULL  \n                                               AND dim.current_flag = 1 \n                                               AND dim.deleted_flag = 0 \"\"\")\\\n                                     .distinct()\\\n                                     .rdd.map(lambda r:r[0])\\\n                                     .collect()[0]\n      \n      insert_control_columns = ',current_flag,deleted_flag,effective_from_date,effective_to_date,inserted_date,update_date,user_id,h_total_type_1,h_total_type_2'\n      src_control_columns    = ',src.current_flag,src.deleted_flag,src.effective_from_date,src.effective_to_date,src.inserted_date,src.update_date,src.user_id,src.h_total_type_1,src.h_total_type_2'\n\n      \n      merge_query = f\"\"\"\n                  MERGE INTO {dimension_schema_table} dim\n                  USING\n                  (\n                    -- INSERT NEW ROWS                \n                    SELECT \n                    ROW_NUMBER() OVER(ORDER BY (SELECT 1)) + {row_count_max_dim_key} AS {table_key}\n                    ,{src_business_key_columns}\n                    ,{src_type1_columns}\n                    ,{src_type2_columns}\n                    ,src.current_flag\n                    ,src.deleted_flag\n                    ,src.effective_from_date\n                    ,src.effective_to_date\n                    ,'{batchTime}' AS inserted_date\n                    ,'{batchTime}' AS update_date\n                    ,src.user_id\n                    ,src.h_total_type_1\n                    ,src.h_total_type_2\n                    ,'INSERT' AS ACTION\n                    FROM {staging_temp_view} src \n                    LEFT JOIN {dimension_schema_table} dim on {join_key}\n                    WHERE {dim_table_key} IS NULL\n                    \n                    UNION\n                \n                    --TYPE 1 UPDATE\n                    SELECT \n                    {dim_table_key}\n                    ,{src_business_key_columns}  \n                    ,{src_type1_columns}\n                    ,{dim_type2_columns}\n                    ,src.current_flag\n                    ,src.deleted_flag\n                    ,src.effective_from_date\n                    ,src.effective_to_date\n                    ,dim.inserted_date\n                    ,'{batchTime}' AS update_date\n                    ,src.user_id\n                    ,src.h_total_type_1\n                    ,src.h_total_type_2\n                    ,'UPDATE_TYPE_1' AS ACTION\n                    FROM {staging_temp_view} src \n                    INNER JOIN {dimension_schema_table} dim on {join_key}\n                    WHERE src.h_total_type_1 <> dim.h_total_type_1 AND dim.current_flag = 1\n                    \n                    UNION\n                \n                    --TYPE 2 UPDATE\n                    SELECT \n                    {dim_table_key}\n                    ,{dim_business_key_columns}\n                    ,{dim_type1_columns}\n                    ,{dim_type2_columns}\n                    ,0   AS current_flag\n                    ,dim.deleted_flag\n                    ,dim.effective_from_date\n                    ,date_format(current_date() - 1,\"yyyy-MM-dd 00:00:00\") AS effective_to_date\n                    ,dim.inserted_date\n                    ,'{batchTime}' AS update_date\n                    ,dim.user_id\n                    ,dim.h_total_type_1\n                    ,dim.h_total_type_2\n                    ,'UPDATE_TYPE_2' AS ACTION\n                    FROM {staging_temp_view} src \n                    RIGHT JOIN {dimension_schema_table} dim on {join_key}\n                    WHERE (src.h_total_type_2 <> dim.h_total_type_2 OR src.h_total_type_2 IS NULL)  AND dim.current_flag = 1 AND dim.deleted_flag = 0\n                    \n                    UNION\n                \n                    --TYPE 2 INSERT (FOR UPDATES)\n                    SELECT \n                    ROW_NUMBER() OVER(ORDER BY (SELECT 1)) + {row_count_max_dim_key} + {row_count_new_insert} AS {table_key}\n                    ,{src_business_key_columns}\n                    ,{dim_type1_columns}\n                    ,{src_type2_columns}\n                    ,src.current_flag\n                    ,0                                                     AS deleted_flag\n                    ,date_format(current_date() ,\"yyyy-MM-dd 00:00:00\")    AS effective_from_date\n                    ,src.effective_to_date\n                    ,'{batchTime}' AS inserted_date\n                    ,'{batchTime}' AS update_date\n                    ,src.user_id\n                    ,src.h_total_type_1\n                    ,src.h_total_type_2\n                    ,'INSERT_TYPE_2'                                       AS ACTION\n                    FROM {staging_temp_view} src \n                    INNER JOIN {dimension_schema_table} dim on {join_key}\n                    WHERE (src.h_total_type_2 <> dim.h_total_type_2)  AND dim.current_flag = 1 AND dim.deleted_flag = 0\n                    \n                    UNION\n                \n                    --TYPE 2 INSERT (FOR DELETES)\n                    SELECT \n                    ROW_NUMBER() OVER(ORDER BY (SELECT 1)) + {row_count_max_dim_key} + {row_count_new_insert} + {row_count_type2_insert} AS {table_key}\n                    ,{dim_business_key_columns}\n                    ,{dim_type1_columns}\n                    ,{dim_type2_columns}\n                    ,1                                                     AS current_flag\n                    ,1                                                     AS deleted_flag\n                    ,date_format(current_date() ,\"yyyy-MM-dd 00:00:00\")    AS effective_from_date\n                    ,dim.effective_to_date\n                    ,'{batchTime}' AS inserted_date\n                    ,'{batchTime}' AS update_date\n                    ,dim.user_id\n                    ,dim.h_total_type_1\n                    ,dim.h_total_type_2\n                    ,'INSERT_TYPE_2'                                       AS ACTION\n                    FROM {staging_temp_view} src \n                    RIGHT JOIN {dimension_schema_table} dim on {join_key}\n                    WHERE src.h_total_type_2 IS NULL  AND dim.current_flag = 1 AND dim.deleted_flag = 0\n                    \n                    UNION\n                \n                    --RE-Activating a Deleted Record\n                    SELECT \n                    {dim_table_key}\n                    ,{dim_business_key_columns}\n                    ,{dim_type1_columns}\n                    ,{dim_type2_columns}\n                    ,0   AS current_flag\n                    ,dim.deleted_flag\n                    ,dim.effective_from_date\n                    ,date_format(current_date() - 1,\"yyyy-MM-dd 00:00:00\") AS effective_to_date\n                    ,dim.inserted_date\n                    ,'{batchTime}' AS update_date\n                    ,dim.user_id\n                    ,dim.h_total_type_1\n                    ,dim.h_total_type_2\n                    ,'UPDATE_REACTIVE_RECORD' AS ACTION\n                    FROM {staging_temp_view} src \n                    INNER JOIN {dimension_schema_table} dim on {join_key}\n                    WHERE dim.current_flag = 1 AND dim.deleted_flag = 1\n                    \n                    UNION\n                \n                    --RE-Activating record INSERT\n                    SELECT \n                    ROW_NUMBER() OVER(ORDER BY (SELECT 1)) + {row_count_max_dim_key} + {row_count_new_insert} + {row_count_type2_insert} + {row_count_delete_insert} AS {table_key}\n                    ,{src_business_key_columns}\n                    ,{src_type1_columns}\n                    ,{src_type2_columns}\n                    ,src.current_flag\n                    ,0                                                     AS deleted_flag\n                    ,date_format(current_date() ,\"yyyy-MM-dd 00:00:00\")    AS effective_from_date\n                    ,src.effective_to_date\n                    ,'{batchTime}' AS inserted_date\n                    ,'{batchTime}' AS update_date\n                    ,src.user_id\n                    ,src.h_total_type_1\n                    ,src.h_total_type_2\n                    ,'INSERT_TYPE_2'                                       AS ACTION\n                    FROM {staging_temp_view} src \n                    INNER JOIN {dimension_schema_table} dim on {join_key}\n                    WHERE dim.current_flag = 1 AND dim.deleted_flag = 1\n                    \n                  )  src \n                  ON {src_table_key} = {dim_table_key}\n                  WHEN MATCHED --AND dim.current_flag = 1\n                  THEN UPDATE SET {update_columns} \t\n                                  ,dim.current_flag        = src.current_flag       \n                                  ,dim.deleted_flag        = src.deleted_flag       \n                                  ,dim.effective_from_date = src.effective_from_date\n                                  ,dim.effective_to_date   = src.effective_to_date  \n                                  ,dim.update_date         = src.update_date        \n                                  ,dim.user_id             = src.user_id            \n                                  ,dim.h_total_type_1      = src.h_total_type_1     \n                                  ,dim.h_total_type_2      = src.h_total_type_2\t\n                \n                  WHEN NOT MATCHED\n                  THEN INSERT({insert_columns}  {insert_control_columns})\n                       VALUES({src_insert_columns}  {src_control_columns})\n      \"\"\"\n      #print(staging_temp_view)\n      #print(merge_query)\n      \n      try:\n        spark.sql(merge_query)\n      except Exception as E:\n        raise ValueError(f\"Error performing merge {E}\")\n      \n      #Clean up - Drop TempView\n      spark.sql(f\"drop view {staging_temp_view}\")","commandVersion":1115,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">reading from table : empower_stage.tmp_dim_dim_product and loading dimension : empower.dim_product and dimension table exists is :True\nreading from table : empower_stage.tmp_dim_dim_legal_entity and loading dimension : empower.dim_legal_entity and dimension table exists is :True\n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[{"name":"staging_query_df","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"legal_entity_key","nullable":true,"type":"integer"},{"metadata":{},"name":"legal_entity_id","nullable":true,"type":"string"},{"metadata":{},"name":"legal_entity_name","nullable":true,"type":"string"},{"metadata":{},"name":"current_flag","nullable":true,"type":"string"},{"metadata":{},"name":"deleted_flag","nullable":true,"type":"string"},{"metadata":{},"name":"effective_from_date","nullable":true,"type":"string"},{"metadata":{},"name":"effective_to_date","nullable":true,"type":"string"},{"metadata":{},"name":"inserted_date","nullable":true,"type":"timestamp"},{"metadata":{},"name":"update_date","nullable":true,"type":"timestamp"},{"metadata":{},"name":"user_id","nullable":true,"type":"string"},{"metadata":{},"name":"h_total_type_1","nullable":true,"type":"string"},{"metadata":{},"name":"h_total_type_2","nullable":true,"type":"string"}],"type":"struct"},"tableIdentifier":null}],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353068388,"submitTime":1626353063446,"finishTime":1626353097925,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"7972","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"Check if table_exists = false then Create New Dimension table, else Apply Merge","showCommandTitle":true,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"a81a916e-fc89-49da-9a29-ce3e60e9505a"},{"version":"CommandV1","origId":3118105296409319,"guid":"3ca97162-c16f-43b8-b14f-020a3805478c","subtype":"command","commandType":"auto","position":2.375,"command":"try:\n    spark.sql(f\"drop view {source_vw}\")\n    staging_query.unpersist()\n    sdf.unpersist()\nexcept:\n    pass","commandVersion":33,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353097929,"submitTime":1626353063491,"finishTime":1626353097948,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"Clean up temp views","showCommandTitle":true,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"48ce05f4-8c52-435c-9110-8d5834f25b76"},{"version":"CommandV1","origId":3193321063604256,"guid":"4b4d4e1d-b59c-4192-87a0-cbdb97081aea","subtype":"script","commandType":"auto","position":1.1583333333333334,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353064850,"submitTime":0,"finishTime":1626353064867,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"d62311a7-be3c-498c-b12e-ca94329db284"},{"version":"CommandV1","origId":3193321063604257,"guid":"68f3b3ad-09a5-48d5-819a-c6d2c97d3952","subtype":"script","commandType":"auto","position":1.1916666666666667,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353064870,"submitTime":0,"finishTime":1626353064891,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"6a9eb0d7-50a9-44e8-90e8-59a7369c43bf"},{"version":"CommandV1","origId":3193321063604258,"guid":"026193af-853f-4979-be10-25243053672e","subtype":"script","commandType":"auto","position":1.225,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353064895,"submitTime":0,"finishTime":1626353064920,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"98848bd5-ca5c-4049-9c09-249a58ffd562"},{"version":"CommandV1","origId":3193321063604259,"guid":"fd2822e7-a26d-4cae-bd6e-ca93c750b8e6","subtype":"script","commandType":"auto","position":1.2583333333333333,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353064923,"submitTime":0,"finishTime":1626353064941,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"16b69105-4b11-4b61-b3da-aa8772c529c7"},{"version":"CommandV1","origId":3193321063604260,"guid":"6abe7f1e-f285-4285-a5b7-f0214000a39b","subtype":"script","commandType":"auto","position":1.2916666666666667,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353064944,"submitTime":0,"finishTime":1626353064961,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b26ae44c-4b25-45c1-81f2-d7545c4eec8a"},{"version":"CommandV1","origId":3193321063604261,"guid":"8872e158-f1d0-4c41-bf52-a6923af4c4b9","subtype":"script","commandType":"auto","position":1.325,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353064964,"submitTime":0,"finishTime":1626353064981,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"cce1a3d1-b0dc-4512-811f-294e7aa2af0b"},{"version":"CommandV1","origId":3193321063604262,"guid":"eecdd4b9-3de8-408a-80ef-d03daf65250f","subtype":"script","commandType":"auto","position":1.3583333333333334,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353064984,"submitTime":0,"finishTime":1626353065001,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"abdc8deb-2f27-4cd3-9e0b-e69ef54a874c"},{"version":"CommandV1","origId":3193321063604263,"guid":"c1c66660-f9b5-4dbd-b5cc-b2c6dc4bef28","subtype":"script","commandType":"auto","position":1.3916666666666666,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065004,"submitTime":0,"finishTime":1626353065027,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"7f528320-e891-4403-9e60-bb5b532b7384"},{"version":"CommandV1","origId":3193321063604264,"guid":"e0880850-88db-4ced-932a-4d66b7ff0ced","subtype":"script","commandType":"auto","position":1.425,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065030,"submitTime":0,"finishTime":1626353065052,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"6c5783ec-7193-497c-ae48-8f359dd15d79"},{"version":"CommandV1","origId":3193321063604265,"guid":"39936766-031f-4f79-a031-f8eeae8db290","subtype":"script","commandType":"auto","position":1.4583333333333333,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065055,"submitTime":0,"finishTime":1626353065072,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b6ecd665-7a6f-4c6b-bb5d-2e7cafaa1ece"},{"version":"CommandV1","origId":3193321063604266,"guid":"8ed3909c-9d28-491f-922c-a9acd1b726e6","subtype":"script","commandType":"auto","position":1.4916666666666667,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065074,"submitTime":0,"finishTime":1626353065092,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b4d11207-d953-4fea-80bd-48307d1f101e"},{"version":"CommandV1","origId":3193321063604267,"guid":"2f489780-b9e6-4829-a92c-a0e90cb4355e","subtype":"script","commandType":"auto","position":1.525,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065095,"submitTime":0,"finishTime":1626353065113,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b7b1e43b-7474-4cf0-ae05-b94893f23300"},{"version":"CommandV1","origId":3193321063604268,"guid":"9037eee9-bd9e-4f77-93d2-d05dc802f58f","subtype":"script","commandType":"auto","position":1.5583333333333333,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065115,"submitTime":0,"finishTime":1626353065133,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"67be1ec5-042a-4820-91b5-546c62afa16b"},{"version":"CommandV1","origId":3193321063604269,"guid":"9b4ae274-cdcd-492a-b366-f686c838427b","subtype":"script","commandType":"auto","position":1.5916666666666668,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065136,"submitTime":0,"finishTime":1626353065158,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"c9ba476d-bc46-4cb5-8273-442ad0c13aa1"},{"version":"CommandV1","origId":3193321063604270,"guid":"2ad6fcd0-bd7b-45ef-9653-601a4607ecf7","subtype":"script","commandType":"auto","position":1.625,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065160,"submitTime":0,"finishTime":1626353065176,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"61923e5c-f069-4991-bce1-d1998f03ca50"},{"version":"CommandV1","origId":3193321063604271,"guid":"24eebc50-897a-4769-8cc0-dbb721418097","subtype":"script","commandType":"auto","position":1.6583333333333332,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065179,"submitTime":0,"finishTime":1626353065196,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"6a2386a8-3585-4f5b-8d1a-6a221008a3a8"},{"version":"CommandV1","origId":3193321063604272,"guid":"3d581b66-eda6-4f81-9af3-d4d45da1e2cf","subtype":"script","commandType":"auto","position":1.6916666666666667,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065198,"submitTime":0,"finishTime":1626353065216,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"2034a836-ca3b-4e74-9c99-9c5406fae914"},{"version":"CommandV1","origId":3193321063604273,"guid":"465ebb5b-662a-48f9-b6f0-8bdb487beca4","subtype":"script","commandType":"auto","position":1.725,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065218,"submitTime":0,"finishTime":1626353065237,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"fa7038b8-eeae-4faf-b67c-3533f592c4be"},{"version":"CommandV1","origId":3193321063604274,"guid":"0aa1067d-e0c6-438d-af65-0f9db9f9711d","subtype":"script","commandType":"auto","position":1.7583333333333333,"command":"","commandVersion":9,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065240,"submitTime":0,"finishTime":1626353065258,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"f7e130f3-a10c-4be5-b766-bf22f0eaa005"},{"version":"CommandV1","origId":3193321063604275,"guid":"5834a67c-1189-42d7-8648-1b5e4546ba3a","subtype":"script","commandType":"auto","position":1.7916666666666665,"command":"","commandVersion":19,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065260,"submitTime":0,"finishTime":1626353065282,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"cd3b7f3c-4cff-4081-8f26-8fee0f0b4dd6"},{"version":"CommandV1","origId":3193321063604276,"guid":"d4813f00-dd8b-426b-b392-f65186bc66ee","subtype":"script","commandType":"auto","position":1.825,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065285,"submitTime":0,"finishTime":1626353065304,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"4a226d2a-a3e4-4c6d-98fa-85f8ba9827c9"},{"version":"CommandV1","origId":3193321063604277,"guid":"8624d7c9-e9a4-4032-8ffe-2bce3481fa11","subtype":"script","commandType":"auto","position":1.8583333333333334,"command":"","commandVersion":5,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065306,"submitTime":0,"finishTime":1626353065324,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"e1c71d16-34f1-47f0-bf92-ee4ac052e889"},{"version":"CommandV1","origId":3193321063604278,"guid":"12eaad04-1220-41df-906b-15e4c0530fd6","subtype":"script","commandType":"auto","position":1.8916666666666666,"command":"","commandVersion":4,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065327,"submitTime":0,"finishTime":1626353065345,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"0b9ccd37-947a-47e6-ae42-d1e165f3c085"},{"version":"CommandV1","origId":3193321063604279,"guid":"02f2391a-b252-43f6-bc03-08fdc4a78a07","subtype":"script","commandType":"auto","position":1.925,"command":"","commandVersion":11,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065347,"submitTime":0,"finishTime":1626353065371,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b0e73abd-c26a-4354-ba36-0b5f8d95caee"},{"version":"CommandV1","origId":3193321063604280,"guid":"8dbe8d1b-90ac-44bf-a62a-b610d9624f38","subtype":"script","commandType":"auto","position":1.9583333333333335,"command":"","commandVersion":4,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065374,"submitTime":0,"finishTime":1626353065393,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"9e4e7bf9-f126-472c-9fbc-f4e8613533fb"},{"version":"CommandV1","origId":3193321063604281,"guid":"3fbf4492-c75d-4de1-938d-109ca6c81cd9","subtype":"script","commandType":"auto","position":1.9916666666666667,"command":"","commandVersion":42,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065396,"submitTime":0,"finishTime":1626353065416,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"2ebbc8ec-3d9a-4199-8649-df651f2387b6"},{"version":"CommandV1","origId":3193321063604282,"guid":"831c6bdf-963d-4f1e-a645-e564584452e5","subtype":"script","commandType":"auto","position":2.025,"command":"","commandVersion":3,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065419,"submitTime":0,"finishTime":1626353065436,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"966dd1bf-77f9-4969-87ce-57a3dc32afb7"},{"version":"CommandV1","origId":3193321063604283,"guid":"9a5e094d-c503-4583-9cf4-36cc85fe820f","subtype":"script","commandType":"auto","position":2.0583333333333336,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065439,"submitTime":0,"finishTime":1626353065467,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"5da50073-429f-401d-b40f-6379eeead438"},{"version":"CommandV1","origId":3193321063604284,"guid":"d3b37d2f-0c16-4bee-a768-4979a59380fe","subtype":"script","commandType":"auto","position":2.091666666666667,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1626353065470,"submitTime":0,"finishTime":1626353065490,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["cf294192-5a4b-409f-a6df-b4ddb8d08d53"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"7a379d31-5ff4-4887-8d39-12f09f6645d0"}],"dashboards":[],"guid":"e8e3dc92-344b-4073-9a81-5c53d127f532","globalVars":{},"iPythonMetadata":null,"inputWidgets":{"mappingTable":{"nuid":"b65a3ab2-ba6f-40d4-8603-e6198eb7ac9e","currentValue":"/RAW/DataModelConfig_EmpowerSupplyChain.csv","widgetInfo":{"widgetType":"text","name":"mappingTable","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"StagingSchema":{"nuid":"1175dc95-9aba-4cc3-a203-15588b1168b4","currentValue":"empower_stage","widgetInfo":{"widgetType":"text","name":"StagingSchema","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}}},"notebookMetadata":{"pythonIndentUnit":2}}