{"version":"NotebookV1","origId":3273046978841234,"name":"LoadStageFilesFromDeltaTables","language":"python","commands":[{"version":"CommandV1","origId":3273046978841235,"guid":"55655500-ac9e-430f-a3b0-fa0ba7043d53","subtype":"command","commandType":"auto","position":1.0,"command":"%md\n### Purpose\nThis notebook copies data to the Stage Zone for the DNA Gen 2 architecture.\n\n### Format\nThe format of the stage zone is ORC files, partitioned into files based on the underlying table (capped at 240).  Readers must read the entire directory and cannot guarantee single file stage.\n\n### Params\nPass in the name of the hive schema and object name.  If the object is held in the delta lake (at base table), only the current data is selected.","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"8e66aa9a-2130-482c-a0f7-8fb474c77173"},{"version":"CommandV1","origId":3273046978841236,"guid":"7f6c27d7-9982-42f4-ac62-28e84dfa8917","subtype":"command","commandType":"auto","position":2.0,"command":"from pyspark.sql.functions import max, length\n#from pyspark.sql.functions import min as min_ #realias pyspark min function to use python min below\nfrom pyspark.sql import functions as F\n\nimport datetime\nimport json\n\n# Mount point for Output files\nstage_location = \"STAGE\"\n","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533748,"submitTime":1613676533571,"finishTime":1613676533769,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b9dbe1fa-df5d-4d69-a851-ef98d23de428"},{"version":"CommandV1","origId":3273046978841237,"guid":"af06045e-b1c7-45c5-9d5c-1f129ffa5188","subtype":"command","commandType":"auto","position":3.0,"command":"%md\n#### Shared Library","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"28bc7c10-85eb-469d-bd83-7aa6d24f58d4"},{"version":"CommandV1","origId":3273046978841238,"guid":"24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1","subtype":"command","commandType":"auto","position":4.0,"command":"%run /DataEngineering/SharedUtils","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533585,"submitTime":1613676533585,"finishTime":1613676534745,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"acedafbe-1f47-44e3-a733-a4871a6729b2"},{"version":"CommandV1","origId":3273046978841239,"guid":"54682055-57ad-4295-9046-8206fa1ea261","subtype":"script","commandType":"auto","position":4.0344827586206895,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533772,"submitTime":0,"finishTime":1613676533794,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"d62311a7-be3c-498c-b12e-ca94329db284"},{"version":"CommandV1","origId":3273046978841240,"guid":"b7362cae-686b-45fe-92eb-a8589c2fb005","subtype":"script","commandType":"auto","position":4.068965517241379,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533796,"submitTime":0,"finishTime":1613676533816,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"6a9eb0d7-50a9-44e8-90e8-59a7369c43bf"},{"version":"CommandV1","origId":3273046978841241,"guid":"3251dd7c-1521-4c6d-89cc-5bb7c921be22","subtype":"script","commandType":"auto","position":4.103448275862069,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533819,"submitTime":0,"finishTime":1613676533848,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"98848bd5-ca5c-4049-9c09-249a58ffd562"},{"version":"CommandV1","origId":3273046978841242,"guid":"db728f0e-46bd-473c-91f9-d33e307cce6c","subtype":"script","commandType":"auto","position":4.137931034482759,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533850,"submitTime":0,"finishTime":1613676533870,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"16b69105-4b11-4b61-b3da-aa8772c529c7"},{"version":"CommandV1","origId":3273046978841243,"guid":"cf1ee1b0-be15-4235-a958-6923a2b01498","subtype":"script","commandType":"auto","position":4.172413793103448,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533872,"submitTime":0,"finishTime":1613676533892,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b26ae44c-4b25-45c1-81f2-d7545c4eec8a"},{"version":"CommandV1","origId":3273046978841244,"guid":"a9e91ddc-6b84-4234-a049-9ec14a5f5b6e","subtype":"script","commandType":"auto","position":4.206896551724138,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533894,"submitTime":0,"finishTime":1613676533915,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"cce1a3d1-b0dc-4512-811f-294e7aa2af0b"},{"version":"CommandV1","origId":3273046978841245,"guid":"d8cab18c-c7d4-44a9-b925-2b94e2c6c0db","subtype":"script","commandType":"auto","position":4.241379310344827,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533917,"submitTime":0,"finishTime":1613676533936,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"abdc8deb-2f27-4cd3-9e0b-e69ef54a874c"},{"version":"CommandV1","origId":3273046978841246,"guid":"0c0a8887-4d08-4747-8d67-8eefd8e1ccdb","subtype":"script","commandType":"auto","position":4.275862068965517,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533939,"submitTime":0,"finishTime":1613676533958,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"7f528320-e891-4403-9e60-bb5b532b7384"},{"version":"CommandV1","origId":3273046978841247,"guid":"61795731-7093-446d-a966-6f1903bbb81d","subtype":"script","commandType":"auto","position":4.310344827586207,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533961,"submitTime":0,"finishTime":1613676533988,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"6c5783ec-7193-497c-ae48-8f359dd15d79"},{"version":"CommandV1","origId":3273046978841248,"guid":"3322e0fc-33c4-4470-b580-e7c6043d8a69","subtype":"script","commandType":"auto","position":4.344827586206897,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533990,"submitTime":0,"finishTime":1613676534012,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b6ecd665-7a6f-4c6b-bb5d-2e7cafaa1ece"},{"version":"CommandV1","origId":3273046978841249,"guid":"7770c1b3-1b7c-49c5-9994-afedd374598d","subtype":"script","commandType":"auto","position":4.379310344827586,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534015,"submitTime":0,"finishTime":1613676534038,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b4d11207-d953-4fea-80bd-48307d1f101e"},{"version":"CommandV1","origId":3273046978841250,"guid":"858234d0-fcc1-4e5a-be34-98ed013bc6f5","subtype":"script","commandType":"auto","position":4.413793103448276,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534041,"submitTime":0,"finishTime":1613676534061,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b7b1e43b-7474-4cf0-ae05-b94893f23300"},{"version":"CommandV1","origId":3273046978841251,"guid":"86c8a416-bb55-45d9-b73b-7fb9ab03c261","subtype":"script","commandType":"auto","position":4.448275862068965,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534063,"submitTime":0,"finishTime":1613676534084,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"67be1ec5-042a-4820-91b5-546c62afa16b"},{"version":"CommandV1","origId":3273046978841252,"guid":"6889392e-0a2f-4249-bc56-70c5934257b9","subtype":"script","commandType":"auto","position":4.482758620689655,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534086,"submitTime":0,"finishTime":1613676534115,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"c9ba476d-bc46-4cb5-8273-442ad0c13aa1"},{"version":"CommandV1","origId":3273046978841253,"guid":"f365f661-dfde-4fc9-b625-f521835e3808","subtype":"script","commandType":"auto","position":4.517241379310345,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534118,"submitTime":0,"finishTime":1613676534138,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"61923e5c-f069-4991-bce1-d1998f03ca50"},{"version":"CommandV1","origId":3273046978841254,"guid":"d3d5e0fe-7994-4798-88e9-5267fcf899e5","subtype":"script","commandType":"auto","position":4.551724137931035,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534141,"submitTime":0,"finishTime":1613676534162,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"6a2386a8-3585-4f5b-8d1a-6a221008a3a8"},{"version":"CommandV1","origId":3273046978841255,"guid":"69135718-f30e-4263-b40a-b656a96f86b5","subtype":"script","commandType":"auto","position":4.586206896551724,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534164,"submitTime":0,"finishTime":1613676534187,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"2034a836-ca3b-4e74-9c99-9c5406fae914"},{"version":"CommandV1","origId":3273046978841256,"guid":"e42cf599-eb7f-464e-b920-8a360f521980","subtype":"script","commandType":"auto","position":4.620689655172414,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534190,"submitTime":0,"finishTime":1613676534209,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"fa7038b8-eeae-4faf-b67c-3533f592c4be"},{"version":"CommandV1","origId":3273046978841257,"guid":"512ab974-c2f5-4a37-a7ca-e121541dcb98","subtype":"script","commandType":"auto","position":4.655172413793103,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534212,"submitTime":0,"finishTime":1613676534249,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"f7e130f3-a10c-4be5-b766-bf22f0eaa005"},{"version":"CommandV1","origId":3273046978841258,"guid":"ad26fff3-eecc-491e-9841-fae734adacfe","subtype":"script","commandType":"auto","position":4.689655172413794,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534251,"submitTime":0,"finishTime":1613676534270,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"cd3b7f3c-4cff-4081-8f26-8fee0f0b4dd6"},{"version":"CommandV1","origId":3273046978841259,"guid":"6cb114a7-d6c7-4b6e-a58c-e50de337f35a","subtype":"script","commandType":"auto","position":4.724137931034483,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534272,"submitTime":0,"finishTime":1613676534294,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"4a226d2a-a3e4-4c6d-98fa-85f8ba9827c9"},{"version":"CommandV1","origId":3273046978841260,"guid":"ba4f6e36-731f-4d97-b8cf-41dfc24332cd","subtype":"script","commandType":"auto","position":4.758620689655173,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534296,"submitTime":0,"finishTime":1613676534315,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"e1c71d16-34f1-47f0-bf92-ee4ac052e889"},{"version":"CommandV1","origId":3273046978841261,"guid":"ec259884-d378-46d8-8d6a-25d536a6f002","subtype":"script","commandType":"auto","position":4.793103448275862,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534317,"submitTime":0,"finishTime":1613676534345,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"0b9ccd37-947a-47e6-ae42-d1e165f3c085"},{"version":"CommandV1","origId":3273046978841262,"guid":"bcdd6db8-94a1-4fc9-8867-2d80ec1c9ff2","subtype":"script","commandType":"auto","position":4.827586206896552,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534348,"submitTime":0,"finishTime":1613676534368,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"9e4e7bf9-f126-472c-9fbc-f4e8613533fb"},{"version":"CommandV1","origId":3273046978841263,"guid":"6b22e0d2-a76c-4f44-b1b6-3ecda3b10505","subtype":"script","commandType":"auto","position":4.862068965517241,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534371,"submitTime":0,"finishTime":1613676534393,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"2ebbc8ec-3d9a-4199-8649-df651f2387b6"},{"version":"CommandV1","origId":3273046978841264,"guid":"556507d7-b654-4603-9160-f409e1e4d6f5","subtype":"script","commandType":"auto","position":4.896551724137931,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534396,"submitTime":0,"finishTime":1613676534417,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"019d1fea-41da-4b59-800b-bff77577d419"},{"version":"CommandV1","origId":3273046978841265,"guid":"37708ad8-f0f8-45d1-9938-36d82d4eb4ca","subtype":"script","commandType":"auto","position":4.931034482758621,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534425,"submitTime":0,"finishTime":1613676534459,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"5da50073-429f-401d-b40f-6379eeead438"},{"version":"CommandV1","origId":3273046978841266,"guid":"d243df8f-c387-4060-8283-51839a4b5d14","subtype":"script","commandType":"auto","position":4.9655172413793105,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534462,"submitTime":0,"finishTime":1613676534486,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["24bb6dbe-67cc-4eaa-aa11-bc9574c0f2d1"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"7a379d31-5ff4-4887-8d39-12f09f6645d0"},{"version":"CommandV1","origId":3273046978841267,"guid":"df94a029-2bee-45c8-b66e-52301e7cdf2d","subtype":"command","commandType":"auto","position":5.0,"command":"%md\n#### Widget Setup (params)","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"64d55d72-40e5-4d68-bebd-c1eabacef544"},{"version":"CommandV1","origId":3273046978841268,"guid":"047a6c6b-c686-4b43-8d6a-df595cfb88bb","subtype":"command","commandType":"auto","position":6.0,"command":"#dbutils.widgets.removeAll()\n\ndbutils.widgets.dropdown(\"Execute Query\", \"TRUE\", [\"TRUE\", \"FALSE\"])\ndbutils.widgets.dropdown(\"Return Schema\", \"TRUE\", [\"TRUE\", \"FALSE\"])\ndbutils.widgets.text(\"StageFolderPath\",\"\")\ndbutils.widgets.text(\"Operator\",\"\")\ndbutils.widgets.text(\"SchemaName\",\"\")\ndbutils.widgets.text(\"ObjectName\",\"\")\ndbutils.widgets.text(\"TargetSchema\",\"\")\ndbutils.widgets.text(\"TargetObject\",\"\")\ndbutils.widgets.text(\"ConfigTable\",\"\")\n\nexecute_query = eval(dbutils.widgets.get(\"Execute Query\").title())\ngenerate_schema_output = eval(dbutils.widgets.get(\"Return Schema\").title())\nstage_folder_path = dbutils.widgets.get(\"StageFolderPath\").lower()\njson_config = dbutils.widgets.get(\"ConfigTable\").lower()\noperator = dbutils.widgets.get(\"Operator\").lower()\nsource_schema = dbutils.widgets.get(\"SchemaName\").lower()\nsource_object = dbutils.widgets.get(\"ObjectName\").lower()\ntarget_schema = dbutils.widgets.get(\"TargetSchema\").lower()\ntarget_object = dbutils.widgets.get(\"TargetObject\").lower()\n\nif json_config:\n    configtbl = json.loads(json_config)\nelse:\n    configtbl = ''\n\nprint('Execute query:\\t', execute_query)\nprint('Operator:\\t', operator)\nprint('Stage mnt point:\\t', stage_location)\nprint('Stage folder path:\\t', stage_folder_path)\nprint('Source schema:\\t', source_schema)\nprint('Source object:\\t', source_object)\nprint('Target schema:\\t', target_schema)\nprint('Target object:\\t', target_object)\nprint('Config table:\\t', configtbl)\n\n","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">Execute query:\t True\nOperator:\t \nStage mnt point:\t STAGE\nStage folder path:\t classicbrands_byod/tcinboundrawmessagestaging/2021/2/18/18_51\nSource schema:\t classicbrands_byod\nSource object:\t tcinboundrawmessagestaging\nTarget schema:\t \nTarget object:\t \nConfig table:\t \n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{"TargetObject":"","Operator":"","Return Schema":"TRUE","TargetSchema":"","Execute Query":"TRUE","ObjectName":"tcinboundrawmessagestaging","ConfigTable":"","SchemaName":"classicbrands_byod","StageFolderPath":"classicbrands_byod/tcinboundrawmessagestaging/2021/2/18/18_51"},"addedWidgets":{"TargetObject":{"widgetType":"text","name":"TargetObject","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"Operator":{"widgetType":"text","name":"Operator","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"Return Schema":{"widgetType":"dropdown","name":"Return Schema","defaultValue":"TRUE","label":null,"options":{"widgetType":"dropdown","choices":["TRUE","FALSE"]}},"TargetSchema":{"widgetType":"text","name":"TargetSchema","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"Execute Query":{"widgetType":"dropdown","name":"Execute Query","defaultValue":"TRUE","label":null,"options":{"widgetType":"dropdown","choices":["TRUE","FALSE"]}},"ObjectName":{"widgetType":"text","name":"ObjectName","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"ConfigTable":{"widgetType":"text","name":"ConfigTable","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"SchemaName":{"widgetType":"text","name":"SchemaName","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"StageFolderPath":{"widgetType":"text","name":"StageFolderPath","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534488,"submitTime":1613676533632,"finishTime":1613676534538,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"8551dba3-457e-4ed7-a8c5-e52681dde0bb"},{"version":"CommandV1","origId":3273046978841269,"guid":"420d5cc2-aee3-4da6-81e7-28f413c5f571","subtype":"command","commandType":"auto","position":7.0,"command":"%md\n### Load ConfigTable param\nIf the ConfigTable param was passed in, load it into a Dataframe and then see if it contains a list of columns to use in the load.\n\nIf so, make sure the columns requested are available in the Source Table before proceeding.","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"4eb576c7-805b-48dd-83d8-0c0d914958ca"},{"version":"CommandV1","origId":3273046978841270,"guid":"460b9cdf-be27-4690-aa89-5cbb37422969","subtype":"command","commandType":"auto","position":8.0,"command":"if configtbl:\n    # Use Pandas for easy conversion of JSON to dataframe\n    pdf = pd.DataFrame(configtbl)\n    # Then convert to Spark Dataframe\n    jdf = spark.createDataFrame(pdf)\n\n    # Does the JSON (ConfigTable) contain a Column List?\n    try:\n        col_list = jdf.select(\"columnlist\").rdd.flatMap(lambda x: x).collect()\n        col_list_str = ', '.join(col_list[0])\n\n        # Get a list of source object columns\n        query = f\"describe table {source_schema}.{source_object}\"\n        coldf = spark.sql(query)\n        cols = coldf.select(\"col_name\").rdd.flatMap(lambda x: x).collect()\n        cols_str = str(cols).strip('[]')\n\n        # Diff the columns requested against actual columns\n        diff = list(set(col_list[0]) - set(cols))\n        if diff:\n            raise ValueError(f\"WARNING: The following columns were requested, but do not exist in source table: {source_schema}.{source_object}\\n{diff}\")\n            dbutils.notebook.exit(-1)\n    except:\n        # JSON doesn't contain a column list\n        pass\nelse:\n    col_list_str = ''","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534541,"submitTime":1613676533645,"finishTime":1613676534563,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"cf94867f-f0f6-4d83-8ded-acae1e7a8d6d"},{"version":"CommandV1","origId":3273046978841271,"guid":"1366ee27-baa2-426e-8484-634692c0a89f","subtype":"command","commandType":"auto","position":9.0,"command":"%md\n#### Get the data to copy\nWe're currently using a SQL statement to get the data.  This gives us the flexibility to filter, calculate or cast columns, etc.","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"f38f19e6-fbce-4ff2-84a7-4817f64a69b8"},{"version":"CommandV1","origId":3273046978841272,"guid":"11fba80c-6deb-4e11-acbc-f5a1879f2813","subtype":"command","commandType":"auto","position":10.0,"command":"sourceSchemaAndObject = f'{source_schema}.{source_object}'\n\n# Create DF\n#df = spark.table(sourceSchemaAndObject) \n\n\n# If there is a list of columns requested, use it.  Otherwise select everything.\nif col_list_str:\n    query = f\"SELECT {col_list_str} FROM {source_schema}.{source_object}\"\nelse:\n    query = f\"SELECT * FROM {source_schema}.{source_object}\"\n\n# Create a dataframe from query\ndf = spark.sql(query)\n\n# If we have a current flag in the data, filter out non-current rows.\n# if 'dl_iscurrent' in df.columns:\n#     df = df.filter(\"dl_iscurrent = true\")\n\n# Make sure to update the row hash\ndf_out = df.withColumn(\"dl_rowhash\", F.sha2(F.concat_ws(\"||\", *df.columns), 256))","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[{"name":"df","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"definitiongroup","nullable":true,"type":"string"},{"metadata":{},"name":"executionid","nullable":true,"type":"string"},{"metadata":{},"name":"isselected","nullable":true,"type":"integer"},{"metadata":{},"name":"transferstatus","nullable":true,"type":"integer"},{"metadata":{},"name":"inboundnumber","nullable":true,"type":"integer"},{"metadata":{},"name":"remotenumber","nullable":true,"type":"integer"},{"metadata":{},"name":"mailboxid","nullable":true,"type":"integer"},{"metadata":{},"name":"filename","nullable":true,"type":"string"},{"metadata":{},"name":"filedatestamp","nullable":true,"type":"timestamp"},{"metadata":{},"name":"processdatestamp","nullable":true,"type":"timestamp"},{"metadata":{},"name":"receiveddocument","nullable":true,"type":"string"},{"metadata":{},"name":"tcappserverlist_name","nullable":true,"type":"string"},{"metadata":{},"name":"partition","nullable":true,"type":"string"},{"metadata":{},"name":"syncstartdatetime","nullable":true,"type":"timestamp"},{"metadata":{},"name":"recid","nullable":true,"type":"long"},{"metadata":{},"name":"dl_rowhash","nullable":true,"type":"string"},{"metadata":{},"name":"dl_partitionkey","nullable":true,"type":"string"},{"metadata":{},"name":"dl_iscurrent","nullable":true,"type":"boolean"},{"metadata":{},"name":"dl_recordstartdateutc","nullable":true,"type":"string"},{"metadata":{},"name":"dl_recordenddateutc","nullable":true,"type":"timestamp"},{"metadata":{},"name":"dl_sourcefilename","nullable":true,"type":"string"}],"type":"struct"},"tableIdentifier":null},{"name":"df_out","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"definitiongroup","nullable":true,"type":"string"},{"metadata":{},"name":"executionid","nullable":true,"type":"string"},{"metadata":{},"name":"isselected","nullable":true,"type":"integer"},{"metadata":{},"name":"transferstatus","nullable":true,"type":"integer"},{"metadata":{},"name":"inboundnumber","nullable":true,"type":"integer"},{"metadata":{},"name":"remotenumber","nullable":true,"type":"integer"},{"metadata":{},"name":"mailboxid","nullable":true,"type":"integer"},{"metadata":{},"name":"filename","nullable":true,"type":"string"},{"metadata":{},"name":"filedatestamp","nullable":true,"type":"timestamp"},{"metadata":{},"name":"processdatestamp","nullable":true,"type":"timestamp"},{"metadata":{},"name":"receiveddocument","nullable":true,"type":"string"},{"metadata":{},"name":"tcappserverlist_name","nullable":true,"type":"string"},{"metadata":{},"name":"partition","nullable":true,"type":"string"},{"metadata":{},"name":"syncstartdatetime","nullable":true,"type":"timestamp"},{"metadata":{},"name":"recid","nullable":true,"type":"long"},{"metadata":{},"name":"dl_rowhash","nullable":true,"type":"string"},{"metadata":{},"name":"dl_partitionkey","nullable":true,"type":"string"},{"metadata":{},"name":"dl_iscurrent","nullable":true,"type":"boolean"},{"metadata":{},"name":"dl_recordstartdateutc","nullable":true,"type":"string"},{"metadata":{},"name":"dl_recordenddateutc","nullable":true,"type":"timestamp"},{"metadata":{},"name":"dl_sourcefilename","nullable":true,"type":"string"}],"type":"struct"},"tableIdentifier":null}],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676534566,"submitTime":1613676533665,"finishTime":1613676535107,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"820e9d7e-751b-4f3c-b438-9cc6d6d008cc"},{"version":"CommandV1","origId":3273046978841273,"guid":"83ebdd44-4bfe-49d3-a74e-c9678a8c0492","subtype":"command","commandType":"auto","position":11.0,"command":"%md\n#### Dump Data to Stage","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"1c9f75d4-19c6-4c6c-950b-3352fddfd73e"},{"version":"CommandV1","origId":3273046978841274,"guid":"4ad1d9de-f136-448c-afa4-3b42930ed49c","subtype":"command","commandType":"auto","position":12.0,"command":"# Get date parts for file path\nx = datetime.now()\nyyyy = (x.strftime(\"%Y\"))\nmm = (x.strftime(\"%m\"))\ndd = (x.strftime(\"%d\"))\n\nsaveLocationParts = [\"mnt\", stage_location, stage_folder_path]\nsaveLocation = slash_join(saveLocationParts, True) \ndirectory_list = []\n\nprint(saveLocation)\n\ntry:\n  directory_list = dbutils.fs.ls(saveLocation) \nexcept Exception as inst:\n  # Ignore the error that is raised when the folder path is empty\n  pass\n\n# We do not allow the staging area to be \nif (len(directory_list) > 0):\n  print(directory_list)\n  raise Exception('The staging folder specified is not empty!')\n\n# Write out 60 files for ADW\n# Repartition can increase or decrease the number of files\n# Coalesce can only decrease the number of files\n\nif execute_query:\n    df_out.repartition(60).write.format('ORC').mode(\"overwrite\").option(\"compression\",\"snappy\").save(saveLocation)\n","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">/mnt/STAGE/classicbrands_byod/tcinboundrawmessagestaging/2021/2/18/18_51\n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1613676535110,"submitTime":1613676533681,"finishTime":1613676583283,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"865d9b84-4196-4e34-9a9f-815249229e8c"},{"version":"CommandV1","origId":3273046978841275,"guid":"ad3da4dd-137b-48ee-a232-cfcfb688d916","subtype":"command","commandType":"auto","position":13.0,"command":"%md\n### Get table's schema, translate to SQL datatypes, and send back to ADF\nThis is hopefully a temporary solution, because we have to do a select max(length(<col>)) for every string value to determine the length necessary.\n\nA proper solution would probably be storing the model's schema in the State db, and use that in this step to ensure data is written out in a compatible manner","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"e8777a42-1844-436d-8c6b-537d08b17730"},{"version":"CommandV1","origId":3273046978841276,"guid":"a79e2543-d381-477c-8272-bb2a02fcf37b","subtype":"command","commandType":"auto","position":14.0,"command":"out_str = \"\"\nif generate_schema_output:\n    import math\n\n    output_schema = []\n    str_schema = ''\n    varchar_len_list = [50, 100, 255, 500, 1000, 4000]\n\n    # Get the schema from source object\n    schema_list = df_out.dtypes\n  \n    # Iterate over columns, translating Spark types to SQL, and calculating string lengths\n    for i, c in enumerate(schema_list):\n        col_len = 0\n        #col_name = schema_dict[\"col_name\"][i]\n        #sql_data_type = schema_dict[\"data_type\"][i]\n        col_name = c[0].strip()\n        sql_data_type = c[1]\n        spark_base_type = sql_data_type\n\n        # Find the position of \"(\", and store the data type and length to variables\n        pos = sql_data_type.find(\"(\")\n        col_len = \"\"\n        if pos > 0:\n            spark_base_type = spark_base_type[:pos]\n            col_len = sql_data_type[pos:]\n\n        # Map the Spark datatype to SQL\n        dtype = spark_to_sql_datatype(spark_base_type)\n\n        # If this is a string, we need to know the length, so get the max length from source data\n        # and then \"round up\" to nearest value in list defined above\n        if spark_base_type == 'string':\n            col_spec = df_out.select(max(length(df_out[col_name])).alias(\"maxrowlen\")).rdd.flatMap(lambda x: x).collect()\n            new_len = min(i for i in varchar_len_list if i >= (col_spec[0] or 0)) # handle null/None values\n            output_schema.append(f\"[{col_name}] {dtype}({new_len})\")\n            #print(col_name, col_spec, ':', new_len) # col_spec[\"row_len\"][0])\n        else:\n            output_schema.append(f\"[{col_name}] {dtype}{col_len}\")\n\n    out_str = str(output_schema).strip('[]').replace(\"'\", \"\")\n    print(out_str)\nelse: \n    # We're not generating a schema for output, so just return the file location\n    out_str = saveLocation\n\n","commandVersion":4,"state":"error","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":"<span class=\"ansi-red-fg\">ValueError</span>: min() arg is an empty sequence","errorTraceType":null,"error":"<div class=\"ansiout\"><span class=\"ansi-red-fg\">---------------------------------------------------------------------------</span>\n<span class=\"ansi-red-fg\">ValueError</span>                                Traceback (most recent call last)\n<span class=\"ansi-green-fg\">&lt;command-3769925866938378&gt;</span> in <span class=\"ansi-cyan-fg\">&lt;module&gt;</span>\n<span class=\"ansi-green-intense-fg ansi-bold\">     33</span>         <span class=\"ansi-green-fg\">if</span> spark_base_type <span class=\"ansi-blue-fg\">==</span> <span class=\"ansi-blue-fg\">&#39;string&#39;</span><span class=\"ansi-blue-fg\">:</span>\n<span class=\"ansi-green-intense-fg ansi-bold\">     34</span>             col_spec <span class=\"ansi-blue-fg\">=</span> df_out<span class=\"ansi-blue-fg\">.</span>select<span class=\"ansi-blue-fg\">(</span>max<span class=\"ansi-blue-fg\">(</span>length<span class=\"ansi-blue-fg\">(</span>df_out<span class=\"ansi-blue-fg\">[</span>col_name<span class=\"ansi-blue-fg\">]</span><span class=\"ansi-blue-fg\">)</span><span class=\"ansi-blue-fg\">)</span><span class=\"ansi-blue-fg\">.</span>alias<span class=\"ansi-blue-fg\">(</span><span class=\"ansi-blue-fg\">&#34;maxrowlen&#34;</span><span class=\"ansi-blue-fg\">)</span><span class=\"ansi-blue-fg\">)</span><span class=\"ansi-blue-fg\">.</span>rdd<span class=\"ansi-blue-fg\">.</span>flatMap<span class=\"ansi-blue-fg\">(</span><span class=\"ansi-green-fg\">lambda</span> x<span class=\"ansi-blue-fg\">:</span> x<span class=\"ansi-blue-fg\">)</span><span class=\"ansi-blue-fg\">.</span>collect<span class=\"ansi-blue-fg\">(</span><span class=\"ansi-blue-fg\">)</span>\n<span class=\"ansi-green-fg\">---&gt; 35</span><span class=\"ansi-red-fg\">             </span>new_len <span class=\"ansi-blue-fg\">=</span> min<span class=\"ansi-blue-fg\">(</span>i <span class=\"ansi-green-fg\">for</span> i <span class=\"ansi-green-fg\">in</span> varchar_len_list <span class=\"ansi-green-fg\">if</span> i <span class=\"ansi-blue-fg\">&gt;=</span> <span class=\"ansi-blue-fg\">(</span>col_spec<span class=\"ansi-blue-fg\">[</span><span class=\"ansi-cyan-fg\">0</span><span class=\"ansi-blue-fg\">]</span> <span class=\"ansi-green-fg\">or</span> <span class=\"ansi-cyan-fg\">0</span><span class=\"ansi-blue-fg\">)</span><span class=\"ansi-blue-fg\">)</span> <span class=\"ansi-red-fg\"># handle null/None values</span>\n<span class=\"ansi-green-intense-fg ansi-bold\">     36</span>             output_schema<span class=\"ansi-blue-fg\">.</span>append<span class=\"ansi-blue-fg\">(</span><span class=\"ansi-blue-fg\">f&#34;[{col_name}] {dtype}({new_len})&#34;</span><span class=\"ansi-blue-fg\">)</span>\n<span class=\"ansi-green-intense-fg ansi-bold\">     37</span>             <span class=\"ansi-red-fg\">#print(col_name, col_spec, &#39;:&#39;, new_len) # col_spec[&#34;row_len&#34;][0])</span>\n\n<span class=\"ansi-red-fg\">ValueError</span>: min() arg is an empty sequence</div>","workflows":[],"startTime":1613677351547,"submitTime":1613677351547,"finishTime":1613677368890,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"0aa46d74-95fd-4242-9ef1-e9888e0a84f2"},{"version":"CommandV1","origId":3273046978841277,"guid":"7400d09d-c3fa-4c29-be14-e21817b4689b","subtype":"command","commandType":"auto","position":14.5,"command":"","commandVersion":0,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"e8f13209-0629-457b-ac1e-5669829d0517"},{"version":"CommandV1","origId":3273046978841278,"guid":"df7e0e2f-fb3f-4a19-ba46-5b3197f24203","subtype":"command","commandType":"auto","position":15.0,"command":"dbutils.notebook.exit(out_str)","commandVersion":1,"state":"error","results":null,"errorSummary":"Command skipped","errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533698,"submitTime":1613676533698,"finishTime":1613676601128,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"d39a7125-1eee-4ac7-9db2-42c4e8451f6c"},{"version":"CommandV1","origId":3273046978841279,"guid":"aab098d4-b7f5-466c-b7ef-d8e7d1c43dd9","subtype":"command","commandType":"auto","position":16.0,"command":"%md\n### Testing","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"ad726137-b20a-41e2-8ce0-560013f26366"},{"version":"CommandV1","origId":3273046978841280,"guid":"fc6656a5-6757-428e-9378-d648231d197a","subtype":"command","commandType":"auto","position":17.0,"command":"df_sch = spark.sql(f\"describe table {source_schema}.{source_object}\")\ndf_sch = df_sch.select(\"col_name\", \"data_type\")\nschema_dict = dataframeToDict(df_sch)\nprint(schema_dict)","commandVersion":1,"state":"error","results":null,"errorSummary":"Command skipped","errorTraceType":null,"error":null,"workflows":[],"startTime":1613676533711,"submitTime":1613676533711,"finishTime":1613676601138,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"2a23fb5e-d204-42e4-933b-00779a940d60"}],"dashboards":[],"guid":"1639a1a3-3997-4e11-9730-85b7a44d5976","globalVars":{},"iPythonMetadata":{},"inputWidgets":{"CandidateKey":{"nuid":"640c5ca8-a02a-425f-9956-32dcb51d84d7","currentValue":"","widgetInfo":{"widgetType":"text","name":"CandidateKey","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"TargetObject":{"nuid":"c63ce811-5d55-48a6-8160-a5da21934292","currentValue":"","widgetInfo":{"widgetType":"text","name":"TargetObject","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"Operator":{"nuid":"b227774a-c7ed-42db-b4b6-118e8a69ab14","currentValue":"","widgetInfo":{"widgetType":"text","name":"Operator","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"SourceObject":{"nuid":"ffce37f1-e2c8-4eb9-8ea6-b2401d9414f1","currentValue":"","widgetInfo":{"widgetType":"text","name":"SourceObject","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"Return Schema":{"nuid":"f8081e8a-4ae9-40de-b510-a9946cec335d","currentValue":"TRUE","widgetInfo":{"widgetType":"dropdown","name":"Return Schema","defaultValue":"TRUE","label":null,"options":{"widgetType":"dropdown","choices":["TRUE","FALSE"]}}},"SourceSchema":{"nuid":"f6b148b5-f0b6-4ac1-94b5-13f14590153a","currentValue":"","widgetInfo":{"widgetType":"text","name":"SourceSchema","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"PartitionKey":{"nuid":"3abbe363-aa48-4229-bb96-cbdcf2c1a148","currentValue":"","widgetInfo":{"widgetType":"text","name":"PartitionKey","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"TargetSchema":{"nuid":"d879f4a3-ab1a-4b62-a6c5-0ebddbd2ae73","currentValue":"","widgetInfo":{"widgetType":"text","name":"TargetSchema","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"preprocessingParams":{"nuid":"15e46c6f-76ae-49e6-8f2d-3ce6827a702b","currentValue":"","widgetInfo":{"widgetType":"text","name":"preprocessingParams","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"fileType":{"nuid":"9e1b0ee3-d67b-45d8-be1f-1ff10dc6b328","currentValue":"","widgetInfo":{"widgetType":"text","name":"fileType","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"Execute Query":{"nuid":"2d40d270-1fbb-426a-b6bd-fb0181c85805","currentValue":"TRUE","widgetInfo":{"widgetType":"dropdown","name":"Execute Query","defaultValue":"TRUE","label":null,"options":{"widgetType":"dropdown","choices":["TRUE","FALSE"]}}},"ObjectName":{"nuid":"4ffc286c-7e56-42ef-9666-789cf1586bfb","currentValue":"tcinboundrawmessagestaging","widgetInfo":{"widgetType":"text","name":"ObjectName","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"fileHeader":{"nuid":"eeea76a4-8453-43bd-8f43-f426f63f97b0","currentValue":"","widgetInfo":{"widgetType":"text","name":"fileHeader","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"ConfigTable":{"nuid":"9ab08669-226a-450b-960b-10b97645903a","currentValue":"","widgetInfo":{"widgetType":"text","name":"ConfigTable","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"filePath":{"nuid":"a3114104-b6cc-4032-b023-bf98b3e75b49","currentValue":"","widgetInfo":{"widgetType":"text","name":"filePath","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"SchemaName":{"nuid":"4ef90bbf-6bf2-4df7-8557-36bb9baa40c3","currentValue":"classicbrands_byod","widgetInfo":{"widgetType":"text","name":"SchemaName","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"dateFormat":{"nuid":"9fa248db-74c7-453a-a841-128c0996dc15","currentValue":"","widgetInfo":{"widgetType":"text","name":"dateFormat","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"batchId":{"nuid":"20bea4fd-5dad-4fac-aec1-8ac87513abd3","currentValue":"","widgetInfo":{"widgetType":"text","name":"batchId","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"StageFolderPath":{"nuid":"9197fbf5-0211-43e5-973d-138517db59bb","currentValue":"classicbrands_byod/tcinboundrawmessagestaging/2021/2/18/18_51","widgetInfo":{"widgetType":"text","name":"StageFolderPath","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"fileSchema":{"nuid":"71ccbe26-597d-487e-98eb-fb799ef653e3","currentValue":"","widgetInfo":{"widgetType":"text","name":"fileSchema","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"fileFormat":{"nuid":"f7a804ca-7dc8-41ec-9367-a5b38dd86f6f","currentValue":"","widgetInfo":{"widgetType":"text","name":"fileFormat","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}}},"notebookMetadata":{"pythonIndentUnit":2}}