{"version":"NotebookV1","origId":3919740296814989,"name":"TransformandLoadStage","language":"python","commands":[{"version":"CommandV1","origId":1193393201214270,"guid":"b72d6bd7-72bb-4a51-bfc3-b31f3d394da0","subtype":"command","commandType":"auto","position":11.5,"command":"meta_data_cols = ['dl_rowhash', 'dl_iscurrent', 'dl_recordstartdateutc', 'dl_recordenddateutc', 'dl_sourcefilename']\n\n### Add Ingestion Metadata Columns (DL_*) to Transformed output\n\nsrc_tbls = (jdf\n            .select(\"sourceobject\", \"operationtype\", \"uniongroup\", \"stage\")\n            .filter(jdf[\"operationtype\"] != 'relationship')\n            .join(jdf.selectExpr(\"sourceobject as so\", \"joingroup\", \"operationtype as ot\", \"uniongroup as ug\")\n                    .alias(\"so\")\n                    .filter(\"ot == 'relationship'\")\n                  #, \"sourceobject\", how='left')\n                  , ((col(\"sourceobject\")==col(\"so\")) | (col(\"sourceobject\")==col(\"joingroup\"))), how='left')\n            .filter(\"ot is null\")\n            .distinct()\n            .select(\"stage\", \"uniongroup\", \"sourceobject\" )\n            .filter(\"stage!=1 or sourceobject is not null\")\n            .distinct()\n            .sort(\"stage\",\"uniongroup\")\n            .select(\"stage\", \"uniongroup\", \"sourceobject\" )\n            #.filter(\"stage!= 0 or sourceobject is not null or uniongroup is not null\")\n            .filter(\"NOT (stage=0 AND sourceobject is null)\")\n            .collect()\n)\n\nprint(src_tbls)","commandVersion":6,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">[Row(stage=&#39;0&#39;, uniongroup=&#39;0&#39;, sourceobject=&#39;EcoResReleasedProductV2Staging&#39;)]\n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763405999,"submitTime":1623763403069,"finishTime":1623763406788,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"69d862c8-4806-4e8e-8ae9-d7061f559d40"},{"version":"CommandV1","origId":3919740296814990,"guid":"15a1ec16-5a65-414e-a796-d975077881cb","subtype":"command","commandType":"auto","position":2.0,"command":"from pyspark.sql.functions import *\nfrom pyspark.sql.types import *\nfrom pyspark.sql.window import * #import Window\nimport pandas as pd #Used to greatly simplify converting JSON payload into a dataframe\nimport json\nimport os \n\n# Necessary SESSION-level setting due to changes in Spark 3.0 date/time parsing\n# The alternative is fixing all transformations with string->date parsing\nspark.conf.set(\"spark.sql.legacy.timeParserPolicy\", \"legacy\")\n\ndelta_location = \"DELTA\"\nstage_location = \"STAGE\"\n\nunmapped_string = \"[UnmappedValue]\"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403667,"submitTime":1623763402955,"finishTime":1623763403691,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"769d9dda-4c65-4911-ab92-33fa1bb7d9e0"},{"version":"CommandV1","origId":3919740296814991,"guid":"231df6d7-c26c-4ae9-93f0-d25804ce4135","subtype":"command","commandType":"auto","position":3.0,"command":"%md\n#### Include the common set of utility functions","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"118f6e4f-bbc6-418b-9045-30ae025cbeb0"},{"version":"CommandV1","origId":3919740296814992,"guid":"4d3db74e-43c0-4cc4-aca9-45edba1a0935","subtype":"command","commandType":"auto","position":4.0,"command":"%run /DataEngineering/SharedUtils","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763402975,"submitTime":1623763402975,"finishTime":1623763404769,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"44f995bf-467a-4097-a928-867b5b112c50"},{"version":"CommandV1","origId":3919740296815022,"guid":"17aae837-3f8b-44df-ab83-a2946787ad94","subtype":"command","commandType":"auto","position":5.0,"command":"%md\n#### Widgets","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"58254345-14e7-438c-9fde-533447a56183"},{"version":"CommandV1","origId":3919740296815023,"guid":"9d511329-8ec9-4121-aa0a-ce125c2c090e","subtype":"command","commandType":"auto","position":6.0,"command":"#dbutils.widgets.removeAll()","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404466,"submitTime":1623763403025,"finishTime":1623763404483,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"7cc782a6-59d3-41d4-8b70-ae79efa0a42d"},{"version":"CommandV1","origId":3919740296815024,"guid":"8d0fd15f-e12a-47b6-bd94-e81e9b47cc39","subtype":"command","commandType":"auto","position":7.0,"command":"dbutils.widgets.dropdown(\"Adhoc Mode\", \"FALSE\", [\"TRUE\", \"FALSE\"])\ndbutils.widgets.dropdown(\"Execute Query\", \"TRUE\", [\"TRUE\", \"FALSE\"])\ndbutils.widgets.text(\"ConfigTable\",\"\")\ndbutils.widgets.text(\"CodeMapTable\",\"\")\ndbutils.widgets.text(\"Operator\",\"\")\ndbutils.widgets.text(\"TargetSchema\",\"\")\ndbutils.widgets.text(\"TargetObject\",\"\")\ndbutils.widgets.text(\"SourceSchema\",\"\")\ndbutils.widgets.text(\"SourceObject\",\"\")\n\n# Get Widget values\nadhoc_mode = eval(dbutils.widgets.get(\"Adhoc Mode\").title())\nexecute_query = eval(dbutils.widgets.get(\"Execute Query\").title())\npcfg_table = dbutils.widgets.get(\"ConfigTable\")\n\ntry:\n    config_table = decompress_string(pcfg_table)\nexcept:\n    config_table = pcfg_table\n\ncodemap_table = dbutils.widgets.get(\"CodeMapTable\") # Don't lower case this because it might be a file reference\n\noperator = dbutils.widgets.get(\"Operator\").lower()\ntarget_schema = dbutils.widgets.get(\"TargetSchema\").lower()\ntarget_object = dbutils.widgets.get(\"TargetObject\")#.lower()\nsource_schema = dbutils.widgets.get(\"SourceSchema\").lower()\nsource_object = dbutils.widgets.get(\"SourceObject\")#.lower()\n\nprint('Adhoc mode:\\t', adhoc_mode)\nprint('Operator:\\t', operator)\nprint('Source schema:\\t', source_schema)\nprint('Source object:\\t', source_object)\nprint('Target schema:\\t', target_schema)\nprint('Target object:\\t', target_object)\nprint('Config table:\\n', config_table)\nprint('Code map table:\\n', codemap_table)","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">Adhoc mode:\t False\nOperator:\t testte\nSource schema:\t classicbrandssilver\nSource object:\t EcoResReleasedProductV2Staging\nTarget schema:\t empower_stage\nTarget object:\t tmp_dim_dim_product\nConfig table:\n /RAW/product_transformation_rule.csv\nCode map table:\n \n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{"TargetObject":"tmp_dim_dim_product","Operator":"TestTE","SourceObject":"EcoResReleasedProductV2Staging","SourceSchema":"classicbrandssilver","CodeMapTable":"","TargetSchema":"empower_stage","Adhoc Mode":"FALSE","Execute Query":"TRUE","ConfigTable":"/RAW/product_transformation_rule.csv"},"addedWidgets":{"TargetObject":{"widgetType":"text","name":"TargetObject","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"Operator":{"widgetType":"text","name":"Operator","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"SourceObject":{"widgetType":"text","name":"SourceObject","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"SourceSchema":{"widgetType":"text","name":"SourceSchema","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"CodeMapTable":{"widgetType":"text","name":"CodeMapTable","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"TargetSchema":{"widgetType":"text","name":"TargetSchema","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}},"Adhoc Mode":{"widgetType":"dropdown","name":"Adhoc Mode","defaultValue":"FALSE","label":null,"options":{"widgetType":"dropdown","choices":["TRUE","FALSE"]}},"Execute Query":{"widgetType":"dropdown","name":"Execute Query","defaultValue":"TRUE","label":null,"options":{"widgetType":"dropdown","choices":["TRUE","FALSE"]}},"ConfigTable":{"widgetType":"text","name":"ConfigTable","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404489,"submitTime":1623763403029,"finishTime":1623763404534,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"54123201-4298-42cf-a19f-f10bbc20224e"},{"version":"CommandV1","origId":3919740296815025,"guid":"921fe2c5-2ef0-4cf7-8c42-efe56b98d27b","subtype":"command","commandType":"auto","position":8.0,"command":"%md\n### Bail out if the ConfigTable param is empty","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"28ba723b-0ee1-4cf9-90ef-a730c629c622"},{"version":"CommandV1","origId":3919740296815026,"guid":"adb3a928-704b-4d80-b7bd-8b6e1029480c","subtype":"command","commandType":"auto","position":9.0,"command":"if not config_table:\n    raise ValueError(\"The ConfigTable parameter must be provided!\") \n    dbutils.notebook.exit(-1)","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404541,"submitTime":1623763403046,"finishTime":1623763404558,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"18170a9a-c2de-4255-9d42-0a291c264c53"},{"version":"CommandV1","origId":3919740296815027,"guid":"05fb5d84-897b-4763-ab46-2dee244d0454","subtype":"command","commandType":"auto","position":10.0,"command":"%md\n### Load ConfigTable param\nIf the ConfigTable param was passed in, load it into a Dataframe, and create a view on it","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"57323985-e36d-4559-8cda-b663bab99fc0"},{"version":"CommandV1","origId":3919740296815028,"guid":"31d939e9-950e-4160-bae2-4e7f00f0ba3e","subtype":"command","commandType":"auto","position":11.0,"command":"jdf = None\n\n# Check to see if anything was passed into the ConfigTable param\nif config_table:\n\n    # First let's see if this parses as JSON\n    try:\n        # Convert JSON payload into list\n        #json_dict = json.loads(config_table)\n        config_table_load = config_table #.lower()\n        configtbl_list = json.loads(config_table_load)\n\n        pdf = pd.DataFrame(configtbl_list)\n        \n        pdf_schema = StructType()\n        for item in pdf.columns:\n            if item.lower() == 'codemapped':\n                pdf_schema.add(item, BooleanType())\n            elif item.lower() == 'stage':\n                pdf_schema.add(item, StringType())\n            else:\n              pdf_schema.add(item, StringType())\n\n        #print(pdf_schema)\n        jdf = spark.createDataFrame(pdf, pdf_schema)        \n    except:\n        #Not JSON, so assuming a file reference\n\n        #Add Databricks/dbfs root mount point to file name\n        args = [\"mnt\", config_table]\n        theFile = slash_join(args, True)  # handles existing leading slash (or not)\n        configtbl_file = theFile\n        \n        if not file_exists(configtbl_file):\n            raise ValueError(\"The ConfigTable file provided does not exist!\") \n            dbutils.notebook.exit(-1)        \n            \n        print(f\"Loading file from {configtbl_file}\")\n\n        # Read the file\n        if configtbl_file.endswith(\".csv\"):\n            jdf = (spark \n                        .read \n                        .format('csv') \n                        .option(\"header\", \"true\") \n                        .option(\"inferSchema\", \"true\") \n                        .load(configtbl_file)\n                      )\n        elif configtbl_file.endswith(\".orc\"):\n            jdf = (spark.read\n                        .format('orc')\n                        .load(configtbl_file)\n                     )\n\n        if jdf.count() == 0:\n            raise ValueError(\"The ConfigTable file provided contains no records!\") \n            dbutils.notebook.exit(-1)        \n\n    #jdf = jdf.withColumn(\"rownum\", row_number().over(Window.orderBy(lit(None)))) # wasn't maintaining original order\n    jdf = jdf.withColumn(\"rownum\", row_number().over(Window.orderBy(monotonically_increasing_id())))\n    pdf_schema = jdf.schema\n\n    # Clean up column names (and convert to lower case)\n    new_column_name_list = list(map(lambda x: strip_string(x, \"\", True), jdf.columns))\n    str_clean_cols = str(new_column_name_list).strip(\"[]\")\n\n    # Assign cleaned column names to existing dataframe\n    jdf = jdf.toDF(*new_column_name_list)\n\n    #if not 'stage' in jdf.columns:\n    #    jdf = jdf.withColumn('stage', lit(0))\n    #if not 'codemapped' in jdf.columns:\n    #    jdf = jdf.withColumn('codemapped', lit(False))\n\n    #jdf = jdf.withColumn('stage', col(\"stage\").cast(IntegerType()))\n    #jdf = jdf.withColumn('uniongroup', col(\"uniongroup\").cast(IntegerType()))\n    #jdf = jdf.na.fill(0)\n    jdf = jdf.fillna({'stage':'0', 'uniongroup':'0'})\n    #jdf = jdf.withColumn('codemapped', col(\"codemapped\").cast(BooleanType()))\n\n    #Add a row number for incoming rows to maintain order of columns in output\n    #jdf = jdf.withColumn(\"rownum\", row_number().over(Window.orderBy(lit(None))))\n\n    # Convert contents to lower case\n    check_cols = [\"operationtype\", \"sourceschema\", \"transformationtype\"]\n    for c, dt in jdf.dtypes:\n        if c in check_cols and dt == 'string':\n            jdf = jdf.withColumn(c, ltrim(rtrim(lower(col(c)))))\n\n    configtbl_dict = dataframeToDict(jdf)\n\n    jdf.show(10)\n    #display(jdf)","commandVersion":5,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">Loading file from /mnt/RAW/product_transformation_rule.csv\n+----------+----------------+--------+-------------+-------------------+--------------------+-------------------+--------------------+------------------+----------+---------+-----+------------------+--------------------+----------+------+\n|databaseid|   operationtype|operator| targetschema|       targetobject|     targetattribute|       sourceschema|        sourceobject|   sourceattribute|uniongroup|joingroup|stage|transformationtype|      transformation|codemapped|rownum|\n+----------+----------------+--------+-------------+-------------------+--------------------+-------------------+--------------------+------------------+----------+---------+-----+------------------+--------------------+----------+------+\n|         1|attributemapping|  TestTE|empower_stage|tmp_dim_dim_product|         product_key|classicbrandssilver|EcoResReleasedPro...|              null|         0|     null|    0|              ansi|ROW_NUMBER() OVER...|      null|     1|\n|         1|attributemapping|  TestTE|empower_stage|tmp_dim_dim_product|          product_id|classicbrandssilver|EcoResReleasedPro...|     PRODUCTNUMBER|         0|     null|    0|              null|                null|      null|     2|\n|         1|attributemapping|  TestTE|empower_stage|tmp_dim_dim_product|        product_name|classicbrandssilver|EcoResProductV2St...|       PRODUCTNAME|         0|     null|    0|              null|                null|      null|     3|\n|         1|attributemapping|  TestTE|empower_stage|tmp_dim_dim_product|             item_id|classicbrandssilver|EcoResReleasedPro...|        ITEMNUMBER|         0|     null|    0|              null|                null|      null|     4|\n|         1|attributemapping|  TestTE|empower_stage|tmp_dim_dim_product|          parent_sku|classicbrandssilver|EcoResReleasedPro...|              null|         0|     null|    0|              ansi|CASE WHEN LOCATE(...|      null|     5|\n|         1|attributemapping|  TestTE|empower_stage|tmp_dim_dim_product| product_description|classicbrandssilver|EcoResProductV2St...|PRODUCTDESCRIPTION|         0|     null|    0|              null|                null|      null|     6|\n|         1|attributemapping|  TestTE|empower_stage|tmp_dim_dim_product|        product_type|classicbrandssilver|EcoResReleasedPro...|       PRODUCTTYPE|         0|     null|    0|              null|                null|      null|     7|\n|         1|attributemapping|  TestTE|empower_stage|tmp_dim_dim_product|product_type_desc...|classicbrandssilver|CBAllEnumsForExpo...|     enumitemlabel|         0|     null|    0|              null|                null|      null|     8|\n|         1|attributemapping|  TestTE|empower_stage|tmp_dim_dim_product|    product_sub_type|classicbrandssilver|EcoResReleasedPro...|    PRODUCTSUBTYPE|         0|     null|    0|              null|                null|      null|     9|\n|         1|attributemapping|  TestTE|empower_stage|tmp_dim_dim_product|product_sub_type_...|classicbrandssilver|EcoResReleasedPro...|              null|         0|     null|    0|          constant|        &#39;NOT MAPPED&#39;|      null|    10|\n+----------+----------------+--------+-------------+-------------------+--------------------+-------------------+--------------------+------------------+----------+---------+-----+------------------+--------------------+----------+------+\nonly showing top 10 rows\n\n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[{"name":"jdf","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"databaseid","nullable":true,"type":"integer"},{"metadata":{},"name":"operationtype","nullable":true,"type":"string"},{"metadata":{},"name":"operator","nullable":true,"type":"string"},{"metadata":{},"name":"targetschema","nullable":true,"type":"string"},{"metadata":{},"name":"targetobject","nullable":true,"type":"string"},{"metadata":{},"name":"targetattribute","nullable":true,"type":"string"},{"metadata":{},"name":"sourceschema","nullable":true,"type":"string"},{"metadata":{},"name":"sourceobject","nullable":true,"type":"string"},{"metadata":{},"name":"sourceattribute","nullable":true,"type":"string"},{"metadata":{},"name":"uniongroup","nullable":false,"type":"string"},{"metadata":{},"name":"joingroup","nullable":true,"type":"string"},{"metadata":{},"name":"stage","nullable":false,"type":"string"},{"metadata":{},"name":"transformationtype","nullable":true,"type":"string"},{"metadata":{},"name":"transformation","nullable":true,"type":"string"},{"metadata":{},"name":"codemapped","nullable":true,"type":"string"},{"metadata":{},"name":"rownum","nullable":true,"type":"integer"}],"type":"struct"},"tableIdentifier":null}],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404564,"submitTime":1623763403065,"finishTime":1623763405991,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"2793","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"831bb832-142b-4345-b020-0fc006dc56d9"},{"version":"CommandV1","origId":3919740296815029,"guid":"f900713e-6ff2-46e1-a544-509cc8c3ae4d","subtype":"command","commandType":"auto","position":12.0,"command":"meta_data_cols = ['dl_rowhash', 'dl_iscurrent', 'dl_recordstartdateutc', 'dl_recordenddateutc', 'dl_sourcefilename']\n\n### Add Ingestion Metadata Columns (DL_*) to Transformed output\n\nsrc_tbls = (jdf\n            .select(\"sourceobject\", \"operationtype\", \"uniongroup\", \"stage\")\n            .filter(jdf[\"operationtype\"] != 'relationship')\n            .join(jdf.selectExpr(\"sourceobject as so\", \"joingroup\", \"operationtype as ot\", \"uniongroup as ug\")\n                    .alias(\"so\")\n                    .filter(\"ot == 'relationship'\")\n                  #, \"sourceobject\", how='left')\n                  , ((col(\"sourceobject\")==col(\"so\")) | (col(\"sourceobject\")==col(\"joingroup\"))), how='left')\n            .filter(\"ot is null\")\n            .distinct()\n            .select(\"stage\", \"uniongroup\", \"sourceobject\" )\n            .filter(\"stage!=1 or sourceobject is not null\")\n            .distinct()\n            .sort(\"stage\",\"uniongroup\")\n            .select(\"stage\", \"uniongroup\", \"sourceobject\" )\n            #.filter(\"stage!= 0 or sourceobject is not null or uniongroup is not null\")\n            .filter(\"NOT (stage=0 AND sourceobject is null)\")\n            .collect()\n)\n\n#Grag the max row number in the dataset, so when we add the metadata columns, we can continue from there\nmax_rownum = jdf.selectExpr(\"max(rownum) as max_rownum\").collect()[0][\"max_rownum\"]\nmax_rownum = int(max_rownum)\n\nstages = jdf.selectExpr(\"cast(stage as int)\").alias(\"stage\").distinct().sort(\"stage\").collect()\nstage_list = []\nfor s in stages:\n    stage_list.append(s[\"stage\"])\n\nif stage_list[0] == None:\n    stage_list[0] = 0\n\n# Get a list of keys in the dictionary, so we don't blow up \ndict_keys = []\nfor x in configtbl_dict:\n    dict_keys.append(x)\n\nfor t in src_tbls:\n    source_table_name = t[\"sourceobject\"]\n    source_union_group = t[\"uniongroup\"] or 0\n    source_stage = t[\"stage\"]\n    \n    if not (source_stage == 0 and source_table_name == None): #and source_union_group == None \n        #print(\"LOOPING: source table\", source_table_name, \"source union\", source_union_group, \"source stage\", source_stage)\n\n        #print(f\"t: {t},  sourceobject: {source_table_name}\")\n        #We're only going to add metadata columns for the main source table, or for each Stage group\n        #if len(stage_list) > 1 or (len(stage_list) == 1 and source_table_name != None):\n            #print(source_table_name)\n            # Iterate through the dictionary of Transformations.  Once we find a row\n            # that matches the source table, grab the values and then add the additional\n            # DL_* columns to the dictionary.  This is so we have them included for the\n            # rest of the Transformation process.\n        \n        for i in range(0, len(configtbl_dict['targetattribute'])):\n            ts = target_schema\n            to = target_object\n            if 'operationtype' in dict_keys:\n                ot = (configtbl_dict['operationtype'][i] or '')\n            if 'targetattribute' in dict_keys:\n                ta = (configtbl_dict['targetattribute'][i] or '')\n            if 'sourceschema' in dict_keys:\n                sd = (configtbl_dict['sourceschema'][i] or '')\n            if 'sourceobject' in dict_keys:\n                so = (configtbl_dict['sourceobject'][i] or None)\n            if 'sourceattribute' in dict_keys:\n                sc = (configtbl_dict['sourceattribute'][i] or '')\n            if 'transformationtype' in dict_keys:\n                xft = (configtbl_dict['transformationtype'][i] or '')\n            if 'transformation' in dict_keys:\n                xf = (configtbl_dict['transformation'][i] or '')\n            if 'codemapped' in dict_keys:\n                cm = (configtbl_dict['codemapped'][i] or '')\n            if 'uniongroup' in dict_keys:\n                ug = (configtbl_dict['uniongroup'][i] or 0)\n            if 'joingroup' in dict_keys:\n                jg = (configtbl_dict['joingroup'][i] or None)\n            if 'stage' in dict_keys:\n                st = (configtbl_dict['stage'][i] or 0)\n\n            #print(f\"t {t}, so {so}, stage {st} source_stage {source_stage}\")\n            #print(f\"so {so}, source_table_name {source_table_name}, ot {ot}, ug {ug}, source_union_group {source_union_group}, st {st} source_stage {source_stage}\")\n            if so == source_table_name and ot == 'attributemapping' and ug == source_union_group and st == source_stage: # or so == None :\n                #print(f\"inside metadata if..... so {so}, source_table_name {source_table_name}, ot {ot}, ug {ug}, source_union_group {source_union_group}, st {st} source_stage {source_stage}\")\n                #print(f\"inside if so==.... so {so}, source_table_name {source_table_name}, ot {ot}, ug {ug}, source_union_group {source_union_group}, st {st} source_stage {source_stage}\")\n                for c in meta_data_cols:\n                    max_rownum += 1\n                    if 'operationtype' in dict_keys:\n                        configtbl_dict[\"operationtype\"]\t\t=\t(*configtbl_dict[\"operationtype\"], ot)\n                    if 'targetattribute' in dict_keys:\n                        configtbl_dict[\"targetattribute\"]\t=\t(*configtbl_dict[\"targetattribute\"], c)\n                    if 'sourceschema' in dict_keys:\n                        configtbl_dict[\"sourceschema\"]\t\t=\t(*configtbl_dict[\"sourceschema\"], sd)\n                    if 'sourceobject' in dict_keys:\n                        configtbl_dict[\"sourceobject\"]\t\t=\t(*configtbl_dict[\"sourceobject\"], so)\n                    if 'sourceattribute' in dict_keys:\n                        configtbl_dict[\"sourceattribute\"]\t=\t(*configtbl_dict[\"sourceattribute\"], c)\n                    if 'transformationtype' in dict_keys:\n                        configtbl_dict[\"transformationtype\"]=\t(*configtbl_dict[\"transformationtype\"], None)\n                    if 'transformation' in dict_keys:\n                        configtbl_dict[\"transformation\"]\t=\t(*configtbl_dict[\"transformation\"], None)\n                    if 'codemapped' in dict_keys:\n                        configtbl_dict[\"codemapped\"]\t\t=\t(*configtbl_dict[\"codemapped\"], False)\n                    if 'uniongroup' in dict_keys:\n                        configtbl_dict[\"uniongroup\"]\t\t=\t(*configtbl_dict[\"uniongroup\"], int(ug))\n                    if 'joingroup' in dict_keys:\n                        configtbl_dict[\"joingroup\"]\t\t    =\t(*configtbl_dict[\"joingroup\"], jg)\n                    if 'stage' in dict_keys:\n                        configtbl_dict[\"stage\"]\t\t        =\t(*configtbl_dict[\"stage\"], int(st))\n                    if 'rownum' in dict_keys:\n                        configtbl_dict[\"rownum\"]\t\t    =\t(*configtbl_dict[\"rownum\"], max_rownum)\n\n                break\n\n# This fixes dictionary where array lengths differ so it can be loaded into dataframe\n#pdf = pd.DataFrame(dict([ (k,pd.Series(v)) for k,v in configtbl_dict.items() ]))        \npdf = pd.DataFrame.from_dict(configtbl_dict, orient='index').transpose()\n\npdf['uniongroup'] = pdf['uniongroup'].astype(int)\npdf['stage'] = pdf['stage'].astype(int)\n\n\n\npdf_schema = StructType()\nfor item in pdf.columns:\n    if item.lower() == 'codemapped':\n        pdf_schema.add(item, BooleanType())\n    elif item.lower() == 'stage':\n        pdf_schema.add(item, IntegerType())\n    elif item.lower() == 'uniongroup':\n        pdf_schema.add(item, IntegerType())\n    elif item.lower() == 'rownum':\n        pdf_schema.add(item, IntegerType())\n    else:\n        pdf_schema.add(item, StringType())\n\njdf = spark.createDataFrame(pdf, pdf_schema)\n\n#jdf = jdf.withColumn('stage', col(\"stage\").cast(IntegerType()))\n#jdf = jdf.na.fill(0)\njdf = jdf.withColumn('operator', lit(operator))\njdf = jdf.withColumn('targetschema', lit(target_schema))\njdf = jdf.withColumn('targetobject', lit(target_object))\n\n# Ensure we always have these columns in dataframe.\n# if not 'uniongroup' in jdf.columns:\n#     jdf = jdf.withColumn('uniongroup', lit(None))\nif not 'joingroup' in jdf.columns:\n    jdf = jdf.withColumn('joingroup', lit(None))\nif not 'transformationtype' in jdf.columns:\n    jdf = jdf.withColumn('transformationtype', lit(None))\nif not 'transformation' in jdf.columns:\n    jdf = jdf.withColumn('transformation', lit(None))\n#if not 'stage' in jdf.columns:\n#    jdf = jdf.withColumn('stage', lit(0).cast(IntegerType()))\n\njdf.dtypes\njdf = jdf.distinct()\njdf = jdf.dropDuplicates(['operator', 'operationType', 'targetschema', 'targetobject', 'targetattribute', 'sourceschema', 'sourceobject', 'sourceattribute', 'uniongroup', 'joingroup', 'stage', 'transformationtype', 'transformation','codemapped'])\njdf.show(5)\n\nconfig_table_view = \"vwJsonConfig\"\njdf.createOrReplaceTempView(config_table_view)\n\n#display(jdf.filter(\"sourceattribute like 'dl_%'\").sort(\"uniongroup\", \"stage\", \"sourceattribute\"))\n","commandVersion":29,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">+----------+----------------+--------+-------------+-------------------+--------------------+-------------------+--------------------+--------------------+----------+---------+-----+------------------+--------------+----------+------+\n|databaseid|   operationtype|operator| targetschema|       targetobject|     targetattribute|       sourceschema|        sourceobject|     sourceattribute|uniongroup|joingroup|stage|transformationtype|transformation|codemapped|rownum|\n+----------+----------------+--------+-------------+-------------------+--------------------+-------------------+--------------------+--------------------+----------+---------+-----+------------------+--------------+----------+------+\n|      null|attributemapping|  testte|empower_stage|tmp_dim_dim_product|        dl_iscurrent|classicbrandssilver|EcoResReleasedPro...|        dl_iscurrent|         0|     null|    0|              null|          null|     false|    35|\n|      null|attributemapping|  testte|empower_stage|tmp_dim_dim_product| dl_recordenddateutc|classicbrandssilver|EcoResReleasedPro...| dl_recordenddateutc|         0|     null|    0|              null|          null|     false|    37|\n|      null|attributemapping|  testte|empower_stage|tmp_dim_dim_product|dl_recordstartdat...|classicbrandssilver|EcoResReleasedPro...|dl_recordstartdat...|         0|     null|    0|              null|          null|     false|    36|\n|      null|attributemapping|  testte|empower_stage|tmp_dim_dim_product|          dl_rowhash|classicbrandssilver|EcoResReleasedPro...|          dl_rowhash|         0|     null|    0|              null|          null|     false|    34|\n|      null|attributemapping|  testte|empower_stage|tmp_dim_dim_product|   dl_sourcefilename|classicbrandssilver|EcoResReleasedPro...|   dl_sourcefilename|         0|     null|    0|              null|          null|     false|    38|\n+----------+----------------+--------+-------------+-------------------+--------------------+-------------------+--------------------+--------------------+----------+---------+-----+------------------+--------------+----------+------+\nonly showing top 5 rows\n\n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[{"name":"jdf","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"databaseid","nullable":true,"type":"string"},{"metadata":{},"name":"operationtype","nullable":true,"type":"string"},{"metadata":{},"name":"operator","nullable":false,"type":"string"},{"metadata":{},"name":"targetschema","nullable":false,"type":"string"},{"metadata":{},"name":"targetobject","nullable":false,"type":"string"},{"metadata":{},"name":"targetattribute","nullable":true,"type":"string"},{"metadata":{},"name":"sourceschema","nullable":true,"type":"string"},{"metadata":{},"name":"sourceobject","nullable":true,"type":"string"},{"metadata":{},"name":"sourceattribute","nullable":true,"type":"string"},{"metadata":{},"name":"uniongroup","nullable":true,"type":"integer"},{"metadata":{},"name":"joingroup","nullable":true,"type":"string"},{"metadata":{},"name":"stage","nullable":true,"type":"integer"},{"metadata":{},"name":"transformationtype","nullable":true,"type":"string"},{"metadata":{},"name":"transformation","nullable":true,"type":"string"},{"metadata":{},"name":"codemapped","nullable":true,"type":"boolean"},{"metadata":{},"name":"rownum","nullable":true,"type":"integer"}],"type":"struct"},"tableIdentifier":null}],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763406796,"submitTime":1623763403074,"finishTime":1623763408566,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b38b88cf-34ec-47a4-884b-617d0850b85b"},{"version":"CommandV1","origId":3919740296815030,"guid":"e9cf37b9-636b-42f8-9d1d-7515a2bc7350","subtype":"command","commandType":"auto","position":13.0,"command":"%md\n### Load CodeMapTable from param\nIf the CodeMapTable param was passed in, see if it's JSON, and if not, assume it's a file reference","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"1993ddd2-1860-4ed3-88bc-a18e9455ed7c"},{"version":"CommandV1","origId":3919740296815031,"guid":"2bd09147-15ad-474a-900f-b5248c796120","subtype":"command","commandType":"auto","position":14.0,"command":"# Check to see if anything was passed into the CodeMapTable param\nif codemap_table:\n\n    # First let's see if this parses as JSON\n    try:\n        codemaptbl_dict = json.loads(codemap_table) #.lower())\n        #print(codemaptbl_dict)\n\n        pdf = pd.DataFrame(codemaptbl_dict)\n        #pdf.dtypes\n        pdf_cm_schema = StructType()\n        for item in pdf.columns:\n            pdf_cm_schema.add(item, StringType())\n        cm_tbl = spark.createDataFrame(pdf, pdf_cm_schema)\n\n    except:\n        #Not JSON, so assuming a file reference\n\n        #Add Databricks/dbfs root mount point to file name\n        args = [\"mnt\", codemap_table]\n        theFile = slash_join(args, True)  # handles existing leading slash (or not)\n        codemaptbl_file = theFile\n        print(f\"Loading file from {codemaptbl_file}\")\n\n        # Read the file\n        if codemaptbl_file.endswith(\".csv\"):\n            cm_tbl = (spark \n                        .read \n                        .format('csv') \n                        .option(\"header\", \"true\") \n                        .option(\"inferSchema\", \"true\") \n                        .load(codemaptbl_file)\n                      )\n        elif codemaptbl_file.endswith(\".orc\"):\n            cm_tbl = (spark.read\n                        .format('orc')\n                        .load(codemaptbl_file)\n                     )\n            \n    # Filter to specific table (in case config file contained multiple)\n    cm_tbl = cm_tbl.filter(lower(cm_tbl[\"TargetTableName\"]) == target_object.lower())\n\n    # Make sure there are actually code map records\n    if cm_tbl:\n        if cm_tbl.count() > 0:\n            codemapping_view = \"vwJsonCodeMap\"\n            cm_tbl.createOrReplaceTempView(codemapping_view)\n            cm_tbl.show(5)\n        else:\n            #If no records, set the flag to None so it won't get into the sections below.\n            codemap_table = None\n            print(\"INFO:  CodeMap file contained 0 records.\")\n","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763408574,"submitTime":1623763403091,"finishTime":1623763408597,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"f693cc72-3692-4b74-b514-42904046606e"},{"version":"CommandV1","origId":3919740296815032,"guid":"d9f70180-4213-499b-80c1-a0f3724205b4","subtype":"command","commandType":"auto","position":15.0,"command":"%md\n### Query Configuration Table","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"6411274f-1d7e-4c6b-acbf-e999239e4f0f"},{"version":"CommandV1","origId":3919740296815033,"guid":"9591c354-104d-4d59-b345-948de6add860","subtype":"command","commandType":"auto","position":16.0,"command":"# Register Python helper function used to create table aliases\n# def strip_string(string_to_clean, replace_with=\"\", to_lower=False, remove_vowels=False, trim_length=0, dedupe=False):\n#sqlContext.udf.register('udf_strip_string', strip_string)\n\n# Create a dataframe and view to use for subsequent queries, that includes a derived SourceAlias\nquery = \"\"\"\n        with t AS (\n            -- Grab everything for this transformation, \n            -- PLUS create the basis for a table alias\n            select OperationType, Operator, TargetSchema, TargetObject, TargetAttribute,\n                SourceSchema, SourceObject, COALESCE(UnionGroup, 0) AS UnionGroup, COALESCE(JoinGroup,'') AS JoinGroup,\n                COALESCE(Stage, 0) as Stage, SourceAttribute, TransformationType, Transformation, \n                CodeMapped, LEFT(SourceObject,2)||LEFT(REVERSE(SourceObject),2) AS regr, RowNum\n            from {rm_tbl} \n            where lower(operator) = lower('{op}') \n            and lower(TargetObject) = lower('{tt}') \n            and lower(TargetSchema) = lower('{td}')\n        ),\n        -- Generate a SourceAlias for each Source DB/Table\n        t2 AS (\n            select t.*,\n                  --coalesce(left(regr,2) || reverse(left(reverse(regr),2)) || ifnull(JoinGroup, UnionGroup), coalesce(left(regr,3))) as SourceAlias\n                  --CONCAT_WS('_', SourceObject, JoinGroup) as SourceAlias\n                  case\n                    when t.SourceObject like '(%' then t.JoinGroup\n                    when t.SourceObject is NULL then ''\n                    --else CONCAT(t.SourceObject, t.JoinGroup)  --, t.UnionGroup) --Might need to include UnionGroup?\n                    else case\n                            when ifnull(t.JoinGroup,'') != '' then t.JoinGroup\n                            else CONCAT(t.SourceObject, t.JoinGroup)  --, t.UnionGroup) --Might need to include UnionGroup?\n                         end\n                  end as SourceAlias\n            from t\n        )\n        -- Need to create a JoinedAlias column that relates JOINs with the alias they JOIN to \n        SELECT DISTINCT\n            t2.OperationType, t2.Operator, t2.TargetSchema, t2.TargetObject, t2.TargetAttribute,\n            t2.SourceSchema, t2.SourceObject, t2.SourceAttribute, t2.CodeMapped, t2.Stage,\n            COALESCE(t2.UnionGroup, 0) AS UnionGroup, COALESCE(t2.JoinGroup, 0) AS JoinGroup, \n            t2.TransformationType, t2.Transformation, RowNum, \n            --t2.SourceAlias, \n            case when t2.SourceAlias IS NULL then\n                --(select SourceAlias from t2 where t2.JoinGroup = JoinGroup and lower(OperationType) = 'relationship' LIMIT 1)\n                (select SourceAlias from t2 where ifnull(t2.JoinGroup,'') = ifnull(JoinGroup,'') and lower(OperationType) = 'relationship' LIMIT 1)\n              else\n                t2.SourceAlias\n              end as SourceAlias,\n            vw.SourceAlias as JoinedAlias,\n            case \n                when lower(t2.OperationType) == 'attributemapping' \n                  then case when lower(t2.TargetAttribute) like 'dl_%' then 3 else 0 end\n                when lower(t2.OperationType) == 'pivot' then 2\n                when lower(t2.OperationType) == 'relationship' then 6\n                when lower(t2.OperationType) == 'filter' then 7\n                when lower(t2.OperationType) == 'union' then 8\n                else 4\n            end AS SortOrder\n        FROM t2\n        LEFT JOIN (select distinct OperationType, UnionGroup, SourceAlias, Stage \n                   from t2 \n                   where lower(OperationType)=='attributemapping'\n                   and SourceAlias not in (select SourceAlias from t2 where lower(OperationType) == 'relationship')\n                   and ifnull(sourcealias,'') != ''\n                   ) AS vw\n        ON vw.UnionGroup = t2.UnionGroup\n        AND vw.SourceAlias != t2.SourceAlias\n        AND lower(t2.OperationType)=='relationship'\n        AND vw.Stage = t2.Stage\n\"\"\".format(rm_tbl=config_table_view, op=operator, tt=target_object, td=target_schema)\n\n# Execute the query\ndf = spark.sql(query)\n\n# If there are any results, create a temp view for using later\nif df.count() > 0:\n    df.createOrReplaceTempView(\"vwTransformationConfig\")\n    \nelse: # Nothing found, error out\n    raise ValueError('No matching records found!')\n    dbutils.notebook.exit('ERROR: No matching records found!')\n\ndisplay(df.sort(\"Stage\", \"UnionGroup\", \"SortOrder\", \"RowNum\"))","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"table","data":[["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_key","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","ansi","ROW_NUMBER() OVER(ORDER BY (SELECT 1))",1,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_id","classicbrandssilver","EcoResReleasedProductV2Staging","PRODUCTNUMBER",null,0,0,"",null,null,2,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_name","classicbrandssilver","EcoResProductV2Staging","PRODUCTNAME",null,0,0,"",null,null,3,"EcoResProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","item_id","classicbrandssilver","EcoResReleasedProductV2Staging","ITEMNUMBER",null,0,0,"",null,null,4,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","parent_sku","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","ansi","CASE WHEN LOCATE('-', {sourcealias}.PRODUCTNUMBER,0) = 0 THEN {sourcealias}.PRODUCTNUMBER ELSE SUBSTRING({sourcealias}.PRODUCTNUMBER, 0, LOCATE('-', {sourcealias}.PRODUCTNUMBER,0)) END",5,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_description","classicbrandssilver","EcoResProductV2Staging","PRODUCTDESCRIPTION",null,0,0,"",null,null,6,"EcoResProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_type","classicbrandssilver","EcoResReleasedProductV2Staging","PRODUCTTYPE",null,0,0,"",null,null,7,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_type_description","classicbrandssilver","CBAllEnumsForExportStaging","enumitemlabel",null,0,0,"",null,null,8,"CBAllEnumsForExportStaging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_sub_type","classicbrandssilver","EcoResReleasedProductV2Staging","PRODUCTSUBTYPE",null,0,0,"",null,null,9,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_sub_type_description","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","constant","'NOT MAPPED'",10,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_height","classicbrandssilver","EcoResReleasedProductV2Staging","GROSSPRODUCTHEIGHT",null,0,0,"",null,null,11,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_width","classicbrandssilver","EcoResReleasedProductV2Staging","GROSSPRODUCTWIdTH",null,0,0,"",null,null,12,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_depth","classicbrandssilver","EcoResReleasedProductV2Staging","GROSSDEPTH",null,0,0,"",null,null,13,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_volume","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","ansi","ROUND(({sourcealias}.GROSSPRODUCTHEIGHT / 12) * ({sourcealias}.GROSSPRODUCTWIdTH / 12) * ({sourcealias}.GROSSDEPTH / 12), 2)",14,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_weight","classicbrandssilver","EcoResReleasedProductV2Staging","NETPRODUCTWEIGHT",null,0,0,"",null,null,15,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","unit_cost","classicbrandssilver","EcoResReleasedProductV2Staging","unitcost",null,0,0,"",null,null,16,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","unit_cost_date","classicbrandssilver","EcoResReleasedProductV2Staging","unitcostdate",null,0,0,"",null,null,17,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","unit_cost_quantity","classicbrandssilver","EcoResReleasedProductV2Staging","unitcostquantity",null,0,0,"",null,null,18,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_state","classicbrandssilver","EcoResReleasedProductV2Staging","productlifecyclestateid",null,0,0,"",null,null,19,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","purchase_unit_id","classicbrandssilver","EcoResReleasedProductV2Staging","PURCHASEUNITSYMBOL",null,0,0,"",null,null,20,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","inventory_unit_id","classicbrandssilver","EcoResReleasedProductV2Staging","INVENTORYUNITSYMBOL",null,0,0,"",null,null,21,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","sales_unit_id","classicbrandssilver","EcoResReleasedProductV2Staging","SALESUNITSYMBOL",null,0,0,"",null,null,22,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","legal_entity_id","classicbrandssilver","EcoResReleasedProductV2Staging","DataAreaId",null,0,0,"",null,null,23,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","current_flag","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","constant","1",24,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","deleted_flag","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","constant","0",25,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","effective_from_date","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","constant","'1900-01-01 00:00:00'",26,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","effective_to_date","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","constant","'2099-12-31 00:00:00'",27,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","inserted_date","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","constant","GETDATE()",28,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","update_date","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","constant","GETDATE()",29,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","user_id","classicbrandssilver","EcoResReleasedProductV2Staging",null,null,0,0,"","constant","sysuser'",30,"EcoResReleasedProductV2Staging",null,0],["attributemapping","testte","empower_stage","tmp_dim_dim_product","dl_rowhash","classicbrandssilver","EcoResReleasedProductV2Staging","dl_rowhash",false,0,0,"",null,null,34,"EcoResReleasedProductV2Staging",null,3],["attributemapping","testte","empower_stage","tmp_dim_dim_product","dl_iscurrent","classicbrandssilver","EcoResReleasedProductV2Staging","dl_iscurrent",false,0,0,"",null,null,35,"EcoResReleasedProductV2Staging",null,3],["attributemapping","testte","empower_stage","tmp_dim_dim_product","dl_recordstartdateutc","classicbrandssilver","EcoResReleasedProductV2Staging","dl_recordstartdateutc",false,0,0,"",null,null,36,"EcoResReleasedProductV2Staging",null,3],["attributemapping","testte","empower_stage","tmp_dim_dim_product","dl_recordenddateutc","classicbrandssilver","EcoResReleasedProductV2Staging","dl_recordenddateutc",false,0,0,"",null,null,37,"EcoResReleasedProductV2Staging",null,3],["attributemapping","testte","empower_stage","tmp_dim_dim_product","dl_sourcefilename","classicbrandssilver","EcoResReleasedProductV2Staging","dl_sourcefilename",false,0,0,"",null,null,38,"EcoResReleasedProductV2Staging",null,3],["relationship","testte","empower_stage","tmp_dim_dim_product",null,"classicbrandssilver","EcoResProductV2Staging",null,null,0,0,"","left join","{joinedalias}.PRODUCTNUMBER = {sourcealias}.PRODUCTNUMBER",31,"EcoResProductV2Staging","EcoResReleasedProductV2Staging",6],["relationship","testte","empower_stage","tmp_dim_dim_product",null,"classicbrandssilver","CBAllEnumsForExportStaging",null,null,0,0,"","left join","{joinedalias}.PRODUCTTYPE = {sourcealias}.enumitemvalue AND {sourcealias}.ENUMNAME = 'EcoResProductType'",32,"CBAllEnumsForExportStaging","EcoResReleasedProductV2Staging",6],["filter","testte","empower_stage","tmp_dim_dim_product",null,"classicbrandssilver","EcoResProductV2Staging",null,null,0,0,"","filter","{sourcealias}.PRODUCTNAME IS NOT NULL",33,"EcoResProductV2Staging",null,7]],"arguments":{},"addedWidgets":{},"removedWidgets":[],"schema":[{"name":"OperationType","type":"\"string\"","metadata":"{}"},{"name":"Operator","type":"\"string\"","metadata":"{}"},{"name":"TargetSchema","type":"\"string\"","metadata":"{}"},{"name":"TargetObject","type":"\"string\"","metadata":"{}"},{"name":"TargetAttribute","type":"\"string\"","metadata":"{}"},{"name":"SourceSchema","type":"\"string\"","metadata":"{}"},{"name":"SourceObject","type":"\"string\"","metadata":"{}"},{"name":"SourceAttribute","type":"\"string\"","metadata":"{}"},{"name":"CodeMapped","type":"\"boolean\"","metadata":"{}"},{"name":"Stage","type":"\"integer\"","metadata":"{}"},{"name":"UnionGroup","type":"\"integer\"","metadata":"{}"},{"name":"JoinGroup","type":"\"string\"","metadata":"{}"},{"name":"TransformationType","type":"\"string\"","metadata":"{}"},{"name":"Transformation","type":"\"string\"","metadata":"{}"},{"name":"RowNum","type":"\"integer\"","metadata":"{}"},{"name":"SourceAlias","type":"\"string\"","metadata":"{}"},{"name":"JoinedAlias","type":"\"string\"","metadata":"{}"},{"name":"SortOrder","type":"\"integer\"","metadata":"{}"}],"overflow":false,"aggData":[],"aggSchema":[],"aggOverflow":false,"aggSeriesLimitReached":false,"aggError":"","aggType":"","plotOptions":null,"isJsonSchema":true,"dbfsResultPath":null,"datasetInfos":[],"columnCustomDisplayInfos":{},"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[{"name":"df","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"OperationType","nullable":true,"type":"string"},{"metadata":{},"name":"Operator","nullable":false,"type":"string"},{"metadata":{},"name":"TargetSchema","nullable":false,"type":"string"},{"metadata":{},"name":"TargetObject","nullable":false,"type":"string"},{"metadata":{},"name":"TargetAttribute","nullable":true,"type":"string"},{"metadata":{},"name":"SourceSchema","nullable":true,"type":"string"},{"metadata":{},"name":"SourceObject","nullable":true,"type":"string"},{"metadata":{},"name":"SourceAttribute","nullable":true,"type":"string"},{"metadata":{},"name":"CodeMapped","nullable":true,"type":"boolean"},{"metadata":{},"name":"Stage","nullable":false,"type":"integer"},{"metadata":{},"name":"UnionGroup","nullable":false,"type":"integer"},{"metadata":{},"name":"JoinGroup","nullable":false,"type":"string"},{"metadata":{},"name":"TransformationType","nullable":true,"type":"string"},{"metadata":{},"name":"Transformation","nullable":true,"type":"string"},{"metadata":{},"name":"RowNum","nullable":true,"type":"integer"},{"metadata":{},"name":"SourceAlias","nullable":true,"type":"string"},{"metadata":{},"name":"JoinedAlias","nullable":true,"type":"string"},{"metadata":{},"name":"SortOrder","nullable":false,"type":"integer"}],"type":"struct"},"tableIdentifier":null}],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763408603,"submitTime":1623763403108,"finishTime":1623763413031,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"3425","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"03d09bf1-3664-414e-85d4-52a61c449bfe"},{"version":"CommandV1","origId":3919740296815034,"guid":"a554fd8e-e5e5-466f-9866-c4928c30b77b","subtype":"command","commandType":"auto","position":17.0,"command":"%sql\nCACHE TABLE vwTransformationConfig","commandVersion":1,"state":"finished","results":{"type":"table","data":[],"arguments":{},"addedWidgets":{},"removedWidgets":[],"schema":[],"overflow":false,"aggData":[],"aggSchema":[],"aggOverflow":false,"aggSeriesLimitReached":false,"aggError":"","aggType":"","plotOptions":null,"isJsonSchema":true,"dbfsResultPath":null,"datasetInfos":[],"columnCustomDisplayInfos":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763415282,"submitTime":1623763403116,"finishTime":1623763417286,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"5a55afb9-3d4e-478a-886d-a38b9f9623d1"},{"version":"CommandV1","origId":3919740296815035,"guid":"9e3e625b-a71f-4f12-adda-a9c21bd0112c","subtype":"command","commandType":"auto","position":18.0,"command":"%md\n### Create DataFrames and Dictionaries","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"94ac2428-aead-4b46-926d-717dccd7193a"},{"version":"CommandV1","origId":3919740296815036,"guid":"3cd3ae82-200c-47a1-9e20-24660df97f1c","subtype":"command","commandType":"auto","position":19.0,"command":"join_aliases = []\ncustom_cnt = 0\ndfa_dict = {}\n\n#####################################################\n# Create the main dataframe of attributes and actions\n#####################################################\nquery = \"\"\"select distinct OperationType, Operator, TargetSchema, TargetObject, TargetAttribute,\n              SourceSchema, SourceObject, COALESCE(UnionGroup, 0) AS UnionGroup, COALESCE(Stage, 0) as Stage, SourceAttribute,\n              TransformationType, Transformation, SourceAlias, SortOrder, CodeMapped, RowNum, JoinGroup,\n--              case when SourceObject IS NULL then\n--                (select JoinedAlias from vwTransformationConfig v where v.JoinGroup = JoinGroup and lower(OperationType) = 'relationship' LIMIT 1)\n--              else\n--                JoinedAlias\n--              end as JoinedAlias\n              JoinedAlias\n           from vwTransformationConfig vw\n           order by Stage, UnionGroup, SortOrder, RowNum --, SourceAlias --, TargetAttribute --MUST INCLUDE TARGETATTRIBUTE SO DATASETS MATCH COLUMN POSITIONS\n        \"\"\"\ndfa = spark.sql(query)\ndfa_dict = dataframeToDict(dfa) #No need to check dfa.count because that's handled in initial query above\n\n# See if there are CUSTOM transformations for this set\ncustom_cnt = dfa.select(\"OperationType\").where(\"lower(OperationType) == 'custom'\").count()\n\n##################################################\n# Create a dataframe of JOINs\n##################################################\nquery = \"\"\"select distinct transformationtype, transformation, sourceschema, sourceobject, sourcealias, joinedalias, stage, rownum\n            from vwTransformationConfig \n            where lower(OperationType) == 'relationship'\n            and ifnull(joinedalias,'') != ''\n            order by Stage, RowNum --SourceAlias\n            \"\"\"\ndf_join = spark.sql(query)\n\nif df_join.count() > 0:\n    # Create an iterable list from the dataframe\n    join_list = df_join.collect()\n\n    # Create a list of aliases used as JOINed tables\n    for j in join_list:\n        join_aliases.append(j.sourcealias)\n\n    # Filter out duplicates\n    join_aliases = list(set(join_aliases))\n  ","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[{"name":"dfa","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"OperationType","nullable":true,"type":"string"},{"metadata":{},"name":"Operator","nullable":false,"type":"string"},{"metadata":{},"name":"TargetSchema","nullable":false,"type":"string"},{"metadata":{},"name":"TargetObject","nullable":false,"type":"string"},{"metadata":{},"name":"TargetAttribute","nullable":true,"type":"string"},{"metadata":{},"name":"SourceSchema","nullable":true,"type":"string"},{"metadata":{},"name":"SourceObject","nullable":true,"type":"string"},{"metadata":{},"name":"UnionGroup","nullable":false,"type":"integer"},{"metadata":{},"name":"Stage","nullable":false,"type":"integer"},{"metadata":{},"name":"SourceAttribute","nullable":true,"type":"string"},{"metadata":{},"name":"TransformationType","nullable":true,"type":"string"},{"metadata":{},"name":"Transformation","nullable":true,"type":"string"},{"metadata":{},"name":"SourceAlias","nullable":true,"type":"string"},{"metadata":{},"name":"SortOrder","nullable":false,"type":"integer"},{"metadata":{},"name":"CodeMapped","nullable":true,"type":"boolean"},{"metadata":{},"name":"RowNum","nullable":true,"type":"integer"},{"metadata":{},"name":"JoinGroup","nullable":false,"type":"string"},{"metadata":{},"name":"JoinedAlias","nullable":true,"type":"string"}],"type":"struct"},"tableIdentifier":null},{"name":"df_join","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"transformationtype","nullable":true,"type":"string"},{"metadata":{},"name":"transformation","nullable":true,"type":"string"},{"metadata":{},"name":"sourceschema","nullable":true,"type":"string"},{"metadata":{},"name":"sourceobject","nullable":true,"type":"string"},{"metadata":{},"name":"sourcealias","nullable":true,"type":"string"},{"metadata":{},"name":"joinedalias","nullable":true,"type":"string"},{"metadata":{},"name":"stage","nullable":false,"type":"integer"},{"metadata":{},"name":"rownum","nullable":true,"type":"integer"}],"type":"struct"},"tableIdentifier":null}],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763417294,"submitTime":1623763403132,"finishTime":1623763419491,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"e691cb29-5391-4b51-94b7-c2b2d6e67945"},{"version":"CommandV1","origId":3919740296815037,"guid":"372cd044-a998-4d3e-846e-6a5180779dc8","subtype":"command","commandType":"auto","position":20.0,"command":"display(dfa)","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"table","data":[["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_key","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"ansi","ROW_NUMBER() OVER(ORDER BY (SELECT 1))","EcoResReleasedProductV2Staging",0,null,1,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_id","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"PRODUCTNUMBER",null,null,"EcoResReleasedProductV2Staging",0,null,2,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_name","classicbrandssilver","EcoResProductV2Staging",0,0,"PRODUCTNAME",null,null,"EcoResProductV2Staging",0,null,3,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","item_id","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"ITEMNUMBER",null,null,"EcoResReleasedProductV2Staging",0,null,4,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","parent_sku","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"ansi","CASE WHEN LOCATE('-', {sourcealias}.PRODUCTNUMBER,0) = 0 THEN {sourcealias}.PRODUCTNUMBER ELSE SUBSTRING({sourcealias}.PRODUCTNUMBER, 0, LOCATE('-', {sourcealias}.PRODUCTNUMBER,0)) END","EcoResReleasedProductV2Staging",0,null,5,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_description","classicbrandssilver","EcoResProductV2Staging",0,0,"PRODUCTDESCRIPTION",null,null,"EcoResProductV2Staging",0,null,6,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_type","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"PRODUCTTYPE",null,null,"EcoResReleasedProductV2Staging",0,null,7,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_type_description","classicbrandssilver","CBAllEnumsForExportStaging",0,0,"enumitemlabel",null,null,"CBAllEnumsForExportStaging",0,null,8,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_sub_type","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"PRODUCTSUBTYPE",null,null,"EcoResReleasedProductV2Staging",0,null,9,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_sub_type_description","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"constant","'NOT MAPPED'","EcoResReleasedProductV2Staging",0,null,10,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_height","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"GROSSPRODUCTHEIGHT",null,null,"EcoResReleasedProductV2Staging",0,null,11,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_width","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"GROSSPRODUCTWIdTH",null,null,"EcoResReleasedProductV2Staging",0,null,12,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_depth","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"GROSSDEPTH",null,null,"EcoResReleasedProductV2Staging",0,null,13,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_volume","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"ansi","ROUND(({sourcealias}.GROSSPRODUCTHEIGHT / 12) * ({sourcealias}.GROSSPRODUCTWIdTH / 12) * ({sourcealias}.GROSSDEPTH / 12), 2)","EcoResReleasedProductV2Staging",0,null,14,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_weight","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"NETPRODUCTWEIGHT",null,null,"EcoResReleasedProductV2Staging",0,null,15,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","unit_cost","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"unitcost",null,null,"EcoResReleasedProductV2Staging",0,null,16,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","unit_cost_date","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"unitcostdate",null,null,"EcoResReleasedProductV2Staging",0,null,17,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","unit_cost_quantity","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"unitcostquantity",null,null,"EcoResReleasedProductV2Staging",0,null,18,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","product_state","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"productlifecyclestateid",null,null,"EcoResReleasedProductV2Staging",0,null,19,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","purchase_unit_id","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"PURCHASEUNITSYMBOL",null,null,"EcoResReleasedProductV2Staging",0,null,20,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","inventory_unit_id","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"INVENTORYUNITSYMBOL",null,null,"EcoResReleasedProductV2Staging",0,null,21,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","sales_unit_id","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"SALESUNITSYMBOL",null,null,"EcoResReleasedProductV2Staging",0,null,22,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","legal_entity_id","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"DataAreaId",null,null,"EcoResReleasedProductV2Staging",0,null,23,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","current_flag","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"constant","1","EcoResReleasedProductV2Staging",0,null,24,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","deleted_flag","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"constant","0","EcoResReleasedProductV2Staging",0,null,25,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","effective_from_date","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"constant","'1900-01-01 00:00:00'","EcoResReleasedProductV2Staging",0,null,26,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","effective_to_date","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"constant","'2099-12-31 00:00:00'","EcoResReleasedProductV2Staging",0,null,27,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","inserted_date","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"constant","GETDATE()","EcoResReleasedProductV2Staging",0,null,28,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","update_date","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"constant","GETDATE()","EcoResReleasedProductV2Staging",0,null,29,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","user_id","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,null,"constant","sysuser'","EcoResReleasedProductV2Staging",0,null,30,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","dl_rowhash","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"dl_rowhash",null,null,"EcoResReleasedProductV2Staging",3,false,34,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","dl_iscurrent","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"dl_iscurrent",null,null,"EcoResReleasedProductV2Staging",3,false,35,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","dl_recordstartdateutc","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"dl_recordstartdateutc",null,null,"EcoResReleasedProductV2Staging",3,false,36,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","dl_recordenddateutc","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"dl_recordenddateutc",null,null,"EcoResReleasedProductV2Staging",3,false,37,"",null],["attributemapping","testte","empower_stage","tmp_dim_dim_product","dl_sourcefilename","classicbrandssilver","EcoResReleasedProductV2Staging",0,0,"dl_sourcefilename",null,null,"EcoResReleasedProductV2Staging",3,false,38,"",null],["relationship","testte","empower_stage","tmp_dim_dim_product",null,"classicbrandssilver","EcoResProductV2Staging",0,0,null,"left join","{joinedalias}.PRODUCTNUMBER = {sourcealias}.PRODUCTNUMBER","EcoResProductV2Staging",6,null,31,"","EcoResReleasedProductV2Staging"],["relationship","testte","empower_stage","tmp_dim_dim_product",null,"classicbrandssilver","CBAllEnumsForExportStaging",0,0,null,"left join","{joinedalias}.PRODUCTTYPE = {sourcealias}.enumitemvalue AND {sourcealias}.ENUMNAME = 'EcoResProductType'","CBAllEnumsForExportStaging",6,null,32,"","EcoResReleasedProductV2Staging"],["filter","testte","empower_stage","tmp_dim_dim_product",null,"classicbrandssilver","EcoResProductV2Staging",0,0,null,"filter","{sourcealias}.PRODUCTNAME IS NOT NULL","EcoResProductV2Staging",7,null,33,"",null]],"arguments":{},"addedWidgets":{},"removedWidgets":[],"schema":[{"name":"OperationType","type":"\"string\"","metadata":"{}"},{"name":"Operator","type":"\"string\"","metadata":"{}"},{"name":"TargetSchema","type":"\"string\"","metadata":"{}"},{"name":"TargetObject","type":"\"string\"","metadata":"{}"},{"name":"TargetAttribute","type":"\"string\"","metadata":"{}"},{"name":"SourceSchema","type":"\"string\"","metadata":"{}"},{"name":"SourceObject","type":"\"string\"","metadata":"{}"},{"name":"UnionGroup","type":"\"integer\"","metadata":"{}"},{"name":"Stage","type":"\"integer\"","metadata":"{}"},{"name":"SourceAttribute","type":"\"string\"","metadata":"{}"},{"name":"TransformationType","type":"\"string\"","metadata":"{}"},{"name":"Transformation","type":"\"string\"","metadata":"{}"},{"name":"SourceAlias","type":"\"string\"","metadata":"{}"},{"name":"SortOrder","type":"\"integer\"","metadata":"{}"},{"name":"CodeMapped","type":"\"boolean\"","metadata":"{}"},{"name":"RowNum","type":"\"integer\"","metadata":"{}"},{"name":"JoinGroup","type":"\"string\"","metadata":"{}"},{"name":"JoinedAlias","type":"\"string\"","metadata":"{}"}],"overflow":false,"aggData":[],"aggSchema":[],"aggOverflow":false,"aggSeriesLimitReached":false,"aggError":"","aggType":"","plotOptions":null,"isJsonSchema":true,"dbfsResultPath":null,"datasetInfos":[],"columnCustomDisplayInfos":{},"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763419499,"submitTime":1623763403136,"finishTime":1623763419883,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"3425","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"78bc5f5e-ebc2-4d26-9d5d-e3fdd1de188f"},{"version":"CommandV1","origId":3919740296815038,"guid":"a78d3e36-c621-4eb6-ba6d-a613b6c66dd5","subtype":"command","commandType":"auto","position":21.0,"command":"%md\n### Build & Execute Transformation Query","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"335545de-f928-4cc3-868e-464abfaadf0c"},{"version":"CommandV1","origId":3919740296815039,"guid":"e14b9fa5-8cd9-4b13-8cf7-2ca5e798d8a6","subtype":"command","commandType":"auto","position":22.0,"command":"# No custom transformations... proceed.\nif custom_cnt == 0:\n    final_query = []\n    for stage in stage_list:\n        # Initialize variables\n        #insert_clause = f\"INSERT INTO {target_schema}.{target_object} (\" + \"{inscols})\" #inscols is replaced later\n        insert_clause = \"\"\n        select_clause = \"SELECT \"\n\n        query = []\n        query.append(insert_clause)\n        query.append(select_clause)\n\n        from_clause = where_clause = union_clause = join_clause = selectivity_clause = limit_clause = ''\n        col_counter = 0\n        i = 0\n        last_ug = ''\n\n        inscols = []\n        pivot_clause = []\n\n        # Get a Count of output columns for building query\n        #target_col_cnt = dfa.select(\"TargetAttribute\").where(\"Ifnull(TargetAttribute,'') != ''\").distinct().count()\n#         unique_attributes = [t for t in dfa_dict['TargetAttribute'] if dfa_dict['stage'] != stage and t != None]\n#         target_col_cnt = len(set(unique_attributes))\n        unique_attributes = []\n        for i, val in enumerate(dfa_dict[\"TargetAttribute\"]):\n            if dfa_dict[\"Stage\"][i] == stage and val != None:\n                unique_attributes.append(val)\n            \n        target_col_cnt = len(set(unique_attributes))\n\n        # We need to know if we're unpivoting because there will be extra columns not included in config\n        pivot_cnt = dfa.select(\"TransformationType\").where(f\"lower(OperationType) == 'pivot' and stage == {stage}\").count()\n        if pivot_cnt > 0:\n            target_col_cnt += 1\n\n        #for i in range(0, len(dfa_dict['TargetAttribute'])):\n        for i in (i for i in range(0, len(dfa_dict['TargetAttribute'])) if dfa_dict[\"Stage\"][i] == stage):\n\n            derived = False\n            ot = (dfa_dict['OperationType'][i] or '').lower()\n            xft = (dfa_dict['TransformationType'][i] or '').lower()\n            xf = (dfa_dict['Transformation'][i] or '')\n            ug = (dfa_dict['UnionGroup'][i] or '')\n            ta = (dfa_dict['TargetAttribute'][i] or '')\n            sa = (dfa_dict['SourceAlias'][i] or '')\n            sd = (dfa_dict['SourceSchema'][i] or '')\n            st = (dfa_dict['SourceObject'][i] or '')\n            sc = (dfa_dict['SourceAttribute'][i] or '')\n            ja = (dfa_dict['JoinedAlias'][i] or '')\n            op = (dfa_dict['Operator'][i] or '')\n            cm = (dfa_dict['CodeMapped'][i] or '')\n            if st.startswith(\"(\"):\n                derived = True\n            \n            if ug != last_ug:\n                col_counter = 0\n\n            #Since we're no longer automatically converting everything to lower case \n            # We need to make sure any substitution variables are in lower case\n            xf = xf.replace(\"SOURCEALIAS\"      , \"sourcealias\")\n            xf = xf.replace(\"JOINEDALIAS\"      , \"joinedalias\")\n            xf = xf.replace(\"SOURCEATTRIBUTE\"  , \"sourceattribute\")\n            xf = xf.replace(\"SOURCEOBJECT\"     , \"sourceobject\")\n            xf = xf.replace(\"SOURCESCHEMA\"     , \"sourceschema\")\n            xf = xf.replace(\"TARGETATTRIBUTE\"  , \"targetattribute\")\n            xf = xf.replace(\"TARGETOBJECT\"     , \"targetobject\")\n            xf = xf.replace(\"TARGETSCHEMA\"     , \"targetschema\")\n            xf = xf.replace(\"OPERATOR\"         , \"operator\")\n            xf = xf.replace(\"'PIVOTCOLUMN'\"    , \"'pivotcolumn'\")\n            xf = xf.replace(\"'PIVOTVALUES'\"    , \"'pivotvalues'\")\n            xf = xf.replace(\"'PIVOTCOLUMNSTO'\" , \"'pivotcolumnsto'\")\n            xf = xf.replace(\"'PIVOTVALUESTO'\"  , \"'pivotvaluesto'\")\n            xf = xf.replace(\"'PIVOTCOLUMNS'\"   , \"'pivotcolumns'\")\n            xf = xf.replace(\"'PIVOTCOLALIASES'\", \"'pivotcolaliases'\")\n            xf = xf.replace(\"'PIVOTCOLUMNS'\"   , \"'pivotcolumns'\")\n\n            #reset variables\n            newselcol = where_clause = join_clause = pivotcolto = pivotvalto = pivot_col = pivot_val = ''\n\n            # Build the current JOIN clause\n            if ot == 'relationship':\n                # Don't add the source schema if it's a derived query\n                if derived:\n                      join_clause = xft.upper() + ' ' + st + ' AS ' + sa + '\\n\\t' + 'ON ' + xf.format(sourcealias=sa, joinedalias=ja) #+ '\\n\\t' + f'AND DL_IsCurrent = True '\n                else:\n                    join_clause = xft.upper() + ' ' + sd + '.' + st + ' AS ' + sa + '\\n\\t' + 'ON ' + xf.format(sourcealias=sa, joinedalias=ja) + '\\n\\t' + f'AND {sa}.DL_IsCurrent = True '\n\n            if ot == 'selectivity':\n                if 'distinct' in xft:\n                    selectivity_clause = ((xft + ' ' + xf).strip()).upper() #if no transformation/params, strip blank\n                elif 'limit' in xft:\n                    limit_clause = ((xft + ' ' + xf).strip()).upper() #if no transformation/params, strip blank\n\n            # Build the UNION clause (and store until used)\n            if ot == 'union':\n                union_clause = xft.upper()\n\n            # If we've moved from the first UnionGroup to the next, add the UNION clause\n            if ug != last_ug and i > target_col_cnt:\n\n                if len(union_clause) > 0:    \n                    query.append(union_clause)\n\n                # Then add a new SELECT statement\n                query.append(select_clause)\n                #if len(selectivity_clause) > 0:\n                #    query.append(selectivity_clause)\n\n            # If there IS a transformation\n            if ot == 'attributemapping' and len(xf) > 0:\n\n                if xft == 'ansi':\n                    newselcol = xf\n                elif xft == 'constant':\n                    newselcol = xf\n                    # If they didn't quote the constant, do it for them\n                    if \"'\" not in newselcol:\n                        newselcol = \"'\" + newselcol + \"'\"\n                    if newselcol.replace(\"'\",\"\").lower() == \"null\":\n                        newselcol = \"NULL\"\n                    else:\n                        if not newselcol.startswith(\"'\"):\n                            newselcol = \"'\" + newselcol\n                elif xft == 'aggregate':\n                    newselcol = xf\n                else:\n                    newselcol = 'Unsupported Transformation Type: {} {}'.format(xft, xf)\n\n            # No Transformation - simply maps source attribute to target attribute\n            else:\n                if sc != '': #There's a source column\n                    if sa:\n                        newselcol = sa + '.' + sc\n                    else:\n                        newselcol = sc\n                    if sc == 'dl_iscurrent':\n                        newselcol = f\"IFNULL({newselcol}, True)\"\n                else: # No source column provided, assume NULL\n                    newselcol = 'NULL'\n\n            # Variable substitution\n            newselcol = newselcol.format(sourcealias=sa, sourceschema=sd, sourceobject=st, sourceattribute=sc, operator=op)\n\n            # Filter Operation\n            if ot == 'filter':\n                where_clause = 'WHERE {}'.format(xf)\n                if sa != \"\":\n                    where_clause = where_clause.format(sourcealias=sa)\n                else:\n                    where_clause = where_clause.replace(\"{sourcealias}.\", \"\")\n\n            # Pivot (or Unpivot) Operation\n            if ot == 'pivot':\n                if xft == 'pivot':\n                    pivot_dict = eval(xf) #Convert dictionary string to actual dictionary type\n                    pivot_col = pivot_dict[\"pivotcolumn\"]\n                    pivot_val = pivot_dict[\"pivotvalues\"]\n                    pivot_clause = []\n                    tbl = sd + '.' + st\n                    pivoted_aliases = []\n                    pivoted_data = spark.sql(f'select distinct {pivot_col} from {tbl}').collect()\n                    for f in pivoted_data:\n                        pivoted_aliases.append(f.LeaseEventName)\n                    pivoted_aliases = \"'\" + \"','\".join(pivoted_aliases) + \"'\"\n                    pivot_clause.append('PIVOT (')\n                    pivot_clause.append(f'\\tFIRST({pivot_val})')\n                    pivot_clause.append(f'\\tFOR {pivot_col} IN ({pivoted_aliases}) \\n)')\n                elif xft == 'unpivot':\n                    pivot_dict = eval(xf) #Convert dictionary string to actual dictionary type\n                    pivotcolto = pivot_dict[\"pivotcolumnsto\"]\n                    pivotvalto = pivot_dict[\"pivotvaluesto\"]\n                    stack_list = []\n                    cols = pivot_dict['pivotcolumns']\n                    # Pivotcolaliases aren't mandatory, so if it's missing, use column names as default values\n                    try:\n                        aliases = pivot_dict['pivotcolaliases']\n                    except:\n                        aliases = cols\n                    n = len(cols)\n                    for c in range(n):\n                        stack_list.append(\"'{}'\".format(aliases[c]) + \",\" + cols[c])\n\n                    stack_str = ','.join(stack_list)\n                    newselcol = \"stack({},{}) as ({},{})\".format(n, stack_str, pivotcolto, pivotvalto)\n\n            # If we're adding a column, append it to list\n            if len(newselcol) > 0 and len(ta) > 0 and ot == 'attributemapping':\n\n                  # Provide an alias for the column to map to Target Table\n                  newselcol = newselcol + ' AS {}'.format(ta)\n\n                  # Add column to INSERT list, as long as it's not a Transform\n                  if ta not in inscols and len(ta) > 0:\n                      inscols.append(ta)\n\n                  # Add column/transformation to the SELECT list \n                  query.append('\\t' + newselcol + ',')\n                  #query.insert(i, '\\t' + newselcol + ',')\n\n                  # Increment column counter so we know where we're at\n                  col_counter += 1 \n\n            elif ot == 'pivot' and pivotcolto != '':\n                # Add pivot column and values column to INSERT and SELECT \n                inscols.append(pivotcolto)\n                inscols.append(pivotvalto)\n                newselcol = f'\\t{newselcol},'  # Don't alias since this is a stack function\n                query.append(newselcol)\n                col_counter += 1\n\n            elif ot == 'pivot' and pivot_col != '':\n                # Add pivot column and values column to INSERT and SELECT \n                inscols.append(pivot_col)\n                inscols.append(pivot_val)\n                newselcol = f'\\t{sa}.{pivot_col},'  \n                query.append(newselcol)\n                newselcol = f'\\t{sa}.{pivot_val},'  \n                query.append(newselcol)\n                col_counter += 1\n\n            # If this isn't one of the JOINed tables, build the FROM clause (used either at the end of a single query, or each query if UNIONed)\n            if sa not in join_aliases and st != \"\":\n                from_clause = f'FROM {sd}.{st} AS {sa}'\n                \n            # Add the FROM clause, if not already present\n            #if col_counter == target_col_cnt and from_clause not in query:\n            #if col_counter == target_col_cnt: # and ug != last_ug:# and (from_clause not in query or ug != last_ug):\n            if col_counter == target_col_cnt and from_clause not in query[-10:]:  #not in last 10 lines of query... allow for other joins/union groups/etc\n                query.append(from_clause)\n\n            # Add the JOIN clause as appropriate\n            if col_counter == target_col_cnt and ot == 'relationship':\n                query.append(join_clause)\n\n            # Add the WHERE clause as appropriate\n            if col_counter == target_col_cnt and ot == 'filter' and st != \"\":\n                query.append(where_clause)\n\n            #print(f'stage {stage}, sa {sa}, ta {ta}, col_counter {col_counter}, target_col_cnt {target_col_cnt}, join_clause {join_clause}, selectivity {selectivity_clause}')\n            #print(f'Join alias: {ja}; Source alias: {sa}; col_counter {col_counter}, join_clause {join_clause}, selectivity {selectivity_clause}')\n            #print(f'col_counter {col_counter}, target_col_cnt {target_col_cnt}, where_clause {where_clause}')\n            #print(f'col_counter {col_counter}, target_col_cnt {target_col_cnt}, from_clause {from_clause}, ug {ug} last_ug {last_ug}')\n            #print(f\"i {i} colctr {col_counter}\", query[len(query)-1])\n#             if col_counter <= 4:\n#                 print(f\"{ug}\\tsa\\t{sa}\\tta\\t{ta}\")\n            \n            \n            if ug != last_ug:\n                last_ug = ug \n            \n        # Create lists of lower case items\n        tt_list = []\n        tt_list[:] = [item.lower() for item in dfa_dict['TransformationType'] if item is not None]\n        tf_list = []\n        tf_list[:] = [item.lower() for item in dfa_dict['Transformation'] if item is not None]\n\n        # Check to see if we need to add a GROUP BY (case sensitive)\n        if 'aggregate' in tt_list and 'groupby' not in tt_list and ' over' not in ''.join(tf_list): #not part of a derived column windowing function\n            groupby_cols = []\n            for n in range(0, len(dfa_dict['TargetAttribute'])):\n                tt = (dfa_dict['TransformationType'][n] or '').lower()\n                ta = (dfa_dict['TargetAttribute'][n] or '')\n                if tt != 'aggregate' and tt != '' and ta != '':\n                    groupby_cols.append(ta)\n\n            # Add GROUP BY and applicable columns to query\n            if len(groupby_cols) > 0:\n                query.append('GROUP BY \\n\\t' + ', \\n\\t'.join(list(set(groupby_cols))))\n\n        if len(pivot_clause) > 0:\n            query.insert(1, 'SELECT * FROM (') # Add to query, after INSERT clause\n            query.append(')')\n            for p in pivot_clause:\n                query.append(p)\n\n        # Remove any blank lines\n        query[:] = [item for item in query if item != '']\n\n        # Format list of INSERT columns\n        inscols = '\\n\\t' + ',\\n\\t'.join(inscols) + '\\n'\n\n        # Add DISTINCT, as appropriate\n        if len(selectivity_clause) > 0:\n            for n, q in enumerate(query):  #Look for SELECTs to replace with SELECT DISTINCT\n                if q.startswith(\"SELECT\"):\n                    new_select = \"SELECT \" + selectivity_clause\n                    if query[n-1] != new_select:\n                        query[n] = new_select\n                    else:\n                        query.pop(n)\n\n        # Add LIMIT clause, as appropriate\n        if len(limit_clause) > 0:\n            query.append(limit_clause)\n\n        # Create query string from list\n        sqlquery = ''\n        for q in query:\n            sqlquery += q + '\\n'\n\n        # String replacement for list of INSERT columns\n        sqlquery = sqlquery.format(inscols=inscols)\n\n        # Remove trailing commas on last select column\n        sqlquery = sqlquery.replace(',\\nFROM', '\\nFROM')\n\n        #print(sqlquery)\n\n        if st != \"\":\n            for q in query:\n                final_query.append(q)\n\n\n        #if len(stage_list) > 1:\n        if stage > 1:\n            # Set up the final query to select from the derived table (inner query/state)\n            #if not final_query[0].startswith(\"SELECT\"):\n            final_query.insert(0, 'SELECT')\n            i = 1\n            for q in query:\n                if q != 'SELECT ':\n                    final_query.insert(i, q)\n                    i += 1\n            final_query.insert(i, 'FROM (')\n            final_query.append(')')\n\n            # Add the WHERE clause as appropriate\n            if where_clause:\n                final_query.append(where_clause)\n\n            if final_query[0].startswith(\"SELECT\") and final_query[1].startswith(\"SELECT\"):\n                #print('deleting',final_query[0])\n                final_query.pop(0)\n\n            sql_out = \"\"\n            for q in final_query:\n                sql_out += q + '\\n'\n\n            # Remove trailing commas on last select column\n            sql_out = sql_out.replace(',\\nFROM', '\\nFROM')\n        else:\n            sql_out = sqlquery\n\n    print(sql_out)\n    \n    # Test the query unless this is being run adhoc\n    if not adhoc_mode:\n        try:\n            print('Testing query...\\n')\n            df = spark.sql(sql_out) #see if it executes without throwing error\n            print('Query tested successfully...')\n            df.createOrReplaceTempView(\"vwTransformedData\")\n        except Exception as E:\n            errMsg = 'ERROR with SQL query!'\n            err = E\n            print(errMsg, '\\n', 'Error: ', err, '\\n', 'Query:', sql_out)\n            raise \n","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">SELECT \n\tROW_NUMBER() OVER(ORDER BY (SELECT 1)) AS product_key,\n\tEcoResReleasedProductV2Staging.PRODUCTNUMBER AS product_id,\n\tEcoResProductV2Staging.PRODUCTNAME AS product_name,\n\tEcoResReleasedProductV2Staging.ITEMNUMBER AS item_id,\n\tCASE WHEN LOCATE(&#39;-&#39;, EcoResReleasedProductV2Staging.PRODUCTNUMBER,0) = 0 THEN EcoResReleasedProductV2Staging.PRODUCTNUMBER ELSE SUBSTRING(EcoResReleasedProductV2Staging.PRODUCTNUMBER, 0, LOCATE(&#39;-&#39;, EcoResReleasedProductV2Staging.PRODUCTNUMBER,0)) END AS parent_sku,\n\tEcoResProductV2Staging.PRODUCTDESCRIPTION AS product_description,\n\tEcoResReleasedProductV2Staging.PRODUCTTYPE AS product_type,\n\tCBAllEnumsForExportStaging.enumitemlabel AS product_type_description,\n\tEcoResReleasedProductV2Staging.PRODUCTSUBTYPE AS product_sub_type,\n\t&#39;NOT MAPPED&#39; AS product_sub_type_description,\n\tEcoResReleasedProductV2Staging.GROSSPRODUCTHEIGHT AS product_height,\n\tEcoResReleasedProductV2Staging.GROSSPRODUCTWIdTH AS product_width,\n\tEcoResReleasedProductV2Staging.GROSSDEPTH AS product_depth,\n\tROUND((EcoResReleasedProductV2Staging.GROSSPRODUCTHEIGHT / 12) * (EcoResReleasedProductV2Staging.GROSSPRODUCTWIdTH / 12) * (EcoResReleasedProductV2Staging.GROSSDEPTH / 12), 2) AS product_volume,\n\tEcoResReleasedProductV2Staging.NETPRODUCTWEIGHT AS product_weight,\n\tEcoResReleasedProductV2Staging.unitcost AS unit_cost,\n\tEcoResReleasedProductV2Staging.unitcostdate AS unit_cost_date,\n\tEcoResReleasedProductV2Staging.unitcostquantity AS unit_cost_quantity,\n\tEcoResReleasedProductV2Staging.productlifecyclestateid AS product_state,\n\tEcoResReleasedProductV2Staging.PURCHASEUNITSYMBOL AS purchase_unit_id,\n\tEcoResReleasedProductV2Staging.INVENTORYUNITSYMBOL AS inventory_unit_id,\n\tEcoResReleasedProductV2Staging.SALESUNITSYMBOL AS sales_unit_id,\n\tEcoResReleasedProductV2Staging.DataAreaId AS legal_entity_id,\n\t&#39;1&#39; AS current_flag,\n\t&#39;0&#39; AS deleted_flag,\n\t&#39;1900-01-01 00:00:00&#39; AS effective_from_date,\n\t&#39;2099-12-31 00:00:00&#39; AS effective_to_date,\n\t&#39;GETDATE()&#39; AS inserted_date,\n\t&#39;GETDATE()&#39; AS update_date,\n\t&#39;sysuser&#39; AS user_id,\n\tEcoResReleasedProductV2Staging.dl_rowhash AS dl_rowhash,\n\tIFNULL(EcoResReleasedProductV2Staging.dl_iscurrent, True) AS dl_iscurrent,\n\tEcoResReleasedProductV2Staging.dl_recordstartdateutc AS dl_recordstartdateutc,\n\tEcoResReleasedProductV2Staging.dl_recordenddateutc AS dl_recordenddateutc,\n\tEcoResReleasedProductV2Staging.dl_sourcefilename AS dl_sourcefilename\nFROM classicbrandssilver.EcoResReleasedProductV2Staging AS EcoResReleasedProductV2Staging\nLEFT JOIN classicbrandssilver.EcoResProductV2Staging AS EcoResProductV2Staging\n\tON EcoResReleasedProductV2Staging.PRODUCTNUMBER = EcoResProductV2Staging.PRODUCTNUMBER\n\tAND EcoResProductV2Staging.DL_IsCurrent = True \nLEFT JOIN classicbrandssilver.CBAllEnumsForExportStaging AS CBAllEnumsForExportStaging\n\tON EcoResReleasedProductV2Staging.PRODUCTTYPE = CBAllEnumsForExportStaging.enumitemvalue AND CBAllEnumsForExportStaging.ENUMNAME = &#39;EcoResProductType&#39;\n\tAND CBAllEnumsForExportStaging.DL_IsCurrent = True \nWHERE EcoResProductV2Staging.PRODUCTNAME IS NOT NULL\n\nTesting query...\n\nQuery tested successfully...\n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[{"name":"df","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"product_key","nullable":true,"type":"integer"},{"metadata":{},"name":"product_id","nullable":true,"type":"string"},{"metadata":{},"name":"product_name","nullable":true,"type":"string"},{"metadata":{},"name":"item_id","nullable":true,"type":"string"},{"metadata":{},"name":"parent_sku","nullable":true,"type":"string"},{"metadata":{},"name":"product_description","nullable":true,"type":"string"},{"metadata":{},"name":"product_type","nullable":true,"type":"integer"},{"metadata":{},"name":"product_type_description","nullable":true,"type":"string"},{"metadata":{},"name":"product_sub_type","nullable":true,"type":"integer"},{"metadata":{},"name":"product_sub_type_description","nullable":false,"type":"string"},{"metadata":{},"name":"product_height","nullable":true,"type":"decimal(32,6)"},{"metadata":{},"name":"product_width","nullable":true,"type":"decimal(32,6)"},{"metadata":{},"name":"product_depth","nullable":true,"type":"decimal(32,6)"},{"metadata":{},"name":"product_volume","nullable":true,"type":"decimal(38,2)"},{"metadata":{},"name":"product_weight","nullable":true,"type":"decimal(32,12)"},{"metadata":{},"name":"unit_cost","nullable":true,"type":"decimal(32,6)"},{"metadata":{},"name":"unit_cost_date","nullable":true,"type":"timestamp"},{"metadata":{},"name":"unit_cost_quantity","nullable":true,"type":"decimal(32,12)"},{"metadata":{},"name":"product_state","nullable":true,"type":"string"},{"metadata":{},"name":"purchase_unit_id","nullable":true,"type":"string"},{"metadata":{},"name":"inventory_unit_id","nullable":true,"type":"string"},{"metadata":{},"name":"sales_unit_id","nullable":true,"type":"string"},{"metadata":{},"name":"legal_entity_id","nullable":true,"type":"string"},{"metadata":{},"name":"current_flag","nullable":false,"type":"string"},{"metadata":{},"name":"deleted_flag","nullable":false,"type":"string"},{"metadata":{},"name":"effective_from_date","nullable":false,"type":"string"},{"metadata":{},"name":"effective_to_date","nullable":false,"type":"string"},{"metadata":{},"name":"inserted_date","nullable":false,"type":"string"},{"metadata":{},"name":"update_date","nullable":false,"type":"string"},{"metadata":{},"name":"user_id","nullable":false,"type":"string"},{"metadata":{},"name":"dl_rowhash","nullable":true,"type":"string"},{"metadata":{},"name":"dl_iscurrent","nullable":false,"type":"boolean"},{"metadata":{},"name":"dl_recordstartdateutc","nullable":true,"type":"string"},{"metadata":{},"name":"dl_recordenddateutc","nullable":true,"type":"timestamp"},{"metadata":{},"name":"dl_sourcefilename","nullable":true,"type":"string"}],"type":"struct"},"tableIdentifier":null}],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763419891,"submitTime":1623763403153,"finishTime":1623763421162,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"097e1538-62c6-454f-a859-e1871cca58a5"},{"version":"CommandV1","origId":3919740296815040,"guid":"c3b0111a-8d8e-447e-8f19-b166bace8572","subtype":"command","commandType":"auto","position":23.0,"command":"%md\n### Perform Code Mapping on Transformed data (not yet written out)","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"12473d87-4542-4251-afac-17c81c39f5d8"},{"version":"CommandV1","origId":3919740296815041,"guid":"fe785b1e-b975-4ec5-83e7-69d88caac574","subtype":"command","commandType":"auto","position":24.0,"command":"# If this table has Code Mappings, do it here.\nif codemap_table and not adhoc_mode:\n    # Get a list of columns from the Transformed dataframe that will be written out\n    df_cols = df.columns\n    \n    # Find the position of the first \"dl_\" column so we can insert generated columns here\n    try:\n        df_insert_index = df_cols.index(\"dl_rowhash\")\n    except:\n        df_insert_index = len(df_cols)\n    \n    # Get a list of code mapped columns\n    cm_cols = spark.sql(f\"select distinct targetattribute from {config_table_view} where codemapped = True\").collect()\n    \n    join_list = []\n    cm_col_list = []\n\n    for cm in cm_cols:\n        #Grab the column name being mapped\n        c = cm[\"targetattribute\"]\n        \n        # Generate new columns to be added to output\n        df_cols.insert(df_insert_index,   f\"IF({c}__PC IS NULL,  IF({c}__RAW IS NULL, NULL, '{unmapped_string}'), {c}__PC)  as {c}__PC\"),\n        df_cols.insert(df_insert_index+1, f\"IF({c}__AC IS NULL,  IF({c}__RAW IS NULL, NULL, '{unmapped_string}'), {c}__AC)  as {c}__AC\"),\n        df_cols.insert(df_insert_index+2, f\"IF({c}__ENT IS NULL, IF({c}__RAW IS NULL, NULL, '{unmapped_string}'), {c}__ENT) as {c}__ENT\"),\n\n        # Create a table alias for this query\n        c_alias = f\"t{c}\"\n        \n        # Generate the JOIN to be used with the transformed data\n        # Each JOIN is to the Code Map table, for each code mapped column\n        # Each of these additional columns are added to the final output\n        query = f\"\"\"\n          LEFT JOIN (\n            select DISTINCT\n                RawValue\n              , PortCoDescription AS {c}__PC\n              , AssetClassDescription AS {c}__AC\n              , EnterpriseDescription AS {c}__ENT\n            FROM vwJsonCodeMap cm\n            WHERE cm.TargetColumnName = '{c}'\n          ) {c_alias} ON LOWER(TRIM({c}__RAW)) = LOWER(TRIM({c_alias}.RawValue))\"\"\"\n        join_list.append(query)\n        df_insert_index += 3\n\n    for cm in cm_cols:\n        #Grab the column name being mapped\n        c = cm[\"targetattribute\"]\n        for idx, elem in enumerate(df_cols):\n            if elem == c:\n                df_cols[idx] = f\"{c}__RAW\"\n        df = df.withColumnRenamed(c, f\"{c}__RAW\")       \n        \n    # Replace the view since it has new column names now\n    df.createOrReplaceTempView(\"vwTransformedData\")\n    \n    # Make strings from lists\n    joins_str = ''.join(join_list)\n    col_str = ', '.join(df_cols)\n\n    # Prepare final query, with all of the columns (including newly generated ones)\n    # and JOINs for each codemapped column\n    final_query = f\"\"\"\n          SELECT {col_str}\n          FROM vwTransformedData AS target {joins_str}\n    \"\"\"\n    # Print the output so it will be in the executed notebook for debugging\n    print(final_query)\n    \n    # Execute the query, storing to df_out Dataframe\n    df_out = spark.sql(final_query)\n\n    for cm in cm_cols:\n        #Grab the column name being mapped\n        c = cm[\"targetattribute\"]\n        df_out = df_out.withColumnRenamed(c, f\"{c}__RAW\")\n        \nelse:  \n    #No Code Mappings = create Dataframe from original Transformations\n    df_out = df\n\n# Make sure to update the row hash\ndf_out = df_out.withColumn(\"dl_rowhash\", sha2(concat_ws(\"||\", *df_out.columns), 256))","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[{"name":"df_out","typeStr":"pyspark.sql.dataframe.DataFrame","schema":{"fields":[{"metadata":{},"name":"product_key","nullable":true,"type":"integer"},{"metadata":{},"name":"product_id","nullable":true,"type":"string"},{"metadata":{},"name":"product_name","nullable":true,"type":"string"},{"metadata":{},"name":"item_id","nullable":true,"type":"string"},{"metadata":{},"name":"parent_sku","nullable":true,"type":"string"},{"metadata":{},"name":"product_description","nullable":true,"type":"string"},{"metadata":{},"name":"product_type","nullable":true,"type":"integer"},{"metadata":{},"name":"product_type_description","nullable":true,"type":"string"},{"metadata":{},"name":"product_sub_type","nullable":true,"type":"integer"},{"metadata":{},"name":"product_sub_type_description","nullable":false,"type":"string"},{"metadata":{},"name":"product_height","nullable":true,"type":"decimal(32,6)"},{"metadata":{},"name":"product_width","nullable":true,"type":"decimal(32,6)"},{"metadata":{},"name":"product_depth","nullable":true,"type":"decimal(32,6)"},{"metadata":{},"name":"product_volume","nullable":true,"type":"decimal(38,2)"},{"metadata":{},"name":"product_weight","nullable":true,"type":"decimal(32,12)"},{"metadata":{},"name":"unit_cost","nullable":true,"type":"decimal(32,6)"},{"metadata":{},"name":"unit_cost_date","nullable":true,"type":"timestamp"},{"metadata":{},"name":"unit_cost_quantity","nullable":true,"type":"decimal(32,12)"},{"metadata":{},"name":"product_state","nullable":true,"type":"string"},{"metadata":{},"name":"purchase_unit_id","nullable":true,"type":"string"},{"metadata":{},"name":"inventory_unit_id","nullable":true,"type":"string"},{"metadata":{},"name":"sales_unit_id","nullable":true,"type":"string"},{"metadata":{},"name":"legal_entity_id","nullable":true,"type":"string"},{"metadata":{},"name":"current_flag","nullable":false,"type":"string"},{"metadata":{},"name":"deleted_flag","nullable":false,"type":"string"},{"metadata":{},"name":"effective_from_date","nullable":false,"type":"string"},{"metadata":{},"name":"effective_to_date","nullable":false,"type":"string"},{"metadata":{},"name":"inserted_date","nullable":false,"type":"string"},{"metadata":{},"name":"update_date","nullable":false,"type":"string"},{"metadata":{},"name":"user_id","nullable":false,"type":"string"},{"metadata":{},"name":"dl_rowhash","nullable":true,"type":"string"},{"metadata":{},"name":"dl_iscurrent","nullable":false,"type":"boolean"},{"metadata":{},"name":"dl_recordstartdateutc","nullable":true,"type":"string"},{"metadata":{},"name":"dl_recordenddateutc","nullable":true,"type":"timestamp"},{"metadata":{},"name":"dl_sourcefilename","nullable":true,"type":"string"}],"type":"struct"},"tableIdentifier":null}],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763421169,"submitTime":1623763403172,"finishTime":1623763421338,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"e744b9ca-4184-4fb1-80e6-0daad79b2ce6"},{"version":"CommandV1","origId":3919740296815042,"guid":"7725cf48-ffb6-4f2d-887e-4b97371c879d","subtype":"command","commandType":"auto","position":25.0,"command":"%md\n### Set Columns with NULL datatypes to Strings","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"d1b6b8f2-19bd-42f8-97f6-9afc6c0e1333"},{"version":"CommandV1","origId":3919740296815043,"guid":"e95738b6-92a3-4466-ac68-710da673eef0","subtype":"command","commandType":"auto","position":26.0,"command":"# In the event there are no values in column (typically a placeholder), set datatype to string\n# Otherwise the datatype is \"null\", which causes problems downstream\n# Also, ensure the code mapped columns are all strings\nfor c, dt in df_out.dtypes:\n    if dt == 'null' or (dt != 'string' and (c.endswith(\"__RAW\") or c.endswith(\"__PC\") or c.endswith(\"__AC\") or c.endswith(\"__ENT\"))):\n        df_out = df_out.withColumn(c, df_out[c].cast(StringType()))\n\ndf_out.dtypes","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">Out[84]: [(&#39;product_key&#39;, &#39;int&#39;),\n (&#39;product_id&#39;, &#39;string&#39;),\n (&#39;product_name&#39;, &#39;string&#39;),\n (&#39;item_id&#39;, &#39;string&#39;),\n (&#39;parent_sku&#39;, &#39;string&#39;),\n (&#39;product_description&#39;, &#39;string&#39;),\n (&#39;product_type&#39;, &#39;int&#39;),\n (&#39;product_type_description&#39;, &#39;string&#39;),\n (&#39;product_sub_type&#39;, &#39;int&#39;),\n (&#39;product_sub_type_description&#39;, &#39;string&#39;),\n (&#39;product_height&#39;, &#39;decimal(32,6)&#39;),\n (&#39;product_width&#39;, &#39;decimal(32,6)&#39;),\n (&#39;product_depth&#39;, &#39;decimal(32,6)&#39;),\n (&#39;product_volume&#39;, &#39;decimal(38,2)&#39;),\n (&#39;product_weight&#39;, &#39;decimal(32,12)&#39;),\n (&#39;unit_cost&#39;, &#39;decimal(32,6)&#39;),\n (&#39;unit_cost_date&#39;, &#39;timestamp&#39;),\n (&#39;unit_cost_quantity&#39;, &#39;decimal(32,12)&#39;),\n (&#39;product_state&#39;, &#39;string&#39;),\n (&#39;purchase_unit_id&#39;, &#39;string&#39;),\n (&#39;inventory_unit_id&#39;, &#39;string&#39;),\n (&#39;sales_unit_id&#39;, &#39;string&#39;),\n (&#39;legal_entity_id&#39;, &#39;string&#39;),\n (&#39;current_flag&#39;, &#39;string&#39;),\n (&#39;deleted_flag&#39;, &#39;string&#39;),\n (&#39;effective_from_date&#39;, &#39;string&#39;),\n (&#39;effective_to_date&#39;, &#39;string&#39;),\n (&#39;inserted_date&#39;, &#39;string&#39;),\n (&#39;update_date&#39;, &#39;string&#39;),\n (&#39;user_id&#39;, &#39;string&#39;),\n (&#39;dl_rowhash&#39;, &#39;string&#39;),\n (&#39;dl_iscurrent&#39;, &#39;boolean&#39;),\n (&#39;dl_recordstartdateutc&#39;, &#39;string&#39;),\n (&#39;dl_recordenddateutc&#39;, &#39;timestamp&#39;),\n (&#39;dl_sourcefilename&#39;, &#39;string&#39;)]</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763421346,"submitTime":1623763403189,"finishTime":1623763421367,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"0ca1615d-3eb2-429f-9adf-99fc356cae26"},{"version":"CommandV1","origId":3919740296815044,"guid":"f52e1131-2256-4d16-b423-9cd036b29407","subtype":"command","commandType":"auto","position":27.0,"command":"%md ### Create Database If Necessary","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"86b603fe-ad43-4e09-9ab6-4b20a96f007e"},{"version":"CommandV1","origId":3919740296815045,"guid":"81ce5341-dbce-4966-ab25-e19bfe35d9eb","subtype":"command","commandType":"auto","position":28.0,"command":"# If we actually want to execute the query...)\nif execute_query and not adhoc_mode:\n    db_exists = check_if_db_exists(target_schema)\n\n    if not db_exists:\n\n        print('Creating database {}'.format(target_schema))\n\n        query = \"\"\"\n            CREATE DATABASE IF NOT EXISTS {dbname}\n            LOCATION '/mnt/{deltalocation}/{dbname}'\n        \"\"\".format(dbname=target_schema, deltalocation=delta_location)\n\n        print(query)\n        spark.sql(query)   ","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">Creating database empower_stage\n\n            CREATE DATABASE IF NOT EXISTS empower_stage\n            LOCATION &#39;/mnt/DELTA/empower_stage&#39;\n        \n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763421373,"submitTime":1623763403208,"finishTime":1623763421706,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"dd7105da-e7cb-4c75-acd8-14c17e42cd9d"},{"version":"CommandV1","origId":3919740296815046,"guid":"5c97bc19-0e4c-47fd-978a-2c1b9f1b1420","subtype":"command","commandType":"auto","position":29.0,"command":"%md \n### Create (or Replace) Target table\nThis output includes code mappings, as applicable.","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"3a76da72-a5bb-4063-b70c-f5a6094b5f76"},{"version":"CommandV1","origId":3919740296815047,"guid":"cc4d5d83-1c29-4f9b-b11e-cd216ea9ec78","subtype":"command","commandType":"auto","position":30.0,"command":"# If we actually want to execute the query...)\nif execute_query and not adhoc_mode:\n    # Using this method (over Spark SQL) lets us use a single command to create or \n    # replace the table, which allows for schema changes.\n    # This also creates tables as MANAGED, instead of UNMANAGED \n    # so we can drop table (if needed) without needing to do file system cleanup\n    df_out.write \\\n        .format(\"delta\") \\\n        .mode(\"overwrite\") \\\n        .option(\"overwriteSchema\", \"true\") \\\n        .saveAsTable(f\"{target_schema}.{target_object}\")\n","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763421713,"submitTime":1623763403225,"finishTime":1623763432872,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"fd983d90-461b-41c0-9708-3aac0f97976f"},{"version":"CommandV1","origId":3919740296815048,"guid":"f8f4eb1b-fe6c-473d-826a-228f7d7e10e2","subtype":"command","commandType":"auto","position":31.0,"command":"%md\n### Execute Custom Transformation Notebook","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"4936c41e-9e67-4de7-85fc-964747435a90"},{"version":"CommandV1","origId":3919740296815049,"guid":"9449b710-8b44-4a4d-961e-efa5e7acc55d","subtype":"command","commandType":"auto","position":32.0,"command":"if custom_cnt > 0:\n    # Get the notebook and params\n    custom_xf = dfa_dict['Transformation'][0]\n    custom_dict = eval(custom_xf)\n    \n    nb = custom_dict['notebook']\n    args_dict = custom_dict['params'][0]  #.format(operator=operator, targetschema=target_schema, targetobject=target_object)\n    \n    for key in args_dict.keys():\n        args_dict[key] = args_dict[key].format(operator=operator, targetschema=target_schema, targetobject=target_object)\n\n    timeout = 600\n\n    ret = run_notebook_with_retry(nb, args_dict, timeout, retries = 0)\n    print(f\"Notebook output: {ret}\")\n    dbutils.notebook.exit(ret)\n","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763432880,"submitTime":1623763403242,"finishTime":1623763432899,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"bae9071a-0d35-4725-8b85-22814064f913"},{"version":"CommandV1","origId":3919740296815050,"guid":"a8d7a408-9057-4a2a-9548-7e335a314536","subtype":"command","commandType":"auto","position":33.0,"command":"%md\n### Extract Unmapped Values for Code Mapping\nHere we need to find all the code values that don't have a mapping in ColumnCodeMap.  \n\nTo do this we're looking in the final dataframe for any code-mapped columns, with raw values, but no ____PC__ description.","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"1351f56b-11ac-444f-82b5-b78ef749f336"},{"version":"CommandV1","origId":3919740296815051,"guid":"bab2e5ef-da3f-4ba5-8d00-6789e5d78bf5","subtype":"command","commandType":"auto","position":34.0,"command":"outFile = \"\"\n\n# If this table has Code Mappings, do it here.\nif codemap_table and not adhoc_mode:\n    # Get a list of code-mapped columns \n    cm_cols = spark.sql(f\"select distinct targetattribute from {config_table_view} where codemapped = True\").collect()\n    \n    # It's possible there are code mappings, yet no transformations exist marked as codemapped\n    if cm_cols:\n        # Create a view to use below\n        df_out.createOrReplaceTempView(\"vwFinalOutput\")\n\n        qry_list = []\n\n        # Iterate through the list of code-mapped columns.\n        for cm in cm_cols:\n            c = cm[\"targetattribute\"]\n\n            query = f\"SELECT DISTINCT '{c}' AS TargetAttribute, {c}__RAW AS RawValue FROM vwFinalOutput v WHERE {c}__RAW IS NOT NULL AND {c}__PC = '{unmapped_string}'\"\n\n            if qry_list:\n                qry_list.append(\"UNION\")\n            qry_list.append(query)\n\n        final_query = '\\n'.join(qry_list)\n\n        # Print the output so it will be in the executed notebook for debugging\n        #print(final_query)\n\n        # Execute the query, storing to df_out Dataframe\n        df_unmapped = spark.sql(final_query)\n        \n        try:\n            if df_unmapped.count() > 0:\n                stage_location = \"STAGE\"\n                saveLocationParts = [\"dbfs\", \"mnt\", stage_location, \"unmapped_codes\", target_schema]\n                #saveLocationParts = [\"dbfs\", \"mnt\", stage_location, \"CodeMap\"]\n                saveLocation = slash_join(saveLocationParts, True) \n                \n                # Create folders if they don't exist\n                if not os.path.exists(saveLocation):\n                    os.makedirs(saveLocation)\n                outFile = f\"{saveLocation}/{target_object}.csv\"\n                \n                # Write out file with unmapped codes\n                df_unmapped.toPandas().to_csv(outFile, index=False, quotechar='\"')\n                \n                # Clean up name for output\n                outFile = outFile.replace(\"/dbfs/mnt/\", \"\")\n            else:\n                print(\"INFO: There are no unmapped records for output!\")\n        except:\n            print(\"INFO: There are no unmapped records for output!\")\n     # end if cm_cols\n#end if codemap_table and not adhoc_mode\nprint(outFile)","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\">\n</div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763432905,"submitTime":1623763403259,"finishTime":1623763432927,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"8c9527e9-4be3-4a28-96e5-43569538983e"},{"version":"CommandV1","origId":3919740296815052,"guid":"e7735454-07de-4d79-b3d6-fb80dbd993be","subtype":"command","commandType":"auto","position":35.0,"command":"%md\n### Return Output\nIf this notebook is being run ad-hoc (e.g. from another notebook for dev/testing), only return the transformation query,\n\notherwise return the table name, query and unmapped codes back to pipeline.","commandVersion":1,"state":"finished","results":null,"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"a2d36a0c-d53d-4f8c-bc2e-d1ee4b9023e8"},{"version":"CommandV1","origId":3919740296815053,"guid":"1a5a7826-5261-4861-bacc-76e408691b18","subtype":"command","commandType":"auto","position":36.0,"command":"# If this is being run ad-hoc, e.g. from another notebook for dev/testing, \n# only return the transformation query\nif adhoc_mode:\n    # Only return the SQL\n    output = sql_out\nelse:\n    output = f\"\"\"{{\"StageTableName\":\"{target_schema}.{target_object}\", \"UnmappedCodes\":\"{outFile}\"}}\"\"\"\n\n    # Remove CR, LF, Tabs and single quotes from output (primarily for sql query)\n    output = output.replace('\\r','').replace('\\n',' ').replace('\\t','  ').replace(\"'\", \"\")\n","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763432933,"submitTime":1623763403278,"finishTime":1623763432950,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"637b0535-5b80-4476-bb70-7cbbd2ed5184"},{"version":"CommandV1","origId":3919740296815054,"guid":"28f755fd-4d9d-49e1-8bd7-40129cb32452","subtype":"command","commandType":"auto","position":37.0,"command":"# Exit the notebook, returning the output\ndbutils.notebook.exit(output)","commandVersion":1,"state":"finished","results":{"type":"exit","data":"{\"StageTableName\":\"empower_stage.tmp_dim_dim_product\", \"UnmappedCodes\":\"\"}","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763432956,"submitTime":1623763403282,"finishTime":1623763432981,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"2cdbc20e-cf42-447d-b795-0d4412cea850"},{"version":"CommandV1","origId":4450725549120724,"guid":"7b4c3ff4-f9d1-4cdf-b372-0d1e19e29bde","subtype":"script","commandType":"auto","position":4.033333333333333,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403698,"submitTime":0,"finishTime":1623763403721,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"d62311a7-be3c-498c-b12e-ca94329db284"},{"version":"CommandV1","origId":4450725549120725,"guid":"8c29e431-368b-453d-ac46-d107b1ceb983","subtype":"script","commandType":"auto","position":4.066666666666666,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403727,"submitTime":0,"finishTime":1623763403746,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"6a9eb0d7-50a9-44e8-90e8-59a7369c43bf"},{"version":"CommandV1","origId":4450725549120726,"guid":"8bcc967d-7533-4864-b88e-7ba94c2457a9","subtype":"script","commandType":"auto","position":4.1,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403751,"submitTime":0,"finishTime":1623763403771,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"98848bd5-ca5c-4049-9c09-249a58ffd562"},{"version":"CommandV1","origId":4450725549120727,"guid":"a4a371ec-d90f-4844-aac1-322e42e2ee7f","subtype":"script","commandType":"auto","position":4.133333333333334,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403776,"submitTime":0,"finishTime":1623763403795,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"16b69105-4b11-4b61-b3da-aa8772c529c7"},{"version":"CommandV1","origId":4450725549120728,"guid":"25ee4c43-7b30-468d-ae06-79169037adb5","subtype":"script","commandType":"auto","position":4.166666666666667,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403802,"submitTime":0,"finishTime":1623763403821,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b26ae44c-4b25-45c1-81f2-d7545c4eec8a"},{"version":"CommandV1","origId":4450725549120729,"guid":"ea9ff2c2-f2e1-47b2-b2c1-6c3b871c3510","subtype":"script","commandType":"auto","position":4.2,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403827,"submitTime":0,"finishTime":1623763403845,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"cce1a3d1-b0dc-4512-811f-294e7aa2af0b"},{"version":"CommandV1","origId":4450725549120730,"guid":"366d02d8-2ffb-4273-9163-de476cbc4da3","subtype":"script","commandType":"auto","position":4.233333333333333,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403851,"submitTime":0,"finishTime":1623763403874,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"abdc8deb-2f27-4cd3-9e0b-e69ef54a874c"},{"version":"CommandV1","origId":4450725549120731,"guid":"b865a0cb-7351-4244-bb3e-5ddf85b64ce9","subtype":"script","commandType":"auto","position":4.266666666666667,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403880,"submitTime":0,"finishTime":1623763403898,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"7f528320-e891-4403-9e60-bb5b532b7384"},{"version":"CommandV1","origId":4450725549120732,"guid":"e1568b6f-3cc2-494d-af91-7d882a3a5212","subtype":"script","commandType":"auto","position":4.3,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403905,"submitTime":0,"finishTime":1623763403922,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"6c5783ec-7193-497c-ae48-8f359dd15d79"},{"version":"CommandV1","origId":4450725549120733,"guid":"d5614e01-a4c1-43f1-a57c-a4218ceb6e0d","subtype":"script","commandType":"auto","position":4.333333333333333,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403927,"submitTime":0,"finishTime":1623763403944,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b6ecd665-7a6f-4c6b-bb5d-2e7cafaa1ece"},{"version":"CommandV1","origId":4450725549120734,"guid":"98ac57ee-b860-4c1d-8903-9504d8d5d53d","subtype":"script","commandType":"auto","position":4.366666666666666,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403949,"submitTime":0,"finishTime":1623763403966,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b4d11207-d953-4fea-80bd-48307d1f101e"},{"version":"CommandV1","origId":4450725549120735,"guid":"9e10f7eb-1d2c-4fdf-b674-c14c6de530e4","subtype":"script","commandType":"auto","position":4.4,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403971,"submitTime":0,"finishTime":1623763403987,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b7b1e43b-7474-4cf0-ae05-b94893f23300"},{"version":"CommandV1","origId":4450725549120736,"guid":"96339175-f8aa-44a3-a40b-cebc0a87689a","subtype":"script","commandType":"auto","position":4.433333333333334,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763403993,"submitTime":0,"finishTime":1623763404017,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"67be1ec5-042a-4820-91b5-546c62afa16b"},{"version":"CommandV1","origId":4450725549120737,"guid":"c29b27ed-55a9-4a6b-acd3-8041f913092c","subtype":"script","commandType":"auto","position":4.466666666666667,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404023,"submitTime":0,"finishTime":1623763404040,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"c9ba476d-bc46-4cb5-8273-442ad0c13aa1"},{"version":"CommandV1","origId":4450725549120738,"guid":"b983495f-881a-496e-8fe7-29b0d9a50e3d","subtype":"script","commandType":"auto","position":4.5,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404046,"submitTime":0,"finishTime":1623763404063,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"61923e5c-f069-4991-bce1-d1998f03ca50"},{"version":"CommandV1","origId":4450725549120739,"guid":"7b5ae54b-0e61-48bc-84c6-5b2c0417855d","subtype":"script","commandType":"auto","position":4.533333333333333,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404068,"submitTime":0,"finishTime":1623763404088,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"6a2386a8-3585-4f5b-8d1a-6a221008a3a8"},{"version":"CommandV1","origId":4450725549120740,"guid":"7e8906ad-41d0-4c8f-a761-5fc7d20e0dd8","subtype":"script","commandType":"auto","position":4.566666666666666,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404095,"submitTime":0,"finishTime":1623763404114,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"2034a836-ca3b-4e74-9c99-9c5406fae914"},{"version":"CommandV1","origId":4450725549120741,"guid":"426ab0b8-8aad-4556-85a5-621d500b3395","subtype":"script","commandType":"auto","position":4.6,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404120,"submitTime":0,"finishTime":1623763404137,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"fa7038b8-eeae-4faf-b67c-3533f592c4be"},{"version":"CommandV1","origId":4450725549120742,"guid":"a716d426-2dcc-41b8-ac39-accc0eabd014","subtype":"script","commandType":"auto","position":4.633333333333333,"command":"","commandVersion":9,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404143,"submitTime":0,"finishTime":1623763404165,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"f7e130f3-a10c-4be5-b766-bf22f0eaa005"},{"version":"CommandV1","origId":4450725549120743,"guid":"b3f4c230-1675-4b39-85cc-6eb6228a92b7","subtype":"script","commandType":"auto","position":4.666666666666667,"command":"","commandVersion":19,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404171,"submitTime":0,"finishTime":1623763404187,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"cd3b7f3c-4cff-4081-8f26-8fee0f0b4dd6"},{"version":"CommandV1","origId":4450725549120744,"guid":"d11067c5-fc7f-4c83-9f11-9deda7423320","subtype":"script","commandType":"auto","position":4.7,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404193,"submitTime":0,"finishTime":1623763404213,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"4a226d2a-a3e4-4c6d-98fa-85f8ba9827c9"},{"version":"CommandV1","origId":4450725549120745,"guid":"7a6affe5-64de-471d-9ee4-4d538c2d3ba2","subtype":"script","commandType":"auto","position":4.733333333333333,"command":"","commandVersion":5,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404219,"submitTime":0,"finishTime":1623763404239,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"e1c71d16-34f1-47f0-bf92-ee4ac052e889"},{"version":"CommandV1","origId":4450725549120746,"guid":"e9207c55-cff2-4e1b-80ef-b055ece078c2","subtype":"script","commandType":"auto","position":4.766666666666667,"command":"","commandVersion":4,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404244,"submitTime":0,"finishTime":1623763404267,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"0b9ccd37-947a-47e6-ae42-d1e165f3c085"},{"version":"CommandV1","origId":4450725549120747,"guid":"07d3d11d-278e-4a7e-9fa2-e566a191c9fc","subtype":"script","commandType":"auto","position":4.8,"command":"","commandVersion":11,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404273,"submitTime":0,"finishTime":1623763404293,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"b0e73abd-c26a-4354-ba36-0b5f8d95caee"},{"version":"CommandV1","origId":4450725549120748,"guid":"95be28e2-5e7c-4359-99ff-2463913fad7c","subtype":"script","commandType":"auto","position":4.833333333333333,"command":"","commandVersion":4,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404299,"submitTime":0,"finishTime":1623763404318,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"9e4e7bf9-f126-472c-9fbc-f4e8613533fb"},{"version":"CommandV1","origId":4450725549120749,"guid":"3e9fa4de-9b83-4da8-b7c7-c9d780c97ffd","subtype":"script","commandType":"auto","position":4.866666666666667,"command":"","commandVersion":42,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404324,"submitTime":0,"finishTime":1623763404352,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"2ebbc8ec-3d9a-4199-8649-df651f2387b6"},{"version":"CommandV1","origId":4450725549120750,"guid":"98d3928d-c56a-43ae-a887-a4e5229897e5","subtype":"script","commandType":"auto","position":4.9,"command":"","commandVersion":3,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404359,"submitTime":0,"finishTime":1623763404384,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":null,"yColumns":null,"pivotColumns":null,"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"966dd1bf-77f9-4969-87ce-57a3dc32afb7"},{"version":"CommandV1","origId":4450725549120751,"guid":"acaa4a06-5e04-47e9-9b6d-c4cedaa6cbaf","subtype":"script","commandType":"auto","position":4.933333333333334,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404395,"submitTime":0,"finishTime":1623763404430,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"5da50073-429f-401d-b40f-6379eeead438"},{"version":"CommandV1","origId":4450725549120752,"guid":"d17289cb-e535-4d74-a5a8-586ecfdb9db0","subtype":"script","commandType":"auto","position":4.966666666666667,"command":"","commandVersion":1,"state":"finished","results":{"type":"listResults","data":[{"type":"html","data":"<div class=\"ansiout\"></div>","arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}}],"arguments":{},"addedWidgets":{},"removedWidgets":[],"datasetInfos":[],"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":1623763404438,"submitTime":0,"finishTime":1623763404460,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":["4d3db74e-43c0-4cc4-aca9-45edba1a0935"],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"7a379d31-5ff4-4887-8d39-12f09f6645d0"}],"dashboards":[],"guid":"3f63fe33-e47b-4568-84d9-dc5f9b2ddab4","globalVars":{},"iPythonMetadata":null,"inputWidgets":{"TargetObject":{"nuid":"a76d91ab-f9a1-43d0-8fea-a312d51dbadb","currentValue":"tmp_dim_dim_product","widgetInfo":{"widgetType":"text","name":"TargetObject","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"Operator":{"nuid":"da318660-3e10-4f96-b78c-01bbe3d72646","currentValue":"TestTE","widgetInfo":{"widgetType":"text","name":"Operator","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"SourceObject":{"nuid":"21c6a6c1-65f0-49db-909c-b5dd0922e345","currentValue":"EcoResReleasedProductV2Staging","widgetInfo":{"widgetType":"text","name":"SourceObject","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"SourceSchema":{"nuid":"ebbb52ff-13f4-4cb5-8a51-d656eda5b090","currentValue":"classicbrandssilver","widgetInfo":{"widgetType":"text","name":"SourceSchema","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"CodeMapTable":{"nuid":"dc0d1368-d699-40c3-aa16-53d07e728603","currentValue":"","widgetInfo":{"widgetType":"text","name":"CodeMapTable","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"TargetSchema":{"nuid":"fe5846ff-f51c-4924-80af-417a95f44b50","currentValue":"empower_stage","widgetInfo":{"widgetType":"text","name":"TargetSchema","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}},"Adhoc Mode":{"nuid":"02e3dd9d-302c-46f3-ae66-074ecfc17244","currentValue":"FALSE","widgetInfo":{"widgetType":"dropdown","name":"Adhoc Mode","defaultValue":"FALSE","label":null,"options":{"widgetType":"dropdown","choices":["TRUE","FALSE"]}}},"Execute Query":{"nuid":"3116b80a-a10c-4b26-9ac4-4c7a7bb3a18c","currentValue":"TRUE","widgetInfo":{"widgetType":"dropdown","name":"Execute Query","defaultValue":"TRUE","label":null,"options":{"widgetType":"dropdown","choices":["TRUE","FALSE"]}}},"ConfigTable":{"nuid":"ff4e0bf5-f71b-416d-8f3b-f037f4e09430","currentValue":"/RAW/product_transformation_rule.csv","widgetInfo":{"widgetType":"text","name":"ConfigTable","defaultValue":"","label":null,"options":{"widgetType":"text","validationRegex":null}}}},"notebookMetadata":{"pythonIndentUnit":2}}