{"version":"NotebookV1","origId":2969621804244189,"name":"WriteDataToSynapse_ML","language":"python","commands":[{"version":"CommandV1","origId":2969621804244190,"guid":"e50e1cef-56bb-4d52-aeb3-ba4fdd618165","subtype":"command","commandType":"auto","position":2.0,"command":"%md\n### Purpose\nThe notebook copies table from DL to Synapse.\n\n### Parameters\nSource schema, object name, target schema & target name","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"4374cd40-e3fb-4908-8291-632b4e217dc1"},{"version":"CommandV1","origId":2969621804244191,"guid":"ea55b29f-bf29-4c30-bbf0-ea71510a89a5","subtype":"command","commandType":"auto","position":3.0,"command":"from pyspark.sql.functions import max, length, upper\nfrom pyspark.sql import functions as F\n\nimport datetime\nimport json\nimport os\nimport requests","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"ade2f977-f27e-4dd4-bd36-27bfd1fd1c68"},{"version":"CommandV1","origId":2969621804244192,"guid":"d89ae3a7-d2e1-485c-800e-cbabc67c8b0c","subtype":"command","commandType":"auto","position":4.0,"command":"%md\n### Widget Setup (parameters)","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"5e08f709-4be7-469f-b4d2-ce4cec7644a1"},{"version":"CommandV1","origId":2969621804244193,"guid":"4267e5d1-c624-4edd-ac07-b942e029caf4","subtype":"command","commandType":"auto","position":5.0,"command":"# dbutils.widgets.removeAll()","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"85c35bad-84c1-4d1d-b875-e0dbe647cd95"},{"version":"CommandV1","origId":2969621804244194,"guid":"dd4b9300-a519-49b8-9789-eb446234256f","subtype":"command","commandType":"auto","position":6.0,"command":"dbutils.widgets.text(\"MLsourceSchema\",\"\")\ndbutils.widgets.text(\"targetSchema\",\"\")\ndbutils.widgets.text(\"tempDirPath\",\"\")\n\nsource_schema = dbutils.widgets.get(\"MLsourceSchema\")\ntarget_schema = dbutils.widgets.get(\"targetSchema\")\ntemp_dir_sqldw = dbutils.widgets.get(\"tempDirPath\")\n\n\nif not target_schema:\n    target_schema = source_schema","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"f23c7b1e-d862-4fc5-9eb0-215deb73017d"},{"version":"CommandV1","origId":2969621804244195,"guid":"cf32608d-d912-494e-adc6-1a36a29b0529","subtype":"command","commandType":"auto","position":7.0,"command":"print('ML Source schema:\\t', source_schema)\nprint('Target schema:\\t', target_schema)\nprint('SqlDw temp directory:\\t', temp_dir_sqldw)\n\n\nout_msg = \"\"\n\n# Check for required parameters\nif not source_schema:\n    raise ValueError(\"Missing required parameters MLSourceSchema\")\n    dbutils.notebook.exit(-1)","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"85aaaa0b-d1fa-4e87-954f-52fbaf2c0252"},{"version":"CommandV1","origId":2969621804244196,"guid":"af4b80dd-1ced-4db8-9a63-d6676147d111","subtype":"command","commandType":"auto","position":8.0,"command":"%md\n### Load Shared Library","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"d121dbaf-098f-4e12-a548-796d8723e6ef"},{"version":"CommandV1","origId":2969621804244197,"guid":"7fef6ed8-f42f-4312-8b02-e4c3c1345923","subtype":"command","commandType":"auto","position":9.0,"command":"#%run /DataEngineering/SharedUtils","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"fd2f627e-f10d-48ed-abe3-17485f4d95aa"},{"version":"CommandV1","origId":2969621804244198,"guid":"3bee2c62-a9df-4818-8e65-10c9efd1a730","subtype":"command","commandType":"auto","position":10.0,"command":"%md\n### Check for Source Object Existence","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"05e34fe2-af7a-4ba8-999d-38bf19fd473d"},{"version":"CommandV1","origId":2969621804244199,"guid":"b0245a91-a9b5-483b-b92a-6daccd342a4b","subtype":"command","commandType":"auto","position":11.0,"command":"# Check to make sure source table actually exists before proceeding\n#tbl_exists = check_if_table_exists(source_object, db_name=source_schema)\n\n#if not tbl_exists:\n#  raise ValueError(f\"Source object {source_schema.upper()}.{source_object.upper()} does not exist!\")\n#  dbutils.notebook.exit(-1)","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"21393e37-4961-4bb0-8385-ed9e9cf2b0de"},{"version":"CommandV1","origId":2969621804244200,"guid":"8bdf2fb4-7018-4653-8eb7-7cba4740302b","subtype":"command","commandType":"auto","position":12.0,"command":"%md\n### Get Synapse credentials from KeyVault","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"ac861203-70d7-4347-9f2e-fb85acaa7486"},{"version":"CommandV1","origId":2969621804244201,"guid":"e414172e-c62f-4dda-b3ef-742ca8a38f75","subtype":"command","commandType":"auto","position":13.0,"command":"# Get/set secrets from Key Vault\nfs_access_key = \"adl-access-key\"\nfs_account_name_key = os.environ.get(\"DATALAKE_ACCOUNT\"); \nadb_secret_scope = os.environ.get(\"KEY_VAULT\");\n\nfs_accesskey = dbutils.secrets.get(scope = adb_secret_scope, key = fs_access_key) #TODO: ADD KEYS TO KEY VAULT \nfs_accountname = fs_account_name_key\n\nsaUrl = dbutils.secrets.get(scope = adb_secret_scope, key = \"sql-dw-jdbc-connection-string\")\n\ntempdir = \"abfss://maindl@\"+fs_accountname+\".dfs.core.windows.net/\"+temp_dir_sqldw\n\n\nsc._jsc.hadoopConfiguration().set(\"fs.azure.account.key.\"+fs_account_name_key+\".dfs.core.windows.net\",fs_accesskey)\n\n\nspark.conf.set(\n    \"fs.azure.account.key.\"+fs_account_name_key,fs_access_key)\n\nspark.conf.set(\n    \"spark.sql.parquet.writeLegacyFormat\", \"true\")\n\n# Check for required key values\nif not saUrl:\n    raise ValueError(\"Incomplete credentials for Synapse Analytics service!\")\n    dbutils.notebook.exit(-1)","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"8454b7d0-17c0-45bb-aca8-9aaa203d6339"},{"version":"CommandV1","origId":2969621804244202,"guid":"02b4937f-6077-4917-a3c8-fd015386347f","subtype":"command","commandType":"auto","position":14.0,"command":"configs = {\"fs.azure.account.auth.type\": \"OAuth\",\n        \"fs.azure.account.oauth.provider.type\": \"org.apache.hadoop.fs.azurebfs.oauth2.ClientCredsTokenProvider\",\n        \"fs.azure.account.oauth2.client.id\": dbutils.secrets.get(scope = adb_secret_scope, key = \"adb-app-reg-id\"),\n        \"fs.azure.account.oauth2.client.secret\": dbutils.secrets.get(scope = adb_secret_scope, key = \"adb-app-reg-secret\"),\n        \"fs.azure.account.oauth2.client.endpoint\": \"https://login.microsoftonline.com/{}/oauth2/token\".format(dbutils.secrets.get(scope = adb_secret_scope, key = \"ad-tenant-id\")),\n        \"fs.azure.createRemoteFileSystemDuringInitialization\": \"false\"}\n\ntable_options = f\"DISTRIBUTION = ROUND_ROBIN\"\n\n\ndf = spark.sql(f\"SHOW TABLES FROM {source_schema} LIKE '*model*'\") # \n#df.display()\ntablelist = df.select(\"tableName\").rdd.flatMap(lambda x: x).collect()\nfor t in tablelist:\n  print(f\"Reading {t}\")\n  query = f\"\"\"select * from {source_schema}.{t}\"\"\"\n  df2 = spark.sql(query)\n  print(query)\n  df2.write.format(\"com.databricks.spark.sqldw\")\\\n    .option(\"url\",saUrl)\\\n    .option(\"dbtable\",target_schema+\".\"+t)\\\n    .option(\"tableOptions\",table_options)\\\n    .option(\"forwardSparkAzureStorageCredentials\",\"True\")\\\n    .option(\"tempdir\", tempdir)\\\n    .option(\"mssqlIsolationLevel\",\"READ_UNCOMMITTED\")\\\n    .mode(\"overwrite\")\\\n    .save()\n  print(f\"Loaded {t} into synapse\")\n  \n    ","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"f671e516-2acb-4399-9524-c0d8fd91c795"},{"version":"CommandV1","origId":2969621804244203,"guid":"b4038dca-fddf-4684-b25c-7f1c5e57d73c","subtype":"command","commandType":"auto","position":15.0,"command":"","commandVersion":1,"state":"finished","results":{"type":"raw","data":"","arguments":{},"metadata":{}},"errorSummary":null,"errorTraceType":null,"error":null,"workflows":[],"startTime":0,"submitTime":0,"finishTime":0,"collapsed":false,"bindings":{},"inputWidgets":{},"displayType":"table","width":"auto","height":"auto","xColumns":[],"yColumns":[],"pivotColumns":[],"pivotAggregation":null,"useConsistentColors":false,"customPlotOptions":{},"commentThread":[],"commentsVisible":false,"parentHierarchy":[],"diffInserts":[],"diffDeletes":[],"globalVars":{},"latestUser":"a user","latestUserId":null,"commandTitle":"","showCommandTitle":false,"hideCommandCode":false,"hideCommandResult":false,"isLockedInExamMode":false,"iPythonMetadata":null,"streamStates":{},"datasetPreviewNameToCmdIdMap":{},"nuid":"c38d2120-cd07-4df7-99c9-e51eb4d9e517"}],"dashboards":[],"guid":"ccdb20d7-dce1-4c87-9422-8576e78393e8","globalVars":{},"iPythonMetadata":null,"inputWidgets":{},"notebookMetadata":{"pythonIndentUnit":2}}